C Subroutine GCHEM
C
C This software is part of the GLOW model.  Use is governed by the Open Source
C Academic Research License Agreement contained in the file glowlicense.txt.
C For more information see the file glow.txt.
C
C Stan Solomon, 1988, 1989, 1992, 1999, 2005
C
C Includes quartic solution to electron density equation.
C Electron density must be supplied above 200 km in array ZE, a priori
C values are expected but not strictly required at and below 200 km,
C depending on the value of KCHEM.  An initial guess of the N(2D)
C density in array ZND is also expected but not strictly required.
C Other neutral species (O, N2, O2, NO, N(4S)) must be supplied,
C see subroutine GLOW.
C
C Chemical calculations are controlled by switch KCHEM:
C 0 = no calculations at all are performed.
C 1 = electron density, O+(4S), N+, N2+, O2+, NO+ supplied at all
C     altitudes; O+(2P), O+(2D), excited neutrals, and emission rates
C     are calculated.
C 2 = electron density, O+(4S), O2+, NO+ supplied at all altitudes;
C     O+(2P), O+(2D), N+, N2+, excited neutrals, emissions calculated.
C 3 = electron density supplied at all altitudes; everything else
C     calculated.
C 4 = electron density supplied above 200 km; electron density below
C     200 km is calculated, everything else calculated at all altitudes.
C     An initial guess of the electron density below 200 km should be
C     supplied in array ZE.  Electron density for the next two levels
C     above J200 is log interpolated between E(J200) and E(J200+3).
C
C For definitions of common block /CGLOW/ see subroutine GLOW
C
C Other definitions:
C A        Einstein coefficients; s-1
C B        Branching ratios
C BZ       Altitude-dependent branching ratios
C G        Resonant scattering g-factors at each altitude; s-1
C KZ       Temperature dependent rate coeffs at each altitude; cm3s-1
C OEI      O electron impact ionization rates; cm-3s-1
C O2EI     O2   "       "        "       "      "
C RN2EI    N2   "       "        "       "      "
C O2PI     O2 photoionization rates; cm-3s-1
C RN2PI    N2       "          "      "
C RN2ED    N2 electron impact dissociation rate; cm-3s-1
C SRCED    O2     "      "         "         " (SR continuum); cm-3s-1
C P        Volume production rate for each species, altitude; cm-3s-1
C L        Loss rate for each species, altitude; s-1
C T1       Effective temperature divided by 300 for O+ + N2; K
C T2          "          "        "                 O+ + O2; K
C T3          "          "        "                 N2+ + O; K
C T4          "          "        "                 N2+ + O2; K
C T5          "          "        "                 O+ + NO; K
C QQ, RR, SS, TT, UU, VV, WW, XX:  Combined terms for calculation of
C                              O+(4S) given e
C AA, BB, CC, DD, EE, FF, GG, HH: Combined terms for solution of
C                        electron density equation, Roble & Ridley, 1988
C COEF     Coefficients of quartic electron density equation, see "
C ROOT     Roots of          "       "         "       "
C
C
C References for rate coefficients, transition coefficients, branching
C ratios, and g-factors:
C
C      k1  O+(4S) + N2             St. Maurice & Torr, 1978
C                                  (from Albritton et al., 1977)
C      k2  O+(4S) + O2             Combination of (Chen et al, 1978
C                                  and St. Maurice & Torr, 1978)
C      k3  N2+ + O -> NO+ + O      New fit to McFarland et al, 1974
C      k4  N2+ + O2                McFarland et al, 1973
C      k5  N(2D) + O2              Lin & Kaufman, 1971,
C                                  cf. Piper et al, 1987
C      k6  N(2D) + O               Fell et al., 1990
C      k7  N(2D) + e               Frederick & Rusch, 1977;
C                                  Queffelec et al, 1985
C      k8  O(1D) + N2              Streit et al, 1976
C      k9  O(1D) + O2              Streit et al, 1976
C      k10 O(1D) + e               Link, 1982
C      k11 O(1S) + O               Slanger & Black, 1981
C      k12 O+(2D) + N2             Johnsen & Biondi, 1980
C      k13 O+(2D) + O2             Johnsen & Biondi, 1980
C      k14 O+(2D) + e              Henry et al., 1969
C      k15 O+(2D) + O              Torr & Torr, 1980
C      k16 O+(2P) + N2             Rusch et al, 1977
C      k17 O+(2P) + O2             Link, 1982
C      k18 O+(2P) + e              Henry et al., 1969
C      k19 O+(2P) + O              Rusch et al, 1977
C      k20 O2(c) + O               Solheim & Llewellyn, 1979
C      k21 O2(c) + N2              Solheim & Llewellyn, 1979
C      k22 NO+ + e                 Walls & Dunn, 1974; Torr et al, 1977;
C                                  Alge et al, 1983; Dulaney et al,1987;
C                                  Davidson & Hobson, 1987
C      k23 N2+ + e                 Mehr & Biondi, 1969
C      k24 O2+ + e                 Mehr & Biondi; Walls & Dunn, 1974;
C                                  Torr et al, 1976; Alge et al, 1983
C      k25 N+ + O2                 Langford et al, 1985
C      k26 N2(A) + O               Piper et al, 1981b (av. v=1,2)
C      k27 O(1D) + O               Abreu et al, 1986; Yee, pc, 1991
C      k28 O + et                  Link, 1982
C      k29 N2(A) + O2              Piper et al, 1981a
C      k30 O2+ + NO                Lindeger & Ferguson, 1974; G&R, 1979
C      k31 N(2D) + NO              Black et al, 1969; fr. Roble, 1986
C      k32 N+ + O                  Torr, 1985 (Levine, Photochemistry)
C      k33 N(2P) + O               Zipf et al, 1980; Young & Dunn, 1975
C      k34 N(2P) + O2              Zipf et al, 1980; Rawlins, 1988
C                                  (cf Ianuzzi & Kaufman, 1980, 3.5E-12)
C      k35 N(2P) + NO              Rees & Jones, 1973, Zipf et al, 1980
C      k36 O(1S) + O2              Slanger et al, 1972; fr. Bates, 1978
C      k37 O2+ + N                 Fehsenfeld (1977)
C      k38 O+ + N(2D)              Bates, 1989 (PSS 37, 363)
C      k39 N2+ + O -> N2 + O+      Torr, 1985; Torr et al, 1988;
C                                  Knutsen et al, 1988
C      k40 O+ + NO                 St. Maurice & Torr, 1978
C      A1  5200       N(4S-2D)     Wiese et al, 1966
C      A2  6300       O(3P-1D)     Baluja and Zeippen, 1988
C      A3  6364       O(3P-1D)     Baluja and Zeippen, 1988
C      A4  2972       O(3P-1S)     Kernahan & Pang, 1975
C      A5  5577       O(1D-1S)     Kernahan & Pang, 1975
C      A6  3726       O+(4S-2D)    Kernahan & Pang, 1975
C      A7  2470       O+(4S-2P)    Weise et al, 1966
C      A8  7319-30    O+(2D-2P)    Weise et al, 1966
C      A9  (Hertz II) O2(X-c)      Solheim & Llewellyn, 1978
C      A10 (Veg-Kap)  N2(X-A)      Shemansky, 1969
C      A11 3466       N(4S-2P)     Chamberlain, 1961
C      A12 10400      N(2D-2P)     Chamberlain, 1961
C      B1  O(1S) from O2+ + e      Yee et al, 1988
C      B2  O(1D) from O2+ + e      Abreu et al, 1986
C      B3  N(2D) from NO+ + e      Kley et al, 1976
C      B4  N(2D) from N2+ + e      Queffelec et al, 1985
C      B5  N(2D) from N2+ + O      Frederick & Rusch, 1977
C      B6  O(1D) from N(2D) + O2   Link, 1983; Langford et al, 1985
C      B7  O(1D) from O+(2D) + O   ?
C      B8  O+(2D) from O+(2P) + e  Link, 1982
C      B9  O+(2P) from O + e*      Gerard & Rusch, 1979; Jones, 1975
C      B10 O+(2D) from O + e*      Gerard & Rusch, 1979; Jones, 1975
C      B11 O+(4S) from O + e*      Gerard & Rusch, 1979; Jones, 1975
C      B12 O+(2P) from O2 + e*     Link, 1982; guess of .3/3
C      B13 O+(2D) from O2 + e*     Link, 1982; guess of .3/3
C      B14 O+(4S) from O2 + e*     Link, 1982; guess of .3/3
C      B15 N+ from N2 + e*         Richards & Torr, 1985
C      B16 N(2D) from above        Zipf et al, 1980
C      B17 O(1D) from N+ + O2      Langford et al, 1985
C      B18 O(1S) from N2(A) + O    Sharp & Torr, 1979
C      B19 O(1S) from O2(*) + O    ? (= 0 at present)
C      B20 O(1D) from N(2D) + O    ?
C      B21 NO+ from N+ + O2        Langford et al, 1985
C      B22 O2+ from N+ + O2        Langford et al, 1985
C      B23 N(2P) from N2+ + e      Queffelec et al, 1985
C      B24 N2 + e* pri. dis/ion    xsect ratio > 250 eV
C      B25 N(2D) from N2 + e* dis  Zipf et al, 1980
C      B26 N(2P) from N2 + e* dis  Zipf et al, 1980
C      B27 N(2D) from N2 + hv      Richards et al, 1981 (add to B28)
C      B28 N(2P) from N2 + hv      ? (cf Zipf & McGlaughlin, 1978)
C      B29 N(2D) from N(2P) + O    ?
C      B30 O+(2P) from O2 + hv     ?
C      B31 O+(2D)  "               ?
C      B32 O+(4S)  "               ?
C      B33 O(1S) from O2+ + N      Frederick et al, 1976; Kopp ea, 1977
C      B34 O(1S) from N(2D) + NO   Frederick et al, 1976; Kopp ea, 1977
C      B35 O2 + e* pri SRC/ion     xsect ratio > 250 eV
C      B36 N2+(B) from N2 + e*     Borst & Zipf, 1970;
C                                  Shemansky & Broadfoot, 1971
C      B37 (0,0) (3914) fr. N2+(B) Shemansky & Broadfoot, 1971
C      B38 (0,1) (4278) fr. N2+(B) Shemansky & Broadfoot, 1971
C      B39 (0,0) (3371) fr. N2(C)  Conway, 1983; Benesch et al, 1966
C      B40 (0,9) (3352) fr. N2(A)  Cartwright, 1978; Shemansky, 1969
C      B41 O+(2Po) fr. O+(2Pe)     Kirby et al, 1979
C      B42 O+(2Do) fr. O+(2Pe)     Kirby et al, 1979
C      B43 N2(C) bound fraction    ?
C      B44 7990 fr. O(3s'3D)       appx. fr. Hecht, p.c.
C      G1  N2+B(0,0) (3914)        Broadfoot, 1967
C      G2  N2+B(0,1) (4278)        Broadfoot, 1967
C
C
C Array dimensions:
C JMAX    number of altitude levels
C NBINS   number of energetic electron energy bins
C LMAX    number of wavelength intervals for solar flux
C NMAJ    number of major species
C NEX     number of ionized/excited species
C NW      number of airglow emission wavelengths
C NC      number of component production terms for each emission
C NST     number of states produced by photoionization/dissociation
C NEI     number of states produced by electron impact
C NR      number of rate coefficients, branching ratios, A and G factors
C NF      number of available types of auroral fluxes
C
C
      SUBROUTINE GCHEM(P,L)
!      use cglow, only: jmax,lmax,nmaj,nf,nei,nw,nc,nbins,nst,nex,RE,dp
      implicit none
      include 'cglow.h'

      integer,PARAMETER :: NR=50

      real, intent(OUT) :: P(NEX,JMAX), L(NEX,JMAX)

      integer idate,iscale,jlocal,kchem,ierr
      real  UT, GLAT, GLONG, 
     >    F107, F107A, HLYBR, FEXVIR, HLYA, HEIEW, XUVFAC,
     >    ZZ(JMAX), ZO(JMAX), ZN2(JMAX), ZO2(JMAX), ZNO(JMAX),
     >    ZNS(JMAX), ZND(JMAX), ZRHO(JMAX), ZE(JMAX),
     >    ZTN(JMAX), ZTI(JMAX), ZTE(JMAX),
     >    PHITOP(NBINS), EFLUX(NF), EZERO(NF),
     >    SZA, DIP, EFRAC, 
     >    ZMAJ(NMAJ,JMAX), ZCOL(NMAJ,JMAX),
     >    WAVE1(LMAX), WAVE2(LMAX), SFLUX(LMAX),
     >    ENER(NBINS), DEL(NBINS),
     >    PESPEC(NBINS,JMAX), SESPEC(NBINS,JMAX),
     >    PHOTOI(NST,NMAJ,JMAX), PHOTOD(NST,NMAJ,JMAX), PHONO(NST,JMAX),
     >    QTI(JMAX), AURI(NMAJ,JMAX), PIA(NMAJ,JMAX), SION(NMAJ,JMAX),
     >    UFLX(NBINS,JMAX), DFLX(NBINS,JMAX), AGLW(NEI,NMAJ,JMAX),
     >    EHEAT(JMAX), TEZ(JMAX), E(JMAX),
     >    DEN(NEX,JMAX), ZETA(NW,JMAX), ZCETA(NC,NW,JMAX), VCB(NW)

      COMMON /CGLOW/ IDATE, UT, GLAT, GLONG, ISCALE, JLOCAL, KCHEM,
     >    F107, F107A, HLYBR, FEXVIR, HLYA, HEIEW, XUVFAC,
     >    ZZ, ZO, ZN2, ZO2, ZNO, ZNS, ZND, ZRHO, ZE,
     >    ZTN, ZTI, ZTE, PHITOP, EFLUX, EZERO, SZA, DIP, EFRAC, IERR,
     >    ZMAJ, ZCOL, WAVE1, WAVE2, SFLUX, ENER, DEL, PESPEC, SESPEC,
     >    PHOTOI, PHOTOD, PHONO, QTI, AURI, PIA, SION,
     >    UFLX, DFLX, AGLW, EHEAT, TEZ, E, DEN, ZETA, ZCETA, VCB

      real BZ(NR,JMAX), GF(NR,JMAX), KZ(NR,JMAX),
     >          OEI(JMAX), O2EI(JMAX), RN2EI(JMAX), O2PI(JMAX),
     >          RN2PI(JMAX), RN2ED(JMAX), SRCED(JMAX),
     >          T1(JMAX), T2(JMAX), T3(JMAX), T4(JMAX), T5(JMAX),
     >          QQ(JMAX), RR(JMAX), SS(JMAX), TT(JMAX), UU(JMAX),
     >          VV(JMAX), WW(JMAX), XX(JMAX),
     >          AA(JMAX), BB(JMAX), CC(JMAX), DD(JMAX), EE(JMAX),
     >          FF(JMAX), GG(JMAX), HH(JMAX),dz,gh

      integer i,ic,iter,iw,ix,j200,n    
    
      real(kind=dp) :: COEF(JMAX,5), ROOT(JMAX)

      real,parameter :: A(12)=[1.07E-5, 0.00585, 0.00185, 0.04500, 
     &         1.06000,
     >         9.70E-5, 0.04790, 0.17120, 0.00100, 0.77000,
     >         0.00540, 0.07900]
      real,parameter :: B(44)=
     &      [0.07, 1.20, 0.76, 1.85, 1.00, 0.10, 0.50, 0.81, 0.20, 0.32,
     >       0.48, 0.10, 0.10, 0.10, 0.16, 0.50, 0.30, 0.19, 0.00, 0.10,
     >       0.43, 0.51, 0.10, 0.60, 0.54, 0.44, 0.80, 0.20, 1.00, 0.33,
     >       0.33, 0.34, 0.21, 0.20, 0.10, 0.11, 0.65, 0.20, 0.24, 0.02,
     >       0.18, 0.72, 0.75, 0.10]
C
C
      IF (KCHEM .EQ. 0) RETURN
C
C
C Zero airglow and density arrays:
C
      DO 10 I=1,JMAX
      DO 10 IW=1,NW
      ZETA(IW,I) = 0.0
   10 CONTINUE
C
      DO 20 I=1,JMAX
      DO 20 IW=1,NW
      DO 20 IC=1,NC
      ZCETA(IC,IW,I) = 0.0
   20 CONTINUE
C
      IF (KCHEM .GE. 3) THEN
      DO 30 I=1,JMAX
      DO 30 IX=1,NEX
      DEN(IX,I)=0.
   30 CONTINUE
      ENDIF
C
C
C Assign g-factors at altitudes which are sunlit:
C
      DO 40 I=1,JMAX
      DO 40 N=1,NR
      GF(N,I) = 0.0
   40 CONTINUE
C
      DO 50 I=1,JMAX
      GH = (RE+ZZ(I)) * SIN(SZA)
      IF (SZA .LT. 1.6 .OR. GH .GT. RE) THEN
        GF(1,I) = 0.041
        GF(2,I) = 0.013
      ENDIF
   50 CONTINUE
C
C
C Calculate rate coefficients as a function of altitude:
C
      DO 70 I=1,JMAX
      T1(I) = (16.*ZTN(I)+28.*ZTI(I)) / (16.+28.) / 300.
      T2(I) = (16.*ZTN(I)+32.*ZTI(I)) / (16.+32.) / 300.
      T3(I) = (28.*ZTN(I)+16.*ZTI(I)) / (28.+16.) / 300.
      T4(I) = (28.*ZTN(I)+32.*ZTI(I)) / (28.+32.) / 300.
      T5(I) = (16.*ZTN(I)+30.*ZTI(I)) / (16.+30.) / 300.
      IF (T1(I) .LT. 5.6667) THEN
        KZ(1,I) = 1.533E-12 - 5.92E-13*T1(I) + 8.6E-14*T1(I)**2
      ELSE
        KZ(1,I) = 2.73E-12 - 1.155E-12*T1(I) + 1.483E-13*T1(I)**2
      ENDIF
      IF (T2(I) .LT. 6.6667) THEN
        KZ(2,I) = 3.53E-11 - 1.84E-11*T2(I) + 4.62E-12*T2(I)**2
     >                     - 4.95E-13*T2(I)**3 + 2.00E-14*T2(I)**4
      ELSE
        KZ(2,I) = 2.82E-11 - 7.74E-12*T2(I) + 1.073E-12*T2(I)**2
     >                     - 5.17E-14*T2(I)**3 + 9.65E-16*T2(I)**4
      ENDIF
      KZ(3,I) = 1.793e-10 - 6.242e-11*T3(I) + 1.225e-11*T3(I)**2
     >                    - 1.016e-12*T3(I)**3 + 3.087e-14*T3(I)**4
      KZ(4,I) = 5.0E-11 * (1./T4(I)) ** 0.8
      KZ(5,I) = 6.0E-12
      KZ(6,I) = 6.9E-13
      KZ(7,I) = 5.5E-10 * (ZTE(I)/300.) ** 0.5
      KZ(8,I) = 2.0E-11 * EXP(107.8/ZTN(I))
      KZ(9,I) = 2.9E-11 * EXP(67.5 /ZTN(I))
      KZ(10,I) = 8.1E-10 * (ZTE(I)/300.) ** 0.5
      KZ(11,I) = 2.0E-14
      KZ(12,I) = 8.0E-10
      KZ(13,I) = 7.0E-10
      KZ(14,I) = 6.6E-08 * (300./ZTE(I)) ** 0.5
      KZ(15,I) = 1.0E-11
      KZ(16,I) = 4.8E-10
      KZ(17,I) = 4.8E-10
      KZ(18,I) = 1.7E-07 * (300./ZTE(I)) ** 0.5
      KZ(19,I) = 5.2E-11
      KZ(20,I) = 2.1E-11 * EXP(-1136./ZTN(I))
      KZ(21,I) = 1.0E-13
      KZ(22,I) = 4.2E-07 * (300./ZTE(I)) ** 0.85
      KZ(23,I) = 1.8E-07 * (300./ZTE(I)) ** 0.39
      KZ(24,I) = 1.95E-07 * (300./ZTE(I)) ** 0.70
      IF (ZTE(I) .GE. 1200.) KZ(24,I) = 1.6E-07 * (300./ZTE(I)) ** 0.55
      KZ(25,I) = 6.0E-10
      KZ(26,I) = 3.1E-11
      KZ(27,I) = 3.0E-12
      IF (ZTE(I) .LT. 500.) THEN
        KZ(28,I) = 1.0E-29
      ELSE
        KZ(28,I) = 2.6E-11 * ZTE(I)**0.5 * EXP(-22740./ZTE(I))
      ENDIF
      KZ(29,I) = 4.1E-12
      KZ(30,I) = 4.4E-10
      KZ(31,I) = 7.0E-11
      KZ(32,I) = 1.0E-12
      KZ(33,I) = 1.2E-11
      KZ(34,I) = 2.0E-12
      KZ(35,I) = 1.8E-10
      KZ(36,I) = 4.0E-12 * EXP(-865./ZTN(I))
      KZ(37,I) = 1.2E-10
      KZ(38,I) = 1.3E-10
      KZ(39,I) = 2.0E-11
      IF (T5(I) .LT. 5) THEN
        KZ(40,I) = 8.36E-13 - 2.02E-13*T5(I) + 6.95E-14*T5(I)**2
      ELSE
        KZ(40,I) = 5.33E-13 - 1.64E-14*T5(I) + 4.72E-14*T5(I)**2
     >                      - 7.05E-16*T5(I)**3
      ENDIF
   70 CONTINUE
C
C
C Calculate Electron impact ionization, photoionization, and electron
C impact dissociation rates at each altitude; put a priori electron
C density in calculated electron density array: put rough estimate of
C O+ and a priori N(2D) in DEN array:

C
      do I=1,JMAX
      OEI(I)   = SION(1,I) + PIA(1,I)
      O2EI(I)  = SION(2,I) + PIA(2,I)
      RN2EI(I) = SION(3,I) + PIA(3,I)
      O2PI(I)  = PHOTOI(1,2,I) + PHOTOI(2,2,I) + PHOTOI(3,2,I)
      RN2PI(I) = PHOTOI(1,3,I) + PHOTOI(2,3,I) + PHOTOI(3,3,I) +
     >           PHOTOI(4,3,I) + PHOTOI(5,3,I)
      RN2ED(I) = AGLW(5,3,I) + AGLW(6,3,I) + AGLW(7,3,I)
     >          + B(24)*PIA(3,I)
      SRCED(I) = AGLW(4,2,I) + B(35)*PIA(2,I)
      E(I)     = ZE(I)
      DEN(10,I)= ZND(I)
      end do ! I=1,JMAX
C
C
C Find level below which electron density will be calculated:
C
      IF (KCHEM .GE. 4) THEN
        DO 120 I=JMAX,1,-1
        IF (ZZ(I) .GT. 2.0001E7) J200=I-1
  120   CONTINUE
      ELSE
        J200=0
      ENDIF
C
C
C Iterative loop assures that feedback reactions (O+(2P,2D)+e,
C O+(4S)+N(2D), N2++O) are correctly computed:
C
      DO 350 ITER=1,3
  !     print *, 'Feedback iter',iter
C Calculate atomic ion densities at each altitude:
C
      DO 150 I=1,JMAX
C
C
C O+(2P):
      if (debug .and. i.eq.1) print *,'befor', 
     & iter,photoi(3,1,i),oei(i),o2ei(i),
     &           SION(1,I),PIA(1,I)
      P(1,I)= PHOTOI(3,1,I)
     >      + B(41) * PHOTOI(5,1,I)
     >      + B(30) * PHOTOI(4,2,I)
     >      + B(9)  * OEI(I)
     >      + B(12) * O2EI(I)
   

      if (debug .and. i.eq.170) 
     &  print *,'after',iter,p(1,I),photoi(3,1,170),oei(170),o2ei(170)
      L(1,I)= KZ(16,I) * ZN2(I)
     >      + KZ(17,I) * ZO2(I)
     >      + KZ(19,I) * ZO(I)
     >      + KZ(18,I) * E(I) 
     >      + A(8)
     >      + A(7)
      DEN(1,I) = P(1,I) / L(1,I)
C
C
C O+(2D):
C
      P(2,I)= PHOTOI(2,1,I)
     >      + B(42) * PHOTOI(5,1,I)
     >      + B(31) * PHOTOI(4,2,I)
     >      + B(10) * OEI(I)
     >      + B(13) * O2EI(I)
     >      + B(8)  * KZ(18,I) * DEN(1,I) * E(I)
     >      + A(8)  * DEN(1,I)
      L(2,I)= KZ(12,I) * ZN2(I) 
     >      + KZ(13,I) * ZO2(I) 
     >      + KZ(15,I) * ZO(I)
     >      + KZ(14,I) * E(I)
     >      + A(6)
      DEN(2,I) = P(2,I) / L(2,I)
C
C
C N+:
C
      IF (KCHEM .GE. 2) THEN
        P(4,I) = PHOTOI(6,3,I)
     >         + B(15) * RN2EI(I)
     >         + KZ(38,I) * DEN(3,I) * DEN(10,I)
        L(4,I) = KZ(25,I) * ZO2(I)
     >         + KZ(32,I) * ZO(I)
        DEN(4,I) = P(4,I) / L(4,I)
      ENDIF
C
C
C O+(4S):
C
      IF (KCHEM .GE. 3) THEN
        P(3,I)= PHOTOI(1,1,I) + PHOTOI(4,1,I)
     >        + B(32) * PHOTOI(4,2,I)
     >        + B(11) * OEI(I)
     >        + B(14) * O2EI(I) 
     >        + KZ(14,I) * DEN(2,I) * E(I) 
     >        + KZ(15,I) * DEN(2,I) * ZO(I) 
     >        + A(6) * DEN(2,I)
     >        + (1.-B(8)) * KZ(18,I) * DEN(1,I) * E(I)
     >        + KZ(19,I) * DEN(1,I) * ZO(I) 
     >        + A(7) * DEN(1,I)
     >        + KZ(32,I) * DEN(4,I) * ZO(I)
     >        + KZ(39,I) * DEN(5,I) * ZO(I)
        L(3,I)= KZ(1,I) * ZN2(I)
     >        + KZ(2,I) * ZO2(I)
     >        + KZ(38,I) * DEN(10,I)
        DEN(3,I) = P(3,I) / L(3,I)
      ENDIF
C
  150 CONTINUE
C
C
C Above 200 km, (or at all altitudes if KCHEM=3) use a priori
C electron density to calculate O+(4S):
C
      IF (KCHEM .GE. 3) THEN
C
      DO 170 I=J200+1,JMAX
      P(5,I)= RN2PI(I)
     >      + (1.-B(15)) * RN2EI(I)
     >      + KZ(12,I) * DEN(2,I) * ZN2(I)
     >      + KZ(16,I) * DEN(1,I) * ZN2(I)
      L(5,I)= KZ(3,I)  * ZO(I)
     >      + KZ(4,I)  * ZO2(I)
     >      + KZ(23,I) * E(I)
     >      + KZ(39,I) * ZO(I)
      DEN(5,I) = P(5,I) / L(5,I)
      QQ(I) = PHONO(1,I)
     >      + KZ(3,I)  * DEN(5,I) * ZO(I)
     >      + B(21) * KZ(25,I) * DEN(4,I) * ZO2(I)
      RR(I) = KZ(30,I) * ZNO(I)
     >      + KZ(37,I) * ZNS(I)
      SS(I) = KZ(1,I) * ZN2(I)
     >      + KZ(40,I) * ZNO(I)
      TT(I) = KZ(22,I) * E(I)
      UU(I) = O2PI(I)
     >      + (1.-B(12)-B(13)-B(14)) * O2EI(I)
     >      + KZ(13,I) * DEN(2,I) * ZO2(I)
     >      + KZ(17,I) * DEN(1,I) * ZO2(I)
     >      + KZ(4,I)  * DEN(5,I) * ZO2(I)
     >      + B(22) * KZ(25,I) * DEN(4,I) * ZO2(I)
      VV(I) = KZ(2,I) * ZO2(I)
      WW(I) = KZ(24,I) * E(I)
     >      + KZ(30,I) * ZNO(I)
     >      + KZ(37,I) * ZNS(I)
      XX(I) = DEN(1,I) + DEN(2,I) + DEN(4,I) + DEN(5,I)
      DEN(3,I) = (TT(I)*WW(I)*E(I) - TT(I)*WW(I)*XX(I) - TT(I)*UU(I)
     >            - QQ(I)*WW(I) - RR(I)*UU(I) ) /
     >           (TT(I)*WW(I) + TT(I)*VV(I) + RR(I)*VV(I) + SS(I)*WW(I))
  170 CONTINUE
C
      ENDIF
C
C
C If KCHEM=4, calculate electron density using quartic equation method
C below 200 km:
C
      IF (KCHEM .GE. 4) THEN
C
      DO 200 I=1,J200
      AA(I) =  PHONO(1,I)
     >       + KZ(1,I)  * DEN(3,I) * ZN2(I)
     >       + KZ(40,I) * DEN(3,I) * ZNO(I)
     >       + B(21) * KZ(25,I) * DEN(4,I) * ZO2(I)
      BB(I) =  O2PI(I)
     >       + (1.-B(12)-B(13)-B(14)) * O2EI(I)
     >       + KZ(2,I)  * DEN(3,I) * ZO2(I)
     >       + KZ(13,I) * DEN(2,I) * ZO2(I)
     >       + KZ(17,I) * DEN(1,I) * ZO2(I)
     >       + B(22) * KZ(25,I) * DEN(4,I) * ZO2(I)
      CC(I) =  KZ(30,I) * ZNO(I)
     >       + KZ(37,I) * ZNS(I)
      DD(I) =  RN2PI(I)
     >       + (1.-B(15)) * RN2EI(I)
     >       + KZ(12,I) * DEN(2,I) * ZN2(I)
     >       + KZ(16,I) * DEN(1,I) * ZN2(I)
      EE(I) = KZ(3,I) * ZO(I)
      FF(I) = DEN(1,I) + DEN(2,I) + DEN(3,I) + DEN(4,I)
      HH(I) = KZ(4,I)  * ZO2(I)
      GG(I) = KZ(39,I) * ZO(I)
      COEF(I,5) = KZ(22,I) * KZ(23,I) * KZ(24,I)
      COEF(I,4) =(KZ(22,I) * (KZ(24,I)*(EE(I)+HH(I)+GG(I))
     >                        + KZ(23,I)*CC(I))
     >            - KZ(22,I) * KZ(23,I) * KZ(24,I) * FF(I)) / 4.0
      COEF(I,3) =(KZ(22,I) * CC(I) * (EE(I)+HH(I)+GG(I))
     >            - KZ(22,I) * FF(I)
     >                       * (KZ(24,I)*(EE(I)+HH(I)+GG(I))
     >                          + KZ(23,I)*CC(I))
     >            - KZ(24,I) * KZ(23,I) * AA(I)
     >            - KZ(22,I) * KZ(23,I) * BB(I)
     >            - KZ(22,I) * KZ(24,I) * DD(I)) / 6.0
      COEF(I,2) =(- KZ(22,I) * (CC(I)*FF(I)*(EE(I)+HH(I)+GG(I))
     >                         + DD(I)*HH(I) + BB(I)*(EE(I)+HH(I)+GG(I))
     >                          + CC(I)*DD(I))
     >            - KZ(24,I) * (AA(I)*(EE(I)+HH(I)+GG(I)) + DD(I)*EE(I))
     >            - KZ(23,I) * CC(I) * (AA(I)+BB(I))) / 4.0
      COEF(I,1) = - CC(I) * (EE(I)+HH(I)+GG(I)) * (AA(I)+BB(I)+DD(I))
      COEF(I,5) = COEF(I,5) * 1.D10
      COEF(I,4) = COEF(I,4) * 1.D10
      COEF(I,3) = COEF(I,3) * 1.D10
      COEF(I,2) = COEF(I,2) * 1.D10
      COEF(I,1) = COEF(I,1) * 1.D10
  200 CONTINUE
C
      CALL VQUART (COEF, ROOT, J200)
C
      DO 250 I=1,J200
      E(I) =real(ROOT(I))
  250 CONTINUE
C
      E(J200+1) = E(J200) * ( E(J200+3) / E(J200) )
     >            ** ( (ZZ(J200+1)-ZZ(J200)) / (ZZ(J200+3)-ZZ(J200)) )
      E(J200+2) = E(J200) * (E(J200+3)/E(J200))
     >            ** ( (ZZ(J200+2)-ZZ(J200)) / (ZZ(J200+3)-ZZ(J200)) )
C
      ENDIF
C
C
C Calculate molecular ion densities and excited species densites:
C
      DO 300 I=1,JMAX
C
C
C N2+:
C
      IF (KCHEM .GE. 2) THEN
        P(5,I)= RN2PI(I)
     >        + (1.-B(15)) * RN2EI(I)
     >        + KZ(12,I) * DEN(2,I) * ZN2(I)
     >        + KZ(16,I) * DEN(1,I) * ZN2(I)
        L(5,I)= KZ(3,I)  * ZO(I)
     >        + KZ(4,I)  * ZO2(I)
     >        + KZ(23,I) * E(I)
     >        + KZ(39,I) * ZO(I)
          DEN(5,I) = P(5,I) / L(5,I)
      ENDIF
C
C
C O2+:
C
      IF (KCHEM .GE. 3) THEN
        P(6,I)= O2PI(I)
     >        + (1.-B(12)-B(13)-B(14)) * O2EI(I)
     >        + KZ(2,I)  * DEN(3,I) * ZO2(I)
     >        + KZ(13,I) * DEN(2,I) * ZO2(I)
     >        + KZ(17,I) * DEN(1,I) * ZO2(I)
     >        + KZ(4,I)  * DEN(5,I) * ZO2(I)
     >        + B(22) * KZ(25,I) * DEN(4,I) * ZO2(I)
        L(6,I)= KZ(24,I) * E(I)
     >        + KZ(30,I) * ZNO(I)
     >        + KZ(37,I) * ZNS(I)
        DEN(6,I) = P(6,I)/ L(6,I)
      ENDIF
C
C
C NO+:
C
      IF (KCHEM .GE. 3) THEN
        P(7,I)= PHONO(1,I)
     >        + KZ(1,I)  * DEN(3,I) * ZN2(I)
     >        + KZ(40,I) * DEN(3,I) * ZNO(I)
     >        + KZ(3,I)  * DEN(5,I) * ZO(I)
     >        + B(21) * KZ(25,I) * DEN(4,I) * ZO2(I)
     >        + KZ(30,I) * DEN(6,I) * ZNO(I)
     >        + KZ(37,I) * DEN(6,I) * ZNS(I)
        L(7,I)= KZ(22,I) * E(I)
        DEN(7,I) = P(7,I) / L(7,I)
      ENDIF
C
C
C N2(A):
C
      P(8,I)= AGLW(1,3,I) + AGLW(2,3,I) + B(43)*AGLW(3,3,I)
      L(8,I)= KZ(26,I) * ZO(I)
     >      + KZ(29,I) * ZO2(I)
     >      + A(10)
      DEN(8,I) = P(8,I) / L(8,I)
C
C
C N(2P):
C
      P(9,I)= B(28) * PHOTOD(1,3,I)
     >      + B(28) * PHOTOI(6,3,I)
     >      + B(26) * RN2ED(I)
     >      + B(23) * KZ(23,I) * DEN(5,I) * E(I)
      L(9,I)= KZ(33,I) * ZO(I)
     >      + KZ(34,I) * ZO2(I)
     >      + KZ(35,I) * ZNO(I)
     >      + A(11)
     >      + A(12)
      DEN(9,I) = P(9,I) / L(9,I)
C
C
C N(2D):
C
      P(10,I)= B(27) * PHOTOD(1,3,I)
     >       + B(27) * PHOTOI(6,3,I)
     >       + B(25) * RN2ED(I)
     >       + B(16) * B(15) * RN2EI(I)
     >       + B(3)  * KZ(22,I) * DEN(7,I) * E(I)
     >       + B(4)  * KZ(23,I) * DEN(5,I) * E(I)
     >       + B(5)  * KZ(3,I)  * DEN(5,I) * ZO(I)
     >       + B(29) * KZ(33,I) * DEN(9,I) * ZO(I)
     >       + A(12) * DEN(9,I)
      L(10,I)= KZ(5,I)  * ZO2(I)
     >       + KZ(6,I)  * ZO(I)
     >       + KZ(7,I)  * E(I)
     >       + KZ(31,I) * ZNO(I)
     >       + KZ(38,I) * DEN(3,I)
     >       + A(1)
      DEN(10,I) = P(10,I) / L(10,I)
C
C
C O(1S):
C
      BZ(1,I) = 0.12 + 0.02 * ALOG10 (E(I)/ZO(I)*(300./ZTE(I))**0.7)
      IF (BZ(1,I) .LT. 0.03) BZ(1,I)=0.03
      P(11,I)= AGLW(2,1,I)
     >       + BZ(1,I) * KZ(24,I) * DEN(6,I)  * E(I)
     >       + B(18) * KZ(26,I) * DEN(8,I) * ZO(I)
     >       + B(33) * KZ(37,I) * DEN(6,I) * ZNS(I)
     >       + B(34) * KZ(31,I) * DEN(10,I) * ZNO(I)
     >       + PHOTOD(2,2,I)
      L(11,I)= KZ(11,I) * ZO(I)
     >       + KZ(36,I) * ZO2(I)
     >       + A(5)
     >       + A(4)
      DEN(11,I) = P(11,I) / L(11,I)
C
C
C O(1D):
C
      P(12,I)= AGLW(1,1,I)
     >       + KZ(28,I) * E(I)  * ZO(I)
     >       + B(2)  * KZ(24,I) * DEN(6,I)  * E(I)
     >       + B(6)  * KZ(5,I)  * DEN(10,I) * ZO2(I)
     >       + B(20) * KZ(6,I)  * DEN(10,I) * ZO(I)
     >       + B(17) * KZ(25,I) * DEN(4,I)  * ZO2(I)
     >       + B(7)  * KZ(15,I) * DEN(2,I)  * ZO(I)
     >       + SRCED(I)
     >       + PHOTOD(1,2,I)
     >       + A(5)  * DEN(11,I)
      L(12,I)= KZ(8,I)  * ZN2(I) 
     >       + KZ(9,I)  * ZO2(I)
     >       + KZ(10,I) * E(I)
     >       + KZ(27,I) * ZO(I)
     >       + A(2)
     >       + A(3)
      DEN(12,I) = P(12,I) / L(12,I)
C
  300 CONTINUE
C
  350 CONTINUE
C
C
C Calculate airglow emission rates; fill ZCETA array with partial rates
C from each source; fill ZETA array with total rate for each emission:
C
      DO 400 I=1,JMAX
C
      ZCETA(1,1,I) = B(39) * AGLW(3,3,I)
      ZCETA(2,1,I) = B(40) * A(10) * P(8,I) / L(8,I)
C
      ZCETA(1,2,I) = B(38) * B(36) * RN2EI(I)
      ZCETA(2,2,I) = B(38) * PHOTOI(3,3,I)
      ZCETA(3,2,I) = GF(2,I) * DEN(5,I)
C
      ZCETA(1,3,I) = A(1) * B(27) * PHOTOD(1,3,I) / L(10,I)
      ZCETA(2,3,I) = A(1) * B(27) * PHOTOI(6,3,I) / L(10,I)
      ZCETA(3,3,I) = A(1) * B(25) * RN2ED(I) / L(10,I)
      ZCETA(4,3,I) = A(1) * B(16) * B(15) * RN2EI(I) / L(10,I)
      ZCETA(5,3,I) = A(1) * B(3)  * KZ(22,I) * DEN(7,I) * E(I) /L(10,I)
      ZCETA(6,3,I) = A(1) * B(4)  * KZ(23,I) * DEN(5,I) * E(I) /L(10,I)
      ZCETA(7,3,I) = A(1) * B(5)  * KZ(3,I)  * DEN(5,I) * ZO(I) /L(10,I)
      ZCETA(8,3,I) = A(1) * B(29) * KZ(33,I) * DEN(9,I) * ZO(I) /L(10,I)
      ZCETA(9,3,I) = A(1) * A(12) * DEN(9,I) / L(10,I)
C
      ZCETA(1,4,I) = A(5) * AGLW(2,1,I) / L(11,I)
      ZCETA(2,4,I) = A(5) * BZ(1,I)*KZ(24,I) * DEN(6,I) * E(I)  /L(11,I)
      ZCETA(3,4,I) = A(5) * B(18) * KZ(26,I) * DEN(8,I) * ZO(I) /L(11,I)
      ZCETA(4,4,I) = A(5) * B(33) * KZ(37,I) * DEN(6,I) * ZNS(I)/L(11,I)
      ZCETA(5,4,I) = A(5) * B(34) * KZ(31,I) * DEN(10,I)* ZNO(I)/L(11,I)
      ZCETA(6,4,I) = PHOTOD(2,2,I) / L(11,I)
C
      ZCETA(1,5,I) = A(2) * AGLW(1,1,I) / L(12,I)
      ZCETA(2,5,I) = A(2) * KZ(28,I) * E(I)  * ZO(I) / L(12,I)
      ZCETA(3,5,I) = A(2) * B(2)  * KZ(24,I) * DEN(6,I)  * E(I)/L(12,I)
      ZCETA(4,5,I) = A(2) * B(6)  * KZ(5,I)  * DEN(10,I) *ZO2(I)/L(12,I)
      ZCETA(5,5,I) = A(2) * B(20) * KZ(6,I)  * DEN(10,I) * ZO(I)/L(12,I)
      ZCETA(6,5,I) = A(2) * B(17) * KZ(25,I) * DEN(4,I) * ZO2(I)/L(12,I)
      ZCETA(7,5,I) = A(2) * B(7)  * KZ(15,I) * DEN(2,I)  * ZO(I)/L(12,I)
      ZCETA(8,5,I) = A(2) * SRCED(I) / L(12,I)
      ZCETA(9,5,I) = A(2) * PHOTOD(1,2,I) / L(12,I)
      ZCETA(10,5,I)= A(2) * A(5)  * DEN(11,I) / L(12,I)
C
      ZCETA(1,6,I) = A(8) * (PHOTOI(3,1,I)+B(41)*PHOTOI(5,1,I)) / L(1,I)
      ZCETA(2,6,I) = A(8) * B(30) * PHOTOI(4,2,I) / L(1,I)
      ZCETA(3,6,I) = A(8) * B(9) * OEI(I) / L(1,I)
      ZCETA(4,6,I) = A(8) * B(12) * O2EI(I) / L(1,I)
C
      ZCETA(1,7,I) = A(12) * B(28) * PHOTOD(1,3,I) / L(9,I)
      ZCETA(2,7,I) = A(12) * B(28) * PHOTOI(6,3,I) / L(9,I)
      ZCETA(3,7,I) = A(12) * B(26) * RN2ED(I) / L(9,I)
      ZCETA(4,7,I) = A(12) * B(23) * KZ(23,I) * DEN(5,I) * E(I) / L(9,I)
C
      ZCETA(1,8,I) = A(11) * B(28) * PHOTOD(1,3,I) / L(9,I)
      ZCETA(2,8,I) = A(11) * B(28) * PHOTOI(6,3,I) / L(9,I)
      ZCETA(3,8,I) = A(11) * B(26) * RN2ED(I) / L(9,I)
      ZCETA(4,8,I) = A(11) * B(23) * KZ(23,I) * DEN(5,I) * E(I) / L(9,I)
C
      ZCETA(1,9,I) = AGLW(5,1,I)
C
      ZCETA(1,10,I) = AGLW(6,1,I)
      ZCETA(2,10,I) = AGLW(7,1,I)
      ZCETA(3,10,I) = B(44) * AGLW(8,1,I)
C
      ZCETA(1,11,I) = A(6) * (PHOTOI(2,1,I)+B(42)*PHOTOI(5,1,I))/ L(2,I)
      ZCETA(2,11,I) = A(6) * B(31) * PHOTOI(4,2,I) / L(2,I)
      ZCETA(3,11,I) = A(6) * B(10) * OEI(I) / L(2,I)
      ZCETA(4,11,I) = A(6) * B(13) * O2EI(I) / L(2,I)
      ZCETA(5,11,I) = A(6) * B(8)  * KZ(18,I) * DEN(1,I) * E(I) / L(2,I)
      ZCETA(6,11,I) = A(6) * A(8)  * DEN(1,I) / L(2,I)
C
      ZETA(1,I)  = ZCETA(1,1,I)+ZCETA(2,1,I)
      ZETA(2,I)  = ZCETA(1,2,I)+ZCETA(2,2,I)+ZCETA(3,2,I)
      ZETA(3,I)  = ZCETA(1,3,I)+ZCETA(2,3,I)+ZCETA(3,3,I)
     >            +ZCETA(4,3,I)+ZCETA(5,3,I)+ZCETA(6,3,I)
     >            +ZCETA(7,3,I)+ZCETA(8,3,I)+ZCETA(9,3,I)
      ZETA(4,I)  = ZCETA(1,4,I)+ZCETA(2,4,I)+ZCETA(3,4,I)
     >            +ZCETA(4,4,I)+ZCETA(5,4,I)+ZCETA(6,4,I)
      ZETA(5,I)  = ZCETA(1,5,I)+ZCETA(2,5,I)+ZCETA(3,5,I)
     >            +ZCETA(4,5,I)+ZCETA(5,5,I)+ZCETA(6,5,I)
     >            +ZCETA(7,5,I)+ZCETA(8,5,I)+ZCETA(9,5,I)
     >            +ZCETA(10,5,I)
      ZETA(6,I)  = ZCETA(1,6,I)+ZCETA(2,6,I)+ZCETA(3,6,I)+ZCETA(4,6,I)
      ZETA(7,I)  = ZCETA(1,7,I)+ZCETA(2,7,I)+ZCETA(3,7,I)+ZCETA(4,7,I)
      ZETA(8,I)  = ZCETA(1,8,I)+ZCETA(2,8,I)+ZCETA(3,8,I)+ZCETA(4,8,I)
      ZETA(9,I)  = ZCETA(1,9,I)
      ZETA(10,I) = ZCETA(1,10,I)+ZCETA(2,10,I)+ZCETA(3,10,I)
      ZETA(11,I) = ZCETA(1,11,I)+ZCETA(2,11,I)+ZCETA(3,11,I)
     >            +ZCETA(4,11,I)+ZCETA(5,11,I)+ZCETA(6,11,I)
C
  400 CONTINUE
C
C
C Calculate vertical column brightnesses:
C
      DO IW=1,NW
        VCB(IW) = 0.
      End Do
C
      DO I=1,JMAX
          IF (I .EQ. JMAX) THEN
            DZ = (ZZ(I) - ZZ(I-1))
          ELSE
            IF (I .EQ. 1) THEN
              DZ = (ZZ(I+1) - ZZ(I))
            ELSE
              DZ = (ZZ(I+1) - ZZ(I-1)) / 2.0
            ENDIF
          ENDIF

          DO IW=1,NW
            VCB(IW) = VCB(IW) + ZETA(IW,I) * DZ
          End Do
      End Do
C
C
C Convert brightnesses to Rayleighs:
C
      DO IW=1,NW
        VCB(IW) = VCB(IW) / 1.E6
      end do

      END SUBROUTINE GCHEM

! Subroutine EGRID sets up electron energy grid
!
! Stan Solomon, 1/92
!
! This software is part of the GLOW model.  Use is governed by the Open Source
! Academic Research License Agreement contained in the file glowlicense.txt.
! For more information see the file glow.txt.
!
      SUBROUTINE EGRID (ENER, DEL)
!      use cglow,only: nbins
      implicit none
      include 'cglow.h'
! Args:
      Real, Intent(Out) :: ENER(Nbins), DEL(Nbins)
! Local:
      Integer N

      DO N=1,NBINS
        IF (N .LE. 21) THEN
          ENER(N) = 0.5 * REAL(N)
        ELSE
          ENER(N) = EXP (0.05 * REAL(N+26))
        ENDIF
      end do

      DEL(1) = 0.5
      DO N=2,NBINS
        DEL(N) = ENER(N)-ENER(N-1)
      End Do

      DO N=1,NBINS
        ENER(N) = ENER(N) - DEL(N)/2.0
      End Do

      End Subroutine Egrid

C Subroutine SNOEMINT gets NO estimate from the NOEM emperical model and
C INTerpolates it onto an altitude grid.  Extrapolation is done above 150
C km assuming a scale height approximation, and below 100 km
C assuming a constant profile.
C
C Stan Solomon, 12/14
C
C Input:
C   IDATE  Date in yyddd or yyyyddd format
C   GLAT   Geographic latitude in degrees
C   GLONG  Geographic longitude in degrees
C   F107   10.7 cm radio flux index
C   AP     Ap index
C   JMAX   Number of points in altitude grid
C   Z      Altitude grid in km
C   ZTN    Temperature at Z in K
C Output:
C   ZNO    Nitric oxide density at Z in cm-3
C
C
      SUBROUTINE SNOEMINT(IDATE,GLAT,GLONG,F107,AP,Z,ZTN,ZNO)
!      use cglow,only: jmax
      implicit none
      include 'cglow.h'
      
      integer, intent(in) :: IDATE
      real,intent(in) :: GLAT,GLONG,F107,AP,Z(JMAX),ZTN(JMAX)
      real,intent(out):: ZNO(JMAX)
      
      Real ZG(16),XMLATNO(33), ZMNO(33,16), ZMNOI(16),rat,xkp,
     & xmlat,xmlong,h
      integer iday,j,klat1,klat2,kz1,kz2
      

C Find magnetic latitude:

      CALL GEOMAG(0,GLONG,GLAT,XMLONG,XMLAT)
C
C
C Get zonal mean NO profiles:
C
      IDAY=IDATE-IDATE/1000*1000
      XKP=1.75*LOG(0.4*AP)
      CALL SNOEM(IDAY,XKP,F107,ZG,XMLATNO,ZMNO)
C
C
C Interpolate altitude profile at magnetic latitude:
C
      KLAT1=INT(XMLAT+80.)/5+1
      KLAT2=KLAT1+1
      IF (KLAT1 .LT. 1) KLAT1=1
      IF (KLAT1 .GT. 33) KLAT1=33
      IF (KLAT2 .LT. 1) KLAT1=1
      IF (KLAT2 .GT. 33) KLAT2=33
      RAT=XMLAT/5.-INT(XMLAT)/5
C
      DO J=1,16
        ZMNOI(J) = LOG(ZMNO(KLAT1,J)*(1.-RAT)+ZMNO(KLAT2,J)*RAT)
      END DO

      H=0.03*ZTN(JMAX)
      DO J=1,JMAX
        IF (Z(J) .LE. 100.) ZNO(J)=EXP(ZMNOI(16))
        IF (Z(J) .GT. 100. .AND. Z(J) .LE. 150.) THEN
          KZ2=INT((150.-Z(J))*.3)+1
          KZ1=KZ2+1
          ZNO(J)=EXP ( ZMNOI(KZ1) + (ZMNOI(KZ2)-ZMNOI(KZ1))
     >                            * (Z(J)-ZG(KZ1)) / (ZG(KZ2)-ZG(KZ1)) )
        ENDIF
        IF (Z(J) .GT. 150.) ZNO(J)=EXP(ZMNOI(1)+(150.-Z(J))/H)
      END DO
      END SUBROUTINE SNOEMINT

C Subroutine ROUT writes model atmosphere and excitation rates to an
C output file in order to transfer them to radiative transfer program.
C
C This software is part of the GLOW model.  Use is governed by the Open Source
C Academic Research License Agreement contained in the file glowlicense.txt.
C For more information see the file glow.txt.
C
C SMB/SCS, 9/94
C Replaced 834 with LBH, SCS, 2/03
C Reduced cascade contribution to 1356, SCS, 9/03
C Included radiative recombination in 1356 SCS, 9/03
C
      SUBROUTINE ROUT(ROFILE,EF,EZ,ITAIL,FRACO,FRACO2,FRACN2,PyUV)
!      use cglow,only: nst,nf,jmax,nmaj,nw,nc,nbins,lmax,nei,nex
      implicit none
      include 'cglow.h'

      character(len=*),intent(in) :: rofile
      real,intent(in) :: ef,ez,FRACO,FRACO2,FRACN2
      integer,intent(in) :: ITAIL
      real,intent(out) :: PyUV(5,jmax)  ! five UV wavelengths

      integer :: LUN

      real z(jmax), zhe(jmax), e1356(jmax), e1304(jmax),
     &          e1027(jmax), e989(jmax), elbh(jmax)


      integer IDATE, ISCALE, JLOCAL, KCHEM, IERR,j
      real  UT, GLAT, GLONG, 
     >    F107, F107A, f107p, HLYBR, FEXVIR, HLYA, HEIEW, XUVFAC,
     >    ZZ(JMAX), ZO(JMAX), ZN2(JMAX), ZO2(JMAX), ZNO(JMAX),
     >    ZNS(JMAX), ZND(JMAX), ZRHO(JMAX), ZE(JMAX),
     >    ZTN(JMAX), ZTI(JMAX), ZTE(JMAX),
     >    PHITOP(NBINS), EFLUX(NF), EZERO(NF),
     >    SZA, DIP, EFRAC, 
     >    ZMAJ(NMAJ,JMAX), ZCOL(NMAJ,JMAX),
     >    WAVE1(LMAX), WAVE2(LMAX), SFLUX(LMAX),
     >    ENER(NBINS), DEL(NBINS),
     >    PESPEC(NBINS,JMAX), SESPEC(NBINS,JMAX),
     >    PHOTOI(NST,NMAJ,JMAX), PHOTOD(NST,NMAJ,JMAX), PHONO(NST,JMAX),
     >    QTI(JMAX), AURI(NMAJ,JMAX), PIA(NMAJ,JMAX), SION(NMAJ,JMAX),
     >    UFLX(NBINS,JMAX), DFLX(NBINS,JMAX), AGLW(NEI,NMAJ,JMAX),
     >    EHEAT(JMAX), TEZ(JMAX), ECALC(JMAX),
     >    ZXDEN(NEX,JMAX), ZETA(NW,JMAX), ZCETA(NC,NW,JMAX), VCB(NW)


      COMMON /CGLOW/
     >    IDATE, UT, GLAT, GLONG, ISCALE, JLOCAL, KCHEM,
     >    F107, F107A, HLYBR, FEXVIR, HLYA, HEIEW, XUVFAC,
     >    ZZ, ZO, ZN2, ZO2, ZNO, ZNS, ZND, ZRHO, ZE,
     >    ZTN, ZTI, ZTE, PHITOP, EFLUX, EZERO, SZA, DIP, EFRAC, IERR,
     >    ZMAJ, ZCOL, WAVE1, WAVE2, SFLUX, ENER, DEL, PESPEC, SESPEC,
     >    PHOTOI, PHOTOD, PHONO, QTI, AURI, PIA, SION,
     >    UFLX, DFLX, AGLW, EHEAT, TEZ, ECALC, ZXDEN, ZETA, ZCETA, VCB


      do j=1,jmax
        z(j)=zz(j)/1.e5
        zhe(j)=0.
C Temporary fix-up to 1356:
        e1356(j)=aglw(3,1,j)+aglw(5,1,j)*0.7+ecalc(j)*zxden(3,j) * 
     &             4.9e-13
        e1304(j)=aglw(4,1,j)+aglw(6,1,j)+aglw(7,1,j)+aglw(8,1,j)*0.1
        e1027(j)=aglw(7,1,j)
        e989(j)=aglw(8,1,j)
        elbh(j)=aglw(4,3,j)
      enddo
      
      PyUV(1,:) = e1356
      PyUV(2,:) = e1304
      PyUV(3,:) = e1027
      PyUV(4,:) = e989
      PyUV(5,:) = elbh

      Return  ! Python doesn't need writing to disk

      open(newunit=lun,file=rofile,status='unknown',action='write')
C  
      write(lun,100)
 100  format('   JMAX ','   SZA  ','   UT   ','   IDATE',
     >             '   LAT  ','   LONG ','    DIP ')
      write(lun,200) jmax,sza*180./3.14159,ut,idate,glat,glong,dip
 200  format(i8,f8.2,f8.1,i8,3f8.2)
      write(lun,250)
 250  format('  F107  ','  F107p ','  F107a ','  HLyBr ',
     >       ' FeXVIr ','   HLYa ','  HeIew ',' XUVfac ')
      write(lun,300) f107,f107p,f107a,hlybr,fexvir,hlya,heiew,xuvfac
 300  format (5f8.2,1pe10.2,0p2f8.2)
      write(lun,350)
 350  format(' Eflux  ',' Ezero  ',' Itail  ',
     >       ' FracO  ',' FracO2  ',' FracN2  ')
      write(lun,400) ef, ez, itail, fraco, fraco2, fracn2
 400  format(f8.2,f8.1,i8,3f8.2)
      write(lun,500)
 500  format(' Alt    Tn    Ti    Te  ',
     >       '    O        O2       N2       He   ',
     >       '    N        Ne       O+      1356  ',
     >       '   1304     1027      989     LBH')
C
      do j=1,jmax
        write(lun,600) z(j),ztn(j),zti(j),zte(j),
     >               zo(j),zo2(j),zn2(j),zhe(j),
     >               zns(j),ecalc(j),zxden(3,j),e1356(j),
     >               e1304(j),e1027(j),e989(j),elbh(j)
 600    format(0p,f6.1,3f6.0,1p,12e9.2)
      enddo
C
      close(lun)

      End Subroutine Rout

! Subroutine SOLZEN
!
! This software is part of the GLOW model.  Use is governed by the Open Source
! Academic Research License Agreement contained in the file glowlicense.txt.
! For more information see the file glow.txt.
!
! Stan Solomon, 1988
! Temporary Y2K fix-up, SCS, 2005.
!
! Returns Solar Zenith Angle SZA in degrees for specified date in form
! yyddd, universal time in seconds, geographic latitude and longitude
! in degrees.

      SUBROUTINE SOLZEN (IDATE, UT, GLAT, GLONG, SZA)
!      use cglow,only: pi
      implicit none
      include 'cglow.h'
! Args:
      integer,intent(in) :: idate
      real,intent(in) :: UT,glat,glong
      real,intent(out):: sza
! Local:  
      real sdec,srasn,gst,rlat,rh,cossza,rlong

      RLAT = GLAT * PI/180.
      RLONG = GLONG * PI/180.
      CALL SUNCOR (IDATE, UT, SDEC, SRASN, GST)
      RH = SRASN - (GST+RLONG)
      COSSZA = SIN(SDEC)*SIN(RLAT) + COS(SDEC)*COS(RLAT)*COS(RH)
      SZA = ACOS(COSSZA) * 180./PI
      END SUBROUTINE SOLZEN
!
! Subroutine SUNCOR returns the declination SDEC and right ascension
! SRASN of the sun in GEI coordinates, radians, for a given date IDATE
! in yyddd format and universal time UT in seconds.  Greenwich Sidereal
! Time GST in radians is also returned.  Reference:  C.T. Russell,
! Geophysical Coordinate Transforms.
!
      SUBROUTINE SUNCOR (IDATE, UT, SDEC, SRASN, GST)
!      use cglow,only: pi
      implicit none
      include 'cglow.h'
! Args:
      integer,intent(in) :: idate
      real,intent(in) :: UT
      real,intent(out):: SDEC,SRASN,GST
! Local:
      real fday,vl,slp,slong,sind,obliq,GG,DJ,cosd,T
      integer iyr,iday

      FDAY=UT/86400.
      IYR=IDATE/1000
      IDAY=IDATE-IYR*1000
!
! Temporary Y2K fix-up:
! Should work with either yyddd or yyyyddd format from 1950 to 2050.
! Note deteriorating accuracy after ~2050 anyway.
! Won't work after 2100 due to lack of a leap year.
      IF (IYR .GE. 1900) IYR=IYR-1900
      IF (IYR .LT. 50) IYR=IYR+100

      DJ=365*IYR+(IYR-1)/4+IDAY+FDAY-0.5
      T=DJ/36525.
      VL= MOD(279.696678+.9856473354*DJ,360.)
      GST=MOD(279.696678+.9856473354*DJ+360.*FDAY+180.,360.) * PI/180.
      GG=  MOD(358.475845+.985600267*DJ,360.) * PI/180.
      SLONG=VL+(1.91946-.004789*T)*SIN(GG)+.020094*SIN(2.*GG)
      OBLIQ=(23.45229-0.0130125*T) *PI/180.
      SLP=(SLONG-.005686) * PI/180.
      SIND=SIN(OBLIQ)*SIN(SLP)
      COSD=SQRT(1.-SIND**2)
      SDEC=ATAN(SIND/COSD)
      SRASN=pi-ATAN2(1./TAN(OBLIQ)*SIND/COSD,-COS(SLP)/COSD)
      END Subroutine Suncor

! Subroutine RCOLUM
!
! This software is part of the GLOW model.  Use is governed by the Open Source
! Academic Research License Agreement contained in the file glowlicense.txt.
! For more information see the file glow.txt.
!
! Stan Solomon, 1988, 1991
!
! Calculates the column density ZCOL for each species ZMAJ above height
! ZZ at zenith angle CHI.  Uses a Chapman function fit [Smith and Smith,
! JGR 77, 3592, 1972].  If CHI is less than 90 degrees, column
! densities are calculated directly; if CHI is greater than 90 degrees
! the column density at grazing height for 90 degrees is calculated and
! doubled and the column density above ZZ(J) is subtracted; if CHI is
! such that the grazing height is less than the radius of the earth the
! column densities are set to 'infinity', i.e., 1.0E30.  Densities
! supplied in array ZMAJ are used in the calculation except where
! grazing height is below the lowest level specified, in this case
! values are interpolated logarithmically from a US Standard Atmosphere
! at sea level, the tropopause, the stratopause, and the mesopause.
!
      SUBROUTINE RCOLUM (CHI, ZZ, ZMAJ, TN, ZCOL, ZVCD)
!      use cglow,only: nmaj,jmax,pi,Re
      implicit none
      include 'cglow.h'
!Args:
      real, intent(in) :: chi,zz(jmax),ZMAJ(NMAJ,JMAX),TN(JMAX)
      real, intent(out) :: ZVCD(NMAJ,JMAX),ZCOL(NMAJ,JMAX)
!Local:
      integer,PARAMETER :: NM=3,NU=4

      real  ZCG(NM),ghrg,ghz,tng
      real  ZUS(nu), TNUS(nu),zcus(nm,nu)
      integer i,j, jg

      real :: chap !function

      DATA ZUS/0.0, 1.5E6, 5.E6, 9.E6/
      DATA TNUS/288., 217., 271., 187./
      DATA ZCUS/8.00E17, 4.54E24, 1.69E25,
     >          8.00E17, 5.46E23, 2.03E24,
     >          8.00E17, 3.63E21, 1.35E22,
     >          7.80E17, 8.48E18, 3.16E19/

      CALL VCD (ZZ, ZMAJ, ZVCD)

      IF (CHI .GE. 2.) THEN 
        DO 40 I=1,NMAJ
        DO 40 J=1,JMAX
        ZCOL(I,J) = 1.0E30
   40   CONTINUE
        RETURN
      ENDIF
C
      IF (CHI .LE. PI/2.) THEN
        DO 60 I=1,NMAJ
        DO 60 J=1,JMAX
        ZCOL(I,J) = ZVCD(I,J) * CHAP(CHI,ZZ(J),TN(J),I)
   60   CONTINUE
      ELSE
        DO 220 J=1,JMAX
        GHRG=(RE+ZZ(J))*SIN(CHI) 
        GHZ=GHRG-RE 
        IF (GHZ .LE. 0.) THEN
          DO 80 I=1,NMAJ
          ZCOL(I,J) = 1.0E30
   80     CONTINUE
          GOTO 220
        ENDIF
        IF (GHZ .GE. ZZ(1)) THEN
          DO 100 JG=1,J-1
            IF (ZZ(JG) .LE. GHZ .AND. ZZ(JG+1) .GT. GHZ) GOTO 120
  100     CONTINUE
  120     TNG = TN(JG)+(TN(JG+1)-TN(JG))*(GHZ-ZZ(JG))/(ZZ(JG+1)-ZZ(JG))
          DO 140 I=1,NMAJ
          ZCG(I) = ZVCD(I,JG) * (ZVCD(I,JG+1) / ZVCD(I,JG)) **
     >                      ((GHZ-ZZ(JG)) / (ZZ(JG+1)-ZZ(JG)))
  140     CONTINUE
        ELSE
          DO 160 JG=1,3
          IF (ZUS(JG) .LT. GHZ .AND. ZUS(JG+1) .GT. GHZ) GOTO 180
  160     CONTINUE
  180     TNG = TNUS(JG)
     >        + (TNUS(JG+1)-TNUS(JG))*(GHZ-ZUS(JG))/(ZUS(JG+1)-ZUS(JG))
          DO 200 I=1,NMAJ
          ZCG(I) = ZCUS(I,JG) * (ZCUS(I,JG+1) / ZCUS(I,JG)) **
     >                      ((GHZ-ZUS(JG)) / (ZUS(JG+1)-ZUS(JG)))
  200     CONTINUE
        ENDIF
        DO 210 I=1,NMAJ
        ZCOL(I,J) = 2. * ZCG(I) * CHAP(PI/2.,GHZ,TNG,I)
     >              - ZVCD(I,J) * CHAP(CHI,ZZ(J),TN(J),I)
  210   CONTINUE
  220   CONTINUE
      ENDIF
      END SUBROUTINE RCOLUM


      real FUNCTION CHAP (CHI, Z, T, I)
!      use cglow,only: nmaj,pi,Re,G
      implicit none
      include 'cglow.h'
!Args:
      real,intent(in) :: chi,z,t
      integer,intent(in) :: I
!Local:
      real AM(nmaj)
      real gr,hn,hg,hf,sqhf,SPERFC 

      DATA AM/16., 32., 28./

      GR=G*(RE/(RE+Z))**2 
      HN=1.38E-16*T/(AM(I)*1.662E-24*GR)
      HG=(RE+Z)/HN 
      HF=0.5*HG*(COS(CHI)**2) 
      SQHF=SQRT(HF) 
      CHAP=SQRT(0.5*PI*HG)*SPERFC(SQHF) 
      End Function CHAP


      pure real FUNCTION SPERFC(DUMMY) 
      implicit none
      real,intent(in) :: dummy
      IF (DUMMY .LE. 8.) THEN
        SPERFC = (1.0606963+0.55643831*DUMMY) /
     >           (1.0619896+1.7245609*DUMMY+DUMMY*DUMMY)
      ELSE
        SPERFC=0.56498823/(0.06651874+DUMMY) 
      ENDIF 

      END function sperfc


      SUBROUTINE VCD(ZZ,ZMAJ,ZVCD)
!      use cglow,only: nmaj,jmax
      implicit none
      include 'cglow.h'
! Args:
      real,intent(in) :: zz(jmax),zmaj(NMAJ,JMAX)
      real,intent(out) :: ZVCD(NMAJ,JMAX)
! Local:
      real rat
      integer i, j

      DO 200 I=1,NMAJ
      ZVCD(I,JMAX) =   ZMAJ(I,JMAX)
     >               * (ZZ(JMAX)-ZZ(JMAX-1))
     >               / LOG(ZMAJ(I,JMAX-1)/ZMAJ(I,JMAX))
      DO 200 J=JMAX-1,1,-1
      RAT = ZMAJ(I,J+1) / ZMAJ(I,J)
      ZVCD(I,J) =   ZVCD(I,J+1)
     >            + ZMAJ(I,J) * (ZZ(J)-ZZ(J+1)) / LOG(RAT) * (1.-RAT)
  200 CONTINUE
      END Subroutine VCD

! WARNING: THIS FUNCTION IS KNOWN TO BE BROKEN and gives erroneous results MH 8/2015

! Subroutine VQUART
!
! This software is part of the GLOW model.  Use is governed by the Open Source
! Academic Research License Agreement contained in the file glowlicense.txt.
! For more information see the file glow.txt.
!
! TGCM routine obtained from C. Ridley, 9/88.
! Modified by Stan Solomon, 11/88, 5/91.
!
! Determines positive roots of equations of form:
! A(I,5)*X**4 + A(I,4)*X**3 + A(I,3)*X**2 + A(I,2)*X + A(I,1) = 0 
! It is specifically designed for real quartics with real roots,
! only one of which is positive.
! Coefficients of quartics supplied in array A(JMAX,5).
! Positive roots returned in ROOT(JMAX) for I from 1 to NJ.
! W1, W2, W3, W4, W5 are working arrays.
!
!
      SUBROUTINE VQUART (A, ROOT, NJ)
!      use cglow,only: jmax,dp
      implicit none
      include 'cglow.h'
! Args
      Real(kind=dp),intent(out) :: ROOT(JMAX)
      Real(kind=dp),intent(in)  :: A(JMAX,5)
      Integer,intent(in)        :: NJ
! Local
      Integer I
      Real(kind=dp) W1(JMAX), W2(JMAX), W3(JMAX), W4(JMAX), W5(JMAX)
      real(kind=dp),parameter :: E=1.D-38, Z=0.

      DO 200 I=1,NJ
        W1(I)=-(A(I,5)*A(I,1)-4.D0*A(I,4)*A(I,2)+3.D0*A(I,3)**2) / 12.D0
        W2(I) = ( A(I,5)*(A(I,3)*A(I,1)-A(I,2)**2)
     >          -A(I,4)*(A(I,4)*A(I,1)-A(I,2)*A(I,3))
     >          +A(I,3)*(A(I,4)*A(I,2)-A(I,3)**2)    ) / 4.D0
        W4(I)= -2.D0*DREAL(  ( (DCMPLX(W2(I),Z)
     >               +CDSQRT(DCMPLX(W2(I)**2+4.D0*W1(I)**3+E,Z)))/2.D0
     >                 +DCMPLX(E,Z) )**(1.D0/3.D0)  )
        W1(I) = A(I,5)*W4(I) + A(I,4)**2 - A(I,5)*A(I,3) + E
        IF (W1(I) .LE. E) W1(I) = E
        W1(I) = SQRT(W1(I))
        W2(I) = (2.D0*W4(I)+A(I,3))**2 - A(I,5)*A(I,1)
        IF (W2(I) .LE. E) W2(I) = E
        W2(I) = SQRT(W2(I))
        W3(I) = 2.D0*A(I,4)*W4(I) + A(I,4)*A(I,3) - A(I,5)*A(I,2) + E
        W1(I) = SIGN(W1(I),W2(I)*W3(I))
        W3(I) = W1(I)-A(I,4)
        W5(I) = W3(I)**2 - A(I,5)*(A(I,3)+2.D0*W4(I)-W2(I))
        IF (W5(I) .LE. E) W5(I) = E
        ROOT(I) = (W3(I)+SQRT(W5(I))) / A(I,5)
200   CONTINUE
    
      END Subroutine VQUART

C Subroutine QBACK
C
C This software is part of the GLOW model.  Use is governed by the Open Source
C Academic Research License Agreement contained in the file glowlicense.txt.
C For more information see the file glow.txt.
C
C Stan Solomon, 11/88, 11/92
C Comment updated 3/05
C
C Estimates background ("nighttime") ionization rates.
C Intended to conform to the TIGCM background (Roble et al., 1989).
C Three fluxes, from the stellar background and multiple scattering
C of solar atomic hydrogen emissions in the geocorona, are considered:
C The sum of ionizing flux in the 100-1000 A range (FIONT)
C H Lyman beta (FLYBT)
C H Ly alpha (FLYAT)
C
      SUBROUTINE QBACK (ZMAJ, ZNO, ZVCD, PHOTOI, PHONO)
!      use cglow,only: nmaj,jmax,nst
      implicit none
      include 'cglow.h'
!Args:
      real, intent(in) :: ZMAJ(NMAJ,jmax),ZNO(jmax),ZVCD(NMAJ,jmax)
      !PHOTI and PHONO should be INOUT
      real,intent(inout)::PHOTOI(NST,NMAJ,jmax), PHONO(NST,jmax)
!Local:
      real,parameter :: FIONT=5.0E7, FLYBT=1.0E7, FLYAT=1.0E9,
     & SIGIO=1.0E-17,
     & SIGIO2=2.0E-17, SIGIN2=2.0E-17, SLBAO2=1.6E-18, SLBIO2=1.0E-18,
     & SLAAO2=1.0E-20, SLAINO=2.0E-18
      real taui, taulya,taulyb, fion
      integer j
C
C Calculate ionization rates at each altitude:
C
      DO 200 J=1,JMAX
        TAUI = 2.*(SIGIO*ZVCD(1,J)+SIGIO2*ZVCD(2,J)+SIGIN2*ZVCD(3,J))
        IF (TAUI .GT. 60.) TAUI = 60.
        TAULYB = 2.*SLBAO2*ZVCD(2,J)
        IF (TAULYB .GT. 60.) TAULYB = 60.
        TAULYA = 2.*SLAAO2*ZVCD(2,J)
        IF (TAULYA .GT. 60.) TAULYB = 60.
        FION = FIONT * EXP(-TAUI)
        PHOTOI(1,1,J) = PHOTOI(1,1,J) + FION * ZMAJ(1,J) * SIGIO
        PHOTOI(1,2,J) = PHOTOI(1,2,J) + FION * ZMAJ(2,J) * SIGIO2
     +                  + FLYBT * EXP(-TAULYB) * ZMAJ(2,J) * SLBIO2
        PHOTOI(1,3,J) = PHOTOI(1,3,J) + FION * ZMAJ(3,J) * SIGIN2
        PHONO(1,J) = PHONO(1,J) + FLYAT * EXP(-TAULYA) * ZNO(J) * SLAINO
  200 CONTINUE
C
      END SUBROUTINE QBACK

C Subroutine EXSECT
C
C This software is part of the GLOW model.  Use is governed by the Open Source
C Academic Research License Agreement contained in the file glowlicense.txt.
C For more information see the file glow.txt.
C
C Adapted from Banks & Nagy 2-stream code by Stan Solomon, 1988
C Added high-energy relativistic cross section correction, SCS, 1999
C Updated comments, SCS, 2002
C Included in GLOW v. 0.97, SCS, 2005
C
C Calculates electron impact cross sections
C
C Definitions:
C SIGS   elastic cross sections for each species, energy; cm2
C PE     elastic backscatter probabilities for each species, energy
C PI     inelastic  "
C SIGA   energy loss cross section for each species, loss, energy; cm2
C SEC    secondary production xsect for species, Esec, Epri; cm2
C SIGEX  excitation xsect for each state, species, energy; cm2
C     O states:   1D,   1S, 3s5S, 3s3S, 3p5P, 3p3P, 3d3D, 3s'3D
C     O2 states:   a,    b, AA'c,    B,  9.9, Ryds,  vib
C     N2 states: ABW,   B',    C, aa'w,  1Pu,   b', Ryds,  vib
C SIGIX  ionization xsect for each state, species, energy; cm2
C     O states:   4S,  2Do,  2Po
C     O2 states:   X,    a,    A,    b,    B,   c,  37eV
C     N2 states:   X,    A,    B,    D,    C, 40eV
C IIMAX  number of bins for secondary production for each primary energy
C WW     energy threshold for each excited state, species; eV
C WW, AO, OMEG, ANU, BB: revised excitation cross section parameters,
C        from Green & Stolarski (1972) formula (W, A, omega, nu, gamma)
C AUTO   autoionization coefs (= 0 as autoion. included in ion xsects)
C THI    energy threshold for each ionized state, species; eV
C AK, AJ, TS, TA, TB, GAMS, GAMB:  Jackman et al (1977) ioniz. params
C ENER   energy grid; eV
C DEL    energy grid spacing; eV
C NNN    number of excited states for each species
C NINN   number of ionized states for each species
C NUM    number of points on elastic data trid for each species
C EC     data energy grid of elastic xsects and backscatter ratios
C        for each species; eV
C CC     elastic xsects on data grid for each species, cm2
C CE     elastic backscat. probs on data grid for each species; cm2
C CI     inelastic "
C
C Array dimensions:
C NBINS  number of energy levels
C NMAJ   number of major species
C NEI    number of slots for excited and ionized states
C
C
      SUBROUTINE EXSECT (ENER, DEL)
!      use cglow,only: nmaj,nei,nbins
      implicit none
      include 'cglow.h'

! Args:
      real,intent(in) :: ENER(NBINS),DEL(NBINS)
! Local:
      integer inv !function
      integer  IIMAXX(NBINS)
      real  AE,sigion
      real  SIGS(NMAJ,NBINS), PE(NMAJ,NBINS), PIN(NMAJ,NBINS),
     >                SIGA(NMAJ,NBINS,NBINS), SEC(NMAJ,NBINS,NBINS),
     >                SIGEX(NEI,NMAJ,NBINS), SIGIX(NEI,NMAJ,NBINS),
     &    WW(NEI,NMAJ), AO(NEI,NMAJ), OMEG(NEI,NMAJ),
     >                ANU(NEI,NMAJ), BB(NEI,NMAJ), AUTO(NEI,NMAJ),
     >                THI(NEI,NMAJ),  AK(NEI,NMAJ),   AJ(NEI,NMAJ),
     >                TS(NEI,NMAJ),   TA(NEI,NMAJ),   TB(NEI,NMAJ),
     >                GAMS(NEI,NMAJ), GAMB(NEI,NMAJ)

      real SIGI(NBINS), T12(NBINS),
     > RATIO(NBINS), EC(31,NMAJ), CC(31,NMAJ), CE(31,NMAJ), CI(31,NMAJ),
     > detj,e1,e2,eta,etj,ex,fac,ff,gama,sigg,t0,tmax,tmt,wag,we,wth1
      integer i,i1,i2,i3,ibz,ie,iee,ii,ij,itmax,iv,j,jy,k,kk,kuk,kuk1,
     > ml

      COMMON /CXSECT/ SIGS, PE, PIN, SIGA, SEC, SIGEX, SIGIX, IIMAXX

      COMMON /CXPARS/ WW, AO, OMEG, ANU, BB, AUTO,THI, AK, AJ,
     >                TS, TA, TB, GAMS, GAMB

      real,parameter :: QQN=6.51E-14
      integer NNN(NMAJ), NINN(NMAJ), NUM(NMAJ)

      DATA NNN/8,7,8/
      DATA NINN/3,7,6/
      DATA NUM/31,28,28/
C
      DATA WW  /1.96, 4.17, 9.29, 9.53,10.76,10.97,12.07,12.54, 0.,0.,
     >          0.98, 1.64, 4.50, 8.44, 9.90,13.50, 0.25, 0.00, 0.,0.,
     >          6.17, 8.16,11.03, 8.40,12.85,14.00,13.75, 1.85, 0.,0./
      DATA AO /.0100,.0042,.1793,.3565,.0817,.0245,.0293,.1221, 0.,0.,
     >         .0797,.0211,.0215,.3400,.0657,1.110,3.480, 0.00, 0.,0.,
     >         2.770,.1140,.1790,.0999,.8760,.6010,1.890,1.350, 0.,0./
      DATA OMEG/1.00, 1.00, 3.00, 0.75, 3.00, 0.85, 0.75, 0.75, 0.,0.,
     >          2.00, 2.00, 1.15, 0.75, 0.75, 0.75, 7.00, 0.00, 0.,0.,
     >          3.00, 3.00, 3.00, 1.00, 0.75, 0.75, 0.75, 8.00, 0.,0./
      DATA ANU /2.00, 1.04, 2.53, 0.54, 2.43, 2.87, 0.93, 0.72, 0.,0.,
     >          6.18, 4.14, 1.00, 1.05, 1.60, 3.00,10.87, 0.00, 0.,0.,
     >          4.53, 4.78, 4.32, 4.05, 1.47, 1.27, 3.00, 1.58, 0.,0./
      DATA BB / 1.00, 0.50, 1.02, 0.01, 4.19, 4.88, 0.66, 0.17, 0.,0.,
     >          0.53, 0.51, 0.98, 0.99, 1.86, 1.00, 1.00, 0.00, 0.,0.,
     >          1.42, 3.54,12.70, 5.20, 0.86, 0.45, 1.00, 1.00, 0.,0./
      DATA AUTO/30*0.0/
      DATA THI/13.60,16.90,18.50, 0.00, 0.00, 0.00, 0.00, 0.,0.,0.,
     >         12.10,16.10,16.90,18.20,20.00,23.00,37.00, 0.,0.,0.,
     >         15.58,16.73,18.75,22.00,23.60,40.00, 0.00, 0.,0.,0./
      DATA AK / 1.13, 1.25, 0.67, 0.00, 0.00, 0.00, 0.00, 0.,0.,0.,
     >          0.47, 1.13, 1.13, 1.01, 0.65, 0.95, 0.59, 0.,0.,0.,
     >          2.42, 1.06, 0.55, 0.37, 0.37, 0.53, 0.00, 0.,0.,0./
      DATA AJ / 1.81, 1.79, 1.78, 0.00, 0.00, 0.00, 0.00, 0.,0.,0.,
     >          3.76, 3.76, 3.76, 3.76, 3.76, 3.76, 3.76, 0.,0.,0.,
     >          1.74, 1.74, 1.74, 1.74, 1.74, 1.74, 0.00, 0.,0.,0./
      DATA TS / 6.41, 6.41, 6.41, 0.00, 0.00, 0.00, 0.00, 0.,0.,0.,
     >          1.86, 1.86, 1.86, 1.86, 1.86, 1.86, 1.86, 0.,0.,0.,
     >          4.71, 4.71, 4.71, 4.71, 4.71, 4.71, 0.00, 0.,0.,0./
      DATA TA /3450.,3450.,3450.,   0.,   0.,   0.,   0., 0.,0.,0.,
     >         1000.,1000.,1000.,1000.,1000.,1000.,1000., 0.,0.,0.,
     >         1000.,1000.,1000.,1000.,1000.,1000.,   0., 0.,0.,0./
      DATA TB/162.00,162.0,162.0, 0.00, 0.00, 0.00, 0.00, 0.,0.,0.,
     >         24.20,32.20,33.80,36.40,40.60,46.00,74.00, 0.,0.,0.,
     >         31.16,33.46,37.50,44.00,47.20,80.00, 0.00, 0.,0.,0./
      DATA GAMS/13.00,13.0,13.00, 0.00, 0.00, 0.00, 0.00, 0.,0.,0.,
     >          18.50,18.5,18.50,18.50,18.50,18.50,18.50, 0.,0.,0.,
     >          13.80,13.8,13.80,13.80,13.80,13.80, 0.00, 0.,0.,0./
      DATA GAMB/-.815,-.815,-.815,0.00, 0.00, 0.00, 0.00, 0.,0.,0.,
     >          12.10,16.10,16.90,18.2,20.30,23.00,37.00, 0.,0.,0.,
     >          15.58,16.73,18.75,22.0,23.60,40.00, 0.00, 0.,0.,0./
      DATA EC /      1.00,     2.00,     4.00,     6.00,     8.00,
     >              10.00,    12.00,    14.00,    16.00,    18.00,
     >              20.00,    30.00,    40.00,    50.00,    60.00,
     >              70.00,    80.00,    90.00,   100.00,   150.00,
     >             200.00,   300.00,   500.00,  1000.00,  2000.00,
     >            3000.00,  5000.00, 10000.00, 20000.00, 40000.00,
     >           50000.00,
     >               1.00,     2.00,     3.00,     5.00,     7.00,
     >              10.00,    15.00,    20.00,    30.00,    40.00,
     >              50.00,    70.00,   100.00,   150.00,   200.00,
     >             300.00,   400.00,   500.00,   600.00,   700.00,
     >            1000.00,  2000.00,  3000.00,  5000.00, 10000.00,
     >           20000.00, 40000.00, 50000.00,     0.00,     0.00,
     >               0.00,
     >               1.00,     2.00,     2.50,     3.00,     4.00,
     >               5.00,     6.00,     8.00,    10.00,    15.00,
     >              20.00,    30.00,    40.00,    50.00,    70.00,
     >             100.00,   200.00,   300.00,   500.00,   700.00,
     >            1000.00,  2000.00,  3000.00,  5000.00, 10000.00,
     >           20000.00, 40000.00, 50000.00,     0.00,     0.00, 0.0/
      DATA CC /  5.00E-16, 6.00E-16, 7.50E-16, 7.60E-16, 7.70E-16,
     >           7.80E-16, 7.50E-16, 7.20E-16, 6.90E-16, 6.70E-16,
     >           6.50E-16, 5.60E-16, 4.60E-16, 4.00E-16, 3.50E-16,
     >           3.20E-16, 2.90E-16, 2.70E-16, 2.50E-16, 1.90E-16,
     >           1.50E-16, 1.20E-16, 8.00E-17, 5.00E-17, 3.02E-17,
     >           1.99E-17, 1.20E-17, 6.08E-18, 3.06E-18, 1.55E-18,
     >           1.24E-18,
     >           5.50E-16, 6.90E-16, 7.50E-16, 8.50E-16, 9.60E-16,
     >           1.00E-15, 1.00E-15, 9.00E-16, 8.30E-16, 7.70E-16,
     >           6.90E-16, 5.70E-16, 4.40E-16, 3.30E-16, 2.70E-16,
     >           2.10E-16, 1.80E-16, 1.60E-16, 1.40E-16, 1.30E-16,
     >           1.10E-16, 7.00E-17, 5.00E-17, 3.00E-17, 1.53E-17,
     >           7.72E-18, 3.90E-18, 3.13E-18, 0.00E+00, 0.00E+00,
     >           0.00E+00,
     >           9.00E-16, 2.27E-15, 2.52E-15, 1.93E-15, 1.32E-15,
     >           1.15E-15, 1.16E-15, 1.17E-15, 1.18E-15, 1.14E-15,
     >           1.13E-15, 9.50E-16, 8.60E-16, 7.30E-16, 5.90E-16,
     >           4.70E-16, 3.30E-16, 2.50E-16, 1.60E-16, 1.30E-16,
     >           1.10E-16, 6.35E-17, 4.18E-17, 2.54E-17, 1.28E-17,
     >           6.44E-18, 3.27E-18, 2.62E-18, 0.00E+00, 0.00E+00, 0.0/
      DATA CE /   0.50000,  0.49500,  0.46800,  0.43600,  0.42000,
     >            0.40500,  0.37000,  0.36000,  0.34000,  0.33000,
     >            0.32000,  0.27000,  0.24000,  0.22000,  0.20000,
     >            0.18000,  0.17000,  0.16000,  0.15000,  0.13000,
     >            0.11500,  0.09000,  0.06800,  0.04600,  0.02400,
     >            0.01660,  0.01000,  0.00510,  0.00255,  0.00125,
     >            0.00100,
     >            0.50000,  0.50000,  0.49000,  0.44500,  0.42700,
     >            0.40500,  0.36800,  0.34300,  0.31600,  0.28900,
     >            0.25800,  0.22000,  0.18400,  0.16400,  0.13300,
     >            0.11000,  0.10000,  0.09200,  0.08500,  0.08000,
     >            0.06800,  0.03700,  0.02600,  0.01600,  0.00800,
     >            0.00400,  0.00200,  0.00160,  0.00000,  0.00000,
     >            0.00000,
     >            0.50000,  0.50000,  0.50000,  0.49000,  0.46800,
     >            0.44500,  0.43600,  0.42000,  0.40500,  0.36800,
     >            0.34300,  0.31600,  0.28900,  0.25800,  0.22000,
     >            0.18400,  0.14000,  0.11000,  0.08400,  0.07400,
     >            0.06300,  0.03400,  0.02400,  0.01500,  0.00740,
     >            0.00370,  0.00180,  0.00140,  0.00000,  0.00000, 0.0/
      DATA CI /   0.60000,  0.60000,  0.60000,  0.60000,  0.60000,
     >            0.60000,  0.55000,  0.46000,  0.40000,  0.36000,
     >            0.32000,  0.22000,  0.15000,  0.10000,  0.08200,
     >            0.07000,  0.06100,  0.05400,  0.05000,  0.04400,
     >            0.03800,  0.02800,  0.02000,  0.01050,  0.00600,
     >            0.00400,  0.00250,  0.00130,  0.00060,  0.00030,
     >            0.00025,
     >            0.50000,  0.50000,  0.50000,  0.50000,  0.48000,
     >            0.44000,  0.36000,  0.28000,  0.20000,  0.14000,
     >            0.10000,  0.07000,  0.05000,  0.04600,  0.04300,
     >            0.03700,  0.03200,  0.02800,  0.02400,  0.02100,
     >            0.01600,  0.00900,  0.00620,  0.00400,  0.00200,
     >            0.00100,  0.00050,  0.00040,  0.00000,  0.00000,
     >            0.00000,
     >            0.50000,  0.50000,  0.50000,  0.50000,  0.50000,
     >            0.50000,  0.50000,  0.50000,  0.50000,  0.50000,
     >            0.44000,  0.30000,  0.20000,  0.13000,  0.09000,
     >            0.06000,  0.05000,  0.04200,  0.03200,  0.02500,
     >            0.02000,  0.01100,  0.00800,  0.00500,  0.00250,
     >            0.00120,  0.00060,  0.00050,  0.00000,  0.00000, 0.0/
C
C
C Interpolate elastic cross sections and backscatter ratios:
C
      DO 90 IJ=1,NMAJ
        DO  80 IV=1,NBINS
          EX=ENER(IV)
          DO 50 II=1,NUM(IJ)
            IF (EC(II,IJ) .GT. EX) GOTO 60
   50     CONTINUE
          SIGS(IJ,IV)=CC(NUM(IJ),IJ)*(EC(NUM(IJ),IJ)/EX)**0.8
          IF(IJ.EQ.1) SIGS(IJ,IV)=CC(NUM(IJ),IJ)*(EC(NUM(IJ),IJ)/EX)**2
          PE(IJ,IV) = CE(NUM(IJ),IJ)* (EC(NUM(IJ),IJ)/EX)
          PIN(IJ,IV) = CI(NUM(IJ),IJ)* (EC(NUM(IJ),IJ)/EX)
          GOTO 80
   60     I=II-1
          IF (I .LE. 0) THEN
            SIGS(IJ,IV)=CC(II,IJ)
            PE(IJ,IV)=CE(II,IJ)
            PIN(IJ,IV)=CI(II,IJ)
          ELSE
            FAC = log (EX/EC(I,IJ)) / log (EC(II,IJ)/EC(I,IJ))
            SIGS(IJ,IV) = EXP (log (CC(I,IJ))
     >                         + log (CC(II,IJ)/CC(I,IJ)) * FAC)
            PE(IJ,IV) = EXP (log (CE(I,IJ))
     >                       + log (CE(II,IJ)/CE(I,IJ)) * FAC)
            PIN(IJ,IV) = EXP (log (CI(I,IJ))
     >                       + log (CI(II,IJ)/CI(I,IJ)) * FAC)
          ENDIF
   80   CONTINUE
   90 CONTINUE
C
C
C Calculate electron impact excitation and ionization cross sections:
C
      DO 140 I=1,NMAJ
        DO 140 K=1,NEI
          DO 140 J=1,NBINS
          IF (ENER(J).GT.WW(K,I) .AND. WW(K,I).GT.0.001) THEN
            WE = WW(K,I) / ENER(J)
            SIGEX(K,I,J) = QQN * AO(K,I)
     >                       * (WE**OMEG(K,I) / WW(K,I)**2)
     >                       * (1.0 - WE**BB(K,I)) ** ANU(K,I)
            IF (SIGEX(K,I,J) .LT. 1.E-30) SIGEX(K,I,J) = 0.0
          ELSE
            SIGEX(K,I,J) = 0.0
          ENDIF
          IF (ENER(J).GT.THI(K,I) .AND. THI(K,I).GT.0.001) THEN
            AE = AK(K,I)/ENER(J) * log(ENER(J)/AJ(K,I))
            GAMA = GAMS(K,I) * ENER(J) / (ENER(J)+GAMB(K,I))
            T0 = TS(K,I) - (TA(K,I)/(ENER(J)+TB(K,I)))
            SIGIX(K,I,J) = 1.E-16 * AE * GAMA
     >                    * ( ATAN(((ENER(J)-THI(K,I))/2.-T0)/GAMA)
     >                       +ATAN(T0/GAMA) )
            IF (SIGIX(K,I,J) .LT. 1.E-30) SIGIX(K,I,J) = 0.0
          ELSE
            SIGIX(K,I,J) = 0.0
          ENDIF
  140 CONTINUE
C
C
C Obtain high-energy correction factors:
C
      CALL HEXC(ENER,SIGIX,RATIO)
      DO 142 J=1,NBINS
        DO 142 I=1,NMAJ
          DO 142 K=1,NEI
            SIGIX(K,I,J)=SIGIX(K,I,J)/RATIO(J)
  142 CONTINUE
C
C
C Zero energy loss xsect and secondary production xsect arrays:
C
      DO 145 I1=1,NMAJ
      DO 145 I2=1,NBINS
      DO 145 I3=1,NBINS
        SIGA(I1,I2,I3)=0.0
        SEC(I1,I2,I3)=0.0
  145 CONTINUE
C
C
C Loop over energy:
C
      DO 500 JY=1,NBINS
C
      KUK=0
      KUK1=0
      ETJ=ENER(JY)
      DETJ=DEL(JY)
C
C
C Loop over species:
C
      DO 400 I=1,NMAJ
C
C
C Loop over excited states:
C
      DO 200 J=1,NNN(I)
C
C
C Calculate energy loss from JY to J-K for each species.
C The cross secton is divided proportionally between bin INV and bin
C INV-1, the two bins closest to J-K:
C
      SIGG = SIGEX(J,I,JY)
      ETA = ETJ - WW(J,I)
      IF (ETA .GT. 0.) THEN
        IE = INV (ETA,JY,ENER)
        IEE = IE - 1
        IF (IEE .LT. 1) IEE=IE
        K = JY - IE
        KK = JY - IEE
        IF (KK .GE. KUK) KUK = KK
        IF (IE .EQ. JY) THEN
          IF (JY .EQ. 1) THEN
            SIGA(I,1,JY) = SIGA(I,1,JY) + SIGG
          ELSE
            SIGA(I,1,JY) = SIGA(I,1,JY) + SIGG * (DETJ/DEL(JY-1))
     >                    * WW(J,I) / (ENER(JY)-ENER(JY-1))
          ENDIF
        ELSE
          IF (IE .EQ. 1) THEN
C           SIGA(I,K,JY) = SIGA(I,K,JY) + SIGG * 2.*ETA*DETJ/DEL(1)**2
            SIGA(I,K,JY) = SIGA(I,K,JY) + SIGG * DETJ/DEL(1)
          ELSE
            FF = (ENER(IE)-ETA) / (ENER(IE)-ENER(IEE))
            FF = 1.0 - ABS(FF)
            SIGA(I,K,JY) = SIGA(I,K,JY) + SIGG * FF * DETJ/DEL(IE)
            SIGA(I,KK,JY)= SIGA(I,KK,JY) + SIGG * (1.0-FF)*DETJ/DEL(IEE)
          ENDIF
          WAG=WW(J,I)-THI(1,I)
          IF (WAG .GT. 0. .AND. AUTO(J,I) .GT. 0.) THEN
            IBZ = INV (WAG,JY,ENER)
            SEC(I,IBZ,JY) = SEC(I,IBZ,JY)+SIGG*(DETJ/DEL(IBZ))*AUTO(J,I)
            IF(IBZ.GE.KUK1)KUK1=IBZ
          ENDIF
        ENDIF
      ENDIF
  200 CONTINUE
C
C
C Loop over ion states:
C
      DO 300 ML=1,NINN(I)
C
      DO 210 II=1,NBINS
      SIGI(II) = 0.0
      T12(II) = 0.0
  210 CONTINUE
C
C
C Calculate cross-section for production of secondaries into each
C bin from 1 to ITMAX and store in SIGI(II).  Apply relativistic correction.
C Also store the average energy of the secondaries in T12(II):
C
      WAG = THI(ML,I)
      TMAX = (ETJ-WAG) / 2.
      if (tmax .gt. 1.e6) tmax=1.e6
      IF (TMAX .LE. 0.) GOTO 300
      ITMAX = INV (TMAX,JY,ENER)
      IF (ITMAX .GE. KUK1) KUK1 = ITMAX + 1
      TMT = ENER(1) + DEL(1) / 2.0
      IF (TMAX .LT. TMT) TMT = TMAX
      SIGI(1) = SIGION(I,ML,ETJ,0.0,TMT,T12(1)) / RATIO(JY)
      TMT = ENER(1) + DEL(1) / 2.
      IF (TMAX .GT. TMT) THEN
        IF (TMAX .LE. ENER(2)) ITMAX = 2
        DO 220 II=2,ITMAX
        E1 = ENER(II) - DEL(II) / 2.
        E2 = E1 + DEL(II)
        IF (E2 .GT. TMAX) E2 = TMAX
        IF(E1 .LE. E2)SIGI(II)=SIGION(I,ML,ETJ,E1,E2,T12(II))/RATIO(JY)
  220   CONTINUE
      ENDIF
C
C
C Add the secondary production cross-section to SEC; calculate
C the ionization energy loss cross-section and add to SIGA:
C
      DO 250 II=1,ITMAX
      SEC(I,II,JY) = SEC(I,II,JY) + SIGI(II) * DETJ / DEL(II)
      if (isnan(sec(i,ii,jy))) stop 'exsect: NaN in SEC'
      WTH1 = T12(II) + WAG
      ETA = ETJ - WTH1
      IF (ETA .GT. 0.) THEN
        IE = INV (ETA,JY,ENER)
        IEE = IE - 1
        K = JY - IE
        KK = JY - IEE
        IF (IEE .LT. 1) IEE = IE
        IF (IE .EQ. JY) THEN
          SIGA(I,1,JY) = SIGA(I,1,JY) + SIGI(II) * (DETJ/DEL(JY-1))
     >                  * WTH1 / (ENER(JY)-ENER(JY-1))
        ELSE
          IF (KK .GE. KUK) KUK = KK
          IF (IE .EQ. 1) THEN
C           SIGA(I,K,JY) = SIGA(I,K,JY)+2.*ETA*SIGI(II)*DETJ/DEL(1)**2
            SIGA(I,K,JY) = SIGA(I,K,JY)+SIGI(II)*DETJ/DEL(1)
          ELSE
            FF = (ENER(IE)-ETA) / (ENER(IE)-ENER(IEE))
            FF = 1.0 - ABS(FF)
            SIGA(I,K,JY) = SIGA(I,K,JY) + FF*SIGI(II)*DETJ/DEL(IE)
            SIGA(I,KK,JY)=SIGA(I,KK,JY)+(1.0-FF)*SIGI(II)*DETJ/DEL(IEE)
          ENDIF
        ENDIF
      ENDIF
C
  250 CONTINUE
C
  300 CONTINUE
C
  400 CONTINUE
C
      IIMAXX(JY) = KUK1
C
  500 CONTINUE
C
      END SUBROUTINE EXSECT
C
C
C
C
C Function SIGION calculates ionization cross section for species I,
C state ML, primary energy E, secondary energy from E1 to E2 
C
      real FUNCTION SIGION(I,ML,E,E1,E2,T12)
!      use cglow,only: nei,nmaj,dp
      implicit none
      include 'cglow.h'
! Args:
      integer,intent(in) :: i,ml
      real,intent(in) :: E,E1
! yes this is out
      real,intent(out) :: T12 
! the out value isn't actually used, but needed to allow internal modif.
      real,intent(inout) :: E2 
! Local:
      Real(kind=dp)  ABB, ABC, ABD, AK1, AJ1, TS1, TA1, TB1,GAMS1,GAMB1
      Real S,A,TZ,GG,TTL,AL2,AL1,TTL1

      real WW(NEI,NMAJ), AO(NEI,NMAJ), OMEG(NEI,NMAJ),
     >                ANU(NEI,NMAJ), BB(NEI,NMAJ), AUTO(NEI,NMAJ),
     >                THI(NEI,NMAJ),  AK(NEI,NMAJ),   AJ(NEI,NMAJ),
     >                TS(NEI,NMAJ),   TA(NEI,NMAJ),   TB(NEI,NMAJ),
     >                GAMS(NEI,NMAJ), GAMB(NEI,NMAJ)

      COMMON /CXPARS/ WW, AO, OMEG, ANU, BB, AUTO,THI, AK, AJ,
     >                TS, TA, TB, GAMS, GAMB


      real,parameter:: QQ=1.E-16
C
C
      IF (E .LE. THI(ML,I)) GOTO 30
C
      AK1=AK(ML,I)
      AJ1=AJ(ML,I)
      TS1=TS(ML,I)
      TA1=TA(ML,I)
      TB1=TB(ML,I)
      GAMS1=GAMS(ML,I)
      GAMB1=GAMB(ML,I)
      S=QQ*AK1*log(E/AJ1)
      A=S/E
      TZ=TS1-TA1/(E+TB1)
      GG=(GAMS1*E)/(E+GAMB1)
      TTL=(E-THI(ML,I))/2.0
      TTL1=TTL-0.01
      IF(E1.GE.TTL1)GO TO 30
      IF(E2.GE.TTL)E2=TTL
      ABB=(E2-TZ)/GG
      ABC=(E1-TZ)/GG
      AL2=GG*GG*(ABB*ABB+1.0)
      AL1=GG*GG*(ABC*ABC+1.0)
      ABD=ATAN(ABB)-ATAN(ABC)
      T12=TZ+0.5*GG*(log(AL2)-log(AL1))/ABD
      SIGION=A*GG*ABD
      RETURN
C
   30 SIGION=0.0
      END function sigion
C
C
C
C
C Function INV finds the bin number closest to energy ETA on grid ENER.
C Bin INV or INV-1 will contain ETA.
C
      pure integer FUNCTION INV (ETA, JY, ENER)
!      use cglow,only: nbins
      implicit none
      include 'cglow.h'
!
! Args:
      real,intent(in) :: ETA,ENER(NBINS)
      integer,intent(in) :: JY
! Local:
      integer iv
      
      IF (ETA .LT. 0.) THEN
        INV = -1
      ELSE
        DO 30 IV=1,JY
          IF (ETA .LE. ENER(IV)) GOTO 40
   30   CONTINUE
        IV = JY
   40   INV = IV
      ENDIF
C
      END function inv
C
C
C
C
C Subroutine HEXC
C
C High Energy Cross Section Correction
C Calculates ratio of low energy (non-relativistic) to high energy
C (relativistic) ionization cross sections, based on N2.
C Extends to 1 GeV.
C
C Originally coded by Ann Windnagel, 11/98
C Re-written by Stan Solomon, 2/99
C Re-designed with table lookup, SCS, 4/99
C Updated comments, SCS, 4/02
C References:
C   Porter et al., J. Chem. Phys., 65, 154, 1976.
C   Rieke and Prepejchal, Phys. Rev. A, 6, 1507, 1990.
C   Saksena et al., Int. Jour. of Mass Spec. & Ion Proc., 171, L1, 1997.


      SUBROUTINE HEXC(ENER,SIGIX,RATIO)
!      use cglow,only: nmaj,nei,nbins
      implicit none
      include 'cglow.h'
!
! Args:
      real,intent(in) :: ENER(NBINS),SIGIX(NEI,NMAJ,NBINS)
      real,intent(out) :: RATIO(NBINS)
!
! Local:
      real  TOTX(NBINS), TOTNEW(NBINS), EGR(13), SGR(13)
      integer  k,i,kg
      real :: TERPOO !function
      DATA EGR/1.E4,      2.E4,      5.E4,      1.E5,      2.E5,
     >         3.E5,      5.E5,      1.E6,      2.E6,      5.E6,
     >         1.E7,      1.E8,      1.E9/
      DATA SGR/1.20E-17,  7.03E-18,  3.37E-18,  1.96E-18,  1.26E-18,
     >         1.05E-18,  9.50E-19,  9.00E-19,  9.00E-19,  9.40E-19,
     >         1.00E-18,  1.26E-18,  1.59E-18/


C Calculate total low-energy cross section for N2:

      DO 20 K = 1,NBINS
        TOTX(K) = 0.
        DO 20 I = 1,NEI
          TOTX(K) = TOTX(K) + SIGIX(I,3,K)
   20 CONTINUE


C Calculate high-energy cross section for N2, using tabulated values:

      DO 70 K=1,NBINS
        IF (ENER(K) .GE. EGR(1)) THEN
        DO 60 KG=1,12
          IF (ENER(K) .GE. EGR(KG) .AND. ENER(K) .LT. EGR(KG+1))
     >    TOTNEW(K)=TERPOO(ENER(K),EGR(KG),EGR(KG+1),SGR(KG),SGR(KG+1))
   60   CONTINUE
        ELSE
          TOTNEW(K)=TOTX(K)
        ENDIF
   70 CONTINUE


C Calculate ratio (=1 < 10 keV):

      DO 90 K = 1,NBINS
        IF (ENER(K) .GE. EGR(1)) THEN
          RATIO(K) = TOTX(K)/TOTNEW(K) 
C         IF (RATIO(K) .GT. 1.) RATIO(K) = 1.
        ELSE
          RATIO(K) = 1.
        ENDIF
   90 CONTINUE

      END SUBROUTINE HEXC



      pure real FUNCTION TERPOO(X,X1,X2,Y1,Y2)
      implicit none
! Args:
      real,intent(in) :: x,x1,x2,y1,y2

      TERPOO = EXP ( log(Y1) + log(X/X1)*log(Y2/Y1)/log(X2/X1) )
      END function terpoo

C Subroutine GEOMAG
C
C Excerpted from the IRI package, Stan Solomon, 6/88.  Original name was
C GMAG, which was changed to avoid conflict when used at the same time
C as IRI.  Labeled common /CONST/ which contained only the degree/radian
C conversion factor was changed to a data statement.  Longitude range
C from -180 to 180.
C
C CALCULATES GEOMAGNETIC LONGITUDE (MLONG) AND LATITUDE (MLAT)
C FROM GEOGRAFIC LONGITUDE (LONG) AND LATITUDE (LATI) FOR ART=0
C AND REVERSE FOR ART=1. ALL ANGLES IN DEGREE.
C LATITUDE:-90 TO 90. LONGITUDE:0 TO 360 EAST.
C
      SUBROUTINE GEOMAG(ART,LONG,LATI,MLONG,MLAT)
      implicit none

      INTEGER,intent(in) :: ART
!inout to allow internal modif.
      REAL,intent(inout)  :: LONG,LATI
      real,intent(out) :: MLONG,MLAT    

!Local:
      real,parameter :: FAKTOR=.0174532952
      real cbg,cbm,ci,clg,clm,sbg,sbm,si,slg,slm,ylg,zpi

      ZPI=FAKTOR*360.
      CBG=11.4*FAKTOR
      CI=COS(CBG)
      SI=SIN(CBG)
      IF(ART.EQ.0) GOTO 10
      CBM=COS(MLAT*FAKTOR)
      SBM=SIN(MLAT*FAKTOR)
      CLM=COS(MLONG*FAKTOR)
      SLM=SIN(MLONG*FAKTOR)
      SBG=SBM*CI-CBM*CLM*SI
      LATI=ASIN(SBG)
      CBG=COS(LATI)
      SLG=(CBM*SLM)/CBG
      CLG=(SBM*SI+CBM*CLM*CI)/CBG
      IF(CLG.GT.1.) CLG=1.
      LONG=ACOS(CLG)
      IF(SLG.LT.0.0) LONG=ZPI-ACOS(CLG)
      LATI=LATI/FAKTOR
      LONG=LONG/FAKTOR
      LONG=LONG-69.8
      IF(LONG.LT.-180.0) LONG=LONG+360.0
      IF(LONG.GT. 180.0) LONG=LONG-360.0
      RETURN
 10   YLG=LONG+69.8
      CBG=COS(LATI*FAKTOR)
      SBG=SIN(LATI*FAKTOR)
      CLG=COS(YLG*FAKTOR)
      SLG=SIN(YLG*FAKTOR)
      SBM=SBG*CI+CBG*CLG*SI
      MLAT=ASIN(SBM)
      CBM=COS(MLAT)
      SLM=(CBG*SLG)/CBM
      CLM=(-SBG*SI+CBG*CLG*CI)/CBM
      IF(CLM.GT.1.) CLM=1.
      MLONG=ACOS(CLM)
      IF(SLM.LT..0) MLONG=ZPI-ACOS(CLM)
      MLAT=MLAT/FAKTOR
      MLONG=MLONG/FAKTOR
      IF(MLONG.LT.-180.0) MLONG=MLONG+360.0
      IF(MLONG.GT. 180.0) MLONG=MLONG-360.0

      END Subroutine Geomag

C Example driver program for GLOW subroutine package - dayglow version
C
C Stan Solomon, 4/05, 12/14
C Brian Harding, 10/17
C
C This software is part of the GLOW model.  Use is governed by the Open Source
C Academic Research License Agreement contained in the file glowlicense.txt.
C
C For more information see the file glow.txt
C
C For definitions of common block /CGLOW/, see subroutine GLOW
C
C Other definitions:
C F107P   Solar 10.7 cm flux for previous day
C AP      Ap index of geomagnetic activity
C Z       altitude array, km
C XNO     default values for NO concentration, cm-3
C
C Array dimensions:
C JMAX    number of altitude levels
C NBINS   number of energetic electron energy bins
C LMAX    number of wavelength intervals for solar flux
C NMAJ    number of major species
C NEX     number of ionized/excited species
C NW      number of airglow emission wavelengths
C NC      number of component production terms for each emission
C NST     number of states produced by photoionization/dissociation
C NEI     number of states produced by electron impact
C NF      number of types of auroral fluxes
C
      SUBROUTINE DAYGLOW(Z,idate_, ut_, glat_, glong_, f107a_, f107_,
     &                  f107p,ap,PyPhitop,iconj,
     &                  Pyion,Pyecalc,Pypi,Pysi,Pyisr,
     &                  PyUV)

!      use cglow,only: jmax,NMAJ,NEX,NW,NC,NST,NEI,NF,nbins,lmax,PI
      implicit none
      include 'cglow.h'

      Integer, Intent(In) :: idate_, iconj
      Real,Intent(In) :: Z(JMAX),ut_, glat_, glong_, f107a_, f107_,
     &                  f107p, ap, PyPhitop(nbins,3)
! it's 3, not nmaj

      Real, Intent(Out)  :: Pyion(JMAX,11), Pyisr(JMAX,nmaj),
     & Pyecalc(jmax),Pypi(jmax),Pysi(jmax), PyUV(5,jmax)
     
      Real PRATE(NEX,JMAX), LRATE(NEX,JMAX)
!***********************************************************************

      real D(8), T(2), SW(25),
     >          OUTF(11,JMAX), OARR(30), TPI(NMAJ),dipd,emono,fmono,
     > rz12,stl,szad,totpi,totsi
      integer i,iday,ijf,itail,j,j200,jmag,mmdd,ns

      LOGICAL JF(12)
      DATA SW/25*1./

      integer IDATE, ISCALE, JLOCAL, KCHEM, IERR,
     & IIMAXX(NBINS), N

      real UT, GLAT, GLONG,
     >    F107, F107A, HLYBR, FEXVIR, HLYA, HEIEW, XUVFAC,
     >    ZZ(JMAX), ZO(JMAX), ZN2(JMAX), ZO2(JMAX), ZNO(JMAX),
     >    ZNS(JMAX), ZND(JMAX), ZRHO(JMAX), ZE(JMAX),
     >    ZTN(JMAX), ZTI(JMAX), ZTE(JMAX),
     >    PHITOP(NBINS), EFLUX(NF), EZERO(NF),
     >    SZA, DIP, EFRAC,
     >    ZMAJ(NMAJ,JMAX), ZCOL(NMAJ,JMAX),
     >    WAVE1(LMAX), WAVE2(LMAX), SFLUX(LMAX),
     >    ENER(NBINS), DEL(NBINS),
     >    PESPEC(NBINS,JMAX), SESPEC(NBINS,JMAX),
     >    PHOTOI(NST,NMAJ,JMAX), PHOTOD(NST,NMAJ,JMAX), PHONO(NST,JMAX),
     >    QTI(JMAX), AURI(NMAJ,JMAX), PIA(NMAJ,JMAX), SION(NMAJ,JMAX),
     >    UFLX(NBINS,JMAX), DFLX(NBINS,JMAX), AGLW(NEI,NMAJ,JMAX),
     >    EHEAT(JMAX), TEZ(JMAX), ECALC(JMAX),
     >    ZXDEN(NEX,JMAX), ZETA(NW,JMAX), ZCETA(NC,NW,JMAX), VCB(NW),
     &   SIGS(NMAJ,NBINS), PE(NMAJ,NBINS), PIN(NMAJ,NBINS),
     >                SIGA(NMAJ,NBINS,NBINS), SEC(NMAJ,NBINS,NBINS),
     >                SIGEX(NEI,NMAJ,NBINS), SIGIX(NEI,NMAJ,NBINS),
     >    GLATS, GLONGS, XMLONG, XMLAT
     
      real ef,ez,fracO,fracO2,fracN2

      COMMON /CGLOW/ IDATE, UT, GLAT, GLONG, ISCALE, JLOCAL, KCHEM,
     >    F107, F107A, HLYBR, FEXVIR, HLYA, HEIEW, XUVFAC,
     >    ZZ, ZO, ZN2, ZO2, ZNO, ZNS, ZND, ZRHO, ZE,
     >    ZTN, ZTI, ZTE, PHITOP, EFLUX, EZERO, SZA, DIP, EFRAC, IERR,
     >    ZMAJ, ZCOL, WAVE1, WAVE2, SFLUX, ENER, DEL, PESPEC, SESPEC,
     >    PHOTOI, PHOTOD, PHONO, QTI, AURI, PIA, SION,
     >    UFLX, DFLX, AGLW, EHEAT, TEZ, ECALC, ZXDEN, ZETA, ZCETA, VCB

      COMMON /CXSECT/ SIGS, PE, PIN, SIGA, SEC, SIGEX, SIGIX, IIMAXX


!     Ingest Python parameters
      idate=idate_; ut=ut_; glat=glat_; glong=glong_
      f107a=f107a_; f107=f107_
      ENER = PyPhitop(:,1); DEL=PyPhitop(:,2); PHITOP=PyPhitop(:,3)
C
C Obtain input parameters:
C
C     read (5,*) idate, ut, glat, glong, f107a, f107, f107p, ap, ef, ec
C
C
C Set other parameters and switches:
C
      JLOCAL = 0
      KCHEM = 4
      ISCALE = 1
      XUVFAC = 3.
      HLYBR = 0.
      FEXVIR = 0.
      HLYA = 0.
      HEIEW = 0.
C
C Calculate local solar time:
C
      STL = (UT/240.+GLONG) / 15.
      IF (STL .LT. 0.) STL = STL + 24.
      IF (STL .GT. 24.) STL = STL - 24.
C
C
C Call MSIS to get neutral densities and temperature:
C
        CALL TSELEC(SW)

        DO J=1,JMAX
          CALL GTD7(IDATE,UT,Z(J),GLAT,GLONG,STL,F107A,F107P,AP,48,D,T)
          ZO(J) = D(2)
          ! If altitude under 100km and O number density there < 1e7 cm^-3,
          ! replace O density with O2 density there
!**********************************
!very important for not getting all-NaN output below 72.50 km!!!
          IF (ZO(J) .LT. 1.E7 .AND. Z(J) .LT. 100.) ZO(J) = D(4)*1.E-7
!***********************************
          ZN2(J) = D(3)
          ZO2(J) = D(4)
          ZRHO(J) = D(6)
          ZNS(J) = D(8)
          ZTN(J) = T(2)
          if (isnan(zo(j)))  stop 'NaN in O+ density'
          if (isnan(zn2(j))) stop 'NaN in N2+ density'
          if (isnan(zo2(j))) stop 'NaN in O2+ density'
          if (isnan(ztn(j))) stop 'NaN in Tn'
        END DO
C
C
C Call SNOEMINT to obtain NO profile from the Nitric Oxide Empirical
C Model (NOEM)
C
      CALL SNOEMINT(IDATE,GLAT,GLONG,F107,AP,Z,ZTN,ZNO)
C
C
C Call International Reference Ionosphere-1990 subroutine to get
C electron density and temperature and ion temperature:
C
C NOTE: the directory specified in the call to IRI90 must be changed
C to the one where the ccirnn.asc and ursinn.asc files are.
C
      DO IJF=1,12
        JF(IJF) = .TRUE.
      END DO

      JF(5) = .FALSE.
      JF(12) = .FALSE. !no disk output for iri90
      JMAG = 0
      RZ12 = -F107A
      IDAY = IDATE - IDATE/1000*1000
      MMDD = -IDAY
      CALL IRI90(JF,JMAG,GLAT,GLONG,RZ12,MMDD,STL,Z,JMAX,
     >           'iri/',OUTF,OARR)
      DO J=1,JMAX
        ZE(J) = OUTF(1,J) / 1.E6
        IF (ZE(J) .LT. 100.) ZE(J) = 100.
        ZTI(J) = OUTF(3,J)
        IF (ZTI(J) .LT. ZTN(J)) ZTI(J) = ZTN(J)
        ZTE(J) = OUTF(4,J)
        IF (ZTE(J) .LT. ZTN(J)) ZTE(J) = ZTN(J)
        ZXDEN(3,J) = ZE(J) * OUTF(5,J)/100.
        ZXDEN(6,J) = ZE(J) * OUTF(8,J)/100.
        ZXDEN(7,J) = ZE(J) * OUTF(9,J)/100.
        if (isnan(ze(j))) stop 'NaN in Ne'
        if (isnan(zti(j)))stop 'NaN in Ti'
        if (isnan(zte(j)))stop 'NaN in Te'
      END DO
C
C
C Fill altitude array and initialize N(2D):
C
      DO J=1,JMAX
        ZZ(J)   = Z(J) * 1.E5
        ZND(J)  = 0.
      END DO
C
C
C Call GLOW to calculate ionized and excited species, airglow emission
C rates, and vertical column brightnesses:
C
      CALL GLOW(PRATE,LRATE)

C No need to call GLOW again using calculated electron densities
C instead of IRI densities, because it makes a negligible effect
C on airglow, at least for 1304, where it made a 0.4% difference.
C It makes a difference when there is auroral precipitation, however.
C    
C          DO J=1,JMAX
C            ZE(J)=ECALC(J)
C            IF (ZE(J) .LT. 100.) ZE(J) = 100.
C          END DO
C
C        CALL GLOW(PRATE, LRATE)

C If iconj==1, then call GLOW at the conjugate point (using the outgoing
C flux at this point), then call GLOW back at this point (using the outgoing
C flux at the conjugate point)

      IF (ICONJ .EQ. 1) THEN
      
C
C Find location of conjugate point:
C
          GLATS = GLAT
          GLONGS = GLONG
          CALL GEOMAG(0,GLONG,GLAT,XMLONG,XMLAT)
          CALL GEOMAG(1,GLONG,GLAT,XMLONG,-XMLAT)
C
C Downward flux at conjugate point = upward flux at location:
C
          DO N=1,NBINS
            PHITOP(N) = UFLX(N,JMAX)
          END DO
C
C Call Glow for conjugate point (same neutral atmosphere):
C
          CALL GLOW(PRATE, LRATE)
C
C Upward flux at conjugate point = downward flux at location:
C
          DO N=1,NBINS
            PHITOP(N) = UFLX(N,JMAX)
          END DO

C
C Call Glow again at location:
C

          GLAT = GLATS
          GLONG = GLONGS

          CALL GLOW(PRATE, LRATE)
          
      END IF
      
C
C Output section:
C
      SZAD = SZA * 180. / PI
      DIPD = DIP * 180. / PI

!      write (6,444) IDATE, UT, GLAT, GLONG, F107, F107A, AP
!  444 FORMAT (' Date=',i5,' UT=',f6.0,' Lat=',f5.1,' Lon=',f6.1,
!     >        ' F107=',f4.0,' F107A=',f4.0,' Ap=',f4.0)
!      WRITE (6,445) SZAD, STL, DIPD, EFRAC, IERR
!  445 FORMAT (' SZA=',F5.1,' LST=',F5.2,' Dip=',F5.1,
!     >        ' Ec=',F6.3,' Ie=',I1)
!
! Output photoionization, electron impact ionization,
! electron density, and ion densities:
!
!     write (6,690)
!  690 format ('   Z    Photoion   EIion    Ecalc     O+(2P)    ',
!    >        'O+(2D)    O+(4S)     N+         N2+       O2+       NO+')
!    >        '     O        O2         N2        NO')
      do j=1,jmax
        do i=1,nmaj
          tpi(i) = 0.
          do ns=1,nst
            tpi(i) = tpi(i) + photoi(ns,i,j)
          end do
        end do
        totpi = tpi(1) + tpi(2) + tpi(3) + phono(1,j)
        totsi = sion(1,j) + sion(2,j) + sion(3,j)

        if (isnan(totpi)) write(0,*) 'NaN in photoionization'
        if (isnan(totsi)) then
         write(0,*) 'NaN in impact ionization at altitude',z(j) 
        end if

        Pypi(j) = totpi
        Pysi(j) = totsi
!       write (6,730) z(j),totpi,totsi,ecalc(j),(zxden(i,j),i=1,7)
!    >                zo(j),zo2(j),zn2(j),zno(j)
!  730   format (1x, 0p, f5.1, 1p, 14e10.2)
      end do

      Pyecalc = ecalc

      Pyion(:,1:7) = transpose(zxden(1:7,:))
      Pyion(:,8)=zo; Pyion(:,9)=zo2; Pyion(:,10)=zn2; Pyion(:,11)=zno

      Pyisr(:,1)=ZE; Pyisr(:,2)=ZTE; Pyisr(:,3)=ZTI

C
C Output selected volume emission rates and column brightnesses:
C
!      write (6,780)
!  780 format ('   z     3371   4278   5200   5577   6300',
!    >        '   7320  10400   3466   7774   8446')
!      write (6,790) (z(j), (zeta(iw,j),iw=1,10), j=1,jmax)
! 790 format (1x, f5.1, 10f7.1)
!      write (6,795)  (vcb(iw),iw=1,10)
! 795 format (' VCB:',11f7.0)


      CALL ROUT('rt.out',EF,EZ,ITAIL,FRACO,FRACO2,FRACN2,PyUV)

      END SUBROUTINE DAYGLOW

! Subroutine MAXT
!
! This software is part of the GLOW model.  Use is governed by the Open Source
! Academic Research License Agreement contained in the file glowlicense.txt.
! For more information see the file glow.txt.
!
! Stan Solomon, 11/89, 9/91, 1/94, 3/05
!
! Generates Maxwellian electron spectra with, optionally, a low energy tail
! of the form used by Meier et al., JGR 94, 13541, 1989.
!
! Supplied by calling routine:
!     EFLUX  total energy flux in erg cm-2 s-1
!     EZER   characteristic energy in eV
!     ENER   energy grid in eV
!     dE   energy bin width in eV
!     NBINS  number of energy bins (dimension of ENER, dE, and PHI)
!     ITAIL  1 = Maxwellian with low-energy tail, 0 = regular Maxwellian
!     FMONO  additional monoenergetic energy flux in erg cm-2 s-1
!     EMONO  characteristic enerngy of FMONO in eV
!
! Returned by subroutine:
!     MAXT   Hemispherical flux in cm-2 s-1 eV-1
!
      Subroutine maxt(EFLUX, EZER, ENER, dE, ITAIL, FMONO, EMONO, phi)
!      use cglow, only: nbins
      implicit none
      include 'cglow.h'
!Args:
      Real,Intent(Out) :: phi(NBINS)
      Real, Intent(In)  :: EFLUX, EZER, ENER(NBINS), dE(NBINS),
     & FMONO,EMONO
      Integer,Intent(In):: ITAIL
!Local:
      Real B,TE, PHIMAX, ERAT
      Integer K

      TE = 0.
C
      IF (EZER < 500.) THEN
        B = 0.8*EZER
      ELSE
        B = 0.1*EZER + 350.
      ENDIF
C
      PHIMAX = EXP(-1.)
C
      DO 300 K=1,NBINS
        ERAT = ENER(K) / EZER
        IF (ERAT > 60.) ERAT = 60.
        PHI(K) = ERAT * EXP(-ERAT)
        IF (ITAIL > 0)
     >    PHI(K) = PHI(K) + 0.4*PHIMAX*(EZER/ENER(K))*EXP(-ENER(K)/B)
        TE = TE + PHI(K) * dE(K) * ENER(K) * 1.6022E-12
  300 CONTINUE
C
      DO 400 K=1,NBINS
      PHI(K) = PHI(K) * EFLUX / TE
  400 CONTINUE
c
c
c
      if (fmono > 0.) then
      do 500 k=1,nbins
      if (emono > ener(k)-dE(k)/2..and.emono < ener(k)+dE(k)/2.)
     >  phi(k)=phi(k)+fmono/(1.6022E-12*dE(k)*ener(k))
  500 continue
      endif
      END Subroutine maxt

C Subroutine IRI90

C Adapted 7/93 from 10/91 version of IRIS12 by Stan Solomon.
C Replaces 3/92 adaptation of 12/90 version of IRIS12.
C Replaced height range and interval with array of heights ZKM
C Also supply number of heights NZ; unlimited number of heights allowed.
C Added DIRECT argument to specify location of CCIR and URSI files.
C Uses ASCII versions of CCIR and URSI files.

C Accepts longitudes -180 to +180; maps internal longitudes 0-360.
C Added SAVE statements for volatile memory machines.
C Changed 'file not found' error to output message on unit 6 and stop.
C Changed JF(12)=.true. to write messages on unit 12 instead of 6.
C Note: JF(5)=.false. uses recommended (URSI) coefficients.
C Note: JF(4)=.false. uses recommended Gulyeava B0 coefficients.
C All other JF's usually should be .true.
C
C The following is the original comment from IRIS12:
C
C IRIS12.FOR ---------------------------------------- OCTOBER 1991
C
C*****************************************************************
C CHANGES FROM  IRIS11.FOR  TO   IRIS12.FOR:
C    - CIRA-1986 INSTEAD OF CIRA-1972 FOR NEUTRAL TEMPERATURE
C    - 10/30/91 VNER FOR NIGHTTIME LAY-VERSION:  ABS(..)
C    - 10/30/91 XNE(..) IN CASE OF LAY-VERSION
C    - 10/30/91 CHANGE SSIN=F/T TO IIQU=0,1,2
C    - 10/30/91 Te > Ti > Tn ENFORCED IN FINAL PROFILE
C    - 10/30/91 SUB ALL NAMES WITH 6 OR MORE CHARACTERS
C    - 10/31/91 CORRECTED HF1 IN HST SEARCH:  NE(HF1)>NME
C------------- inlcuded on diskette ------------------------------
C    - 11/14/91 C1=0 IF NO F1-REGION
C    - 11/14/91 CORRECTED HHMIN AND HZ FOR LIN. APP.
C    -  1/28/92 RZ12=0 included
C    -  1/29/92 NEQV instead of NE between URSIF2 and URSIFO
C    -  5/ 1/92 CCIR and URSI input as in IRID12
C
C*****************************************************************
C********* INTERNATIONAL REFERENCE IONOSPHERE (IRI). *************
C*****************************************************************
C****************    OCTOBER 1991     ****************************
C****************     SUBROUTINE      ****************************
C*****************************************************************
C
C
C-----------------------------------------------------------------
C INTERNATIONAL REFERENCE IONOSPHERE 1991
C
C INPUT:  JMAG=0/1      GEODETIC/GEOMAGNETIC LATITUDE AND LONGITUDE
C         ALATI,ALONG   LATITUDE NORTH AND LONGITUDE EAST IN DEGREES
C         RZ12 (-COV)   12-MONTHS-RUNNING MEAN OF SOLAR SUNSPOT NUMBER
C                          (OR EQUIVALENT F10.7 SOLAR RADIO FLUX AS
C                          NEGATIVE NUMBER)
C         MMDD (-DDD)   DATE (OR DAY OF YEAR AS A NEGATIVE NUMBER)
C         DHOUR         LOCAL TIME (OR UNIVERSAL TIME + 25) IN DECIMAL
C                          HOURS
C         HEIBEG,       BEGIN, END, AND STEPWIDTH OF HEIGHT RANGE
C          HEIEND,HEISTP   IN KM (MAXIMUM NUMBER OF STEPS IS 50 !!)
C         JF(1:12)      TRUE/FALSE FLAGS FOR SEVERAL OPTIONS
C          JF(1)=.TRUE.[.FALSE.]   ELECTRON DENSITY IS [NOT] CALCULATED
C          JF(2)=T[F]    TEMPERATURES ARE [NOT] CALCULATED
C          JF(3)=T[F]    ION COMPOSITION IS [NOT] CALCULATED
C          JF(4)=T[F]    B0 FROM TABLE [FROM GULYEAVA 1987]
C          JF(5)=T[F]    F2 PEAK FROM CCIR [FROM URSI]
C          JF(6)=T[F]    ION COMP. STANDARD [DANILOV-YAICHNIKOV-1985]
C          JF(7)=T[F]    STAND. IRI TOPSIDE [IRI-79]
C          JF(8)=T[F]    NMF2 PEAK MODEL [INPUT VALUES]
C          JF(9)=T[F]    HMF2 PEAK MODEL [INPUT VALUES]
C          JF(10)=T[F]   TE MODEL [TE-NE MODEL WITH NE INPUT]
C          JF(11)=T[F]   NE STANDARD [LAY-FUNCTIONS VERSION]
C          JF(12)=T[F]   MESSAGE ARE WRITTEN TO UNIT=12 [=6]
C
C  JF(1:11)=.TRUE. GENERATES THE STANDARD IRI-90 PARAMETERS.
C  IF YOU SET JF(8)=.FALSE., THAN YOU HAVE TO PROVIDE THE F2 PEAK
C  NMF2/M-3 OR FOF2/MHZ IN OARR(1). SIMILARLY, IF YOU SET JF(9)=
C  .FALSE., THAN YOU HAVE TO PROVIDE THE F2 PEAK HEIGHT HMF2/KM IN
C  OARR(2). IF YOU SET JF(10)=.FALSE., THAN YOU HAVE TO PROVIDE THE
C  ELECTRON DENSITY IN M-3 AT 300KM AND/OR 400KM AND/OR 600KM IN
C  OARR(3), OARR(4), AND OARR(5). IF YOU WANT TO USE THIS OPTION AT
C  ONLY ONE OF THE THREE ALTITUDES, THAN SET THE DENSITIES AT THE
C  OTHER TWO TO ZERO.
C
C  OUTPUT:  OUTF(1:10,1:50)   IRI PROFILES
C              OUTF(1,*)  ELECTRON DENSITY/M-3
C              OUTF(2,*)  NEUTRAL TEMPERATURE/K
C              OUTF(3,*)  ION TEMPERATURE/K
C              OUTF(4,*)  ELECTRON TEMPERATURE/K
C              OUTF(5,*)  PERCENTAGE OF O+ IONS IN %
C              OUTF(6,*)  PERCENTAGE OF H+ IONS IN %
C              OUTF(7,*)  PERCENTAGE OF HE+ IONS IN %
C              OUTF(8,*)  PERCENTAGE OF O2+ IONS IN %
C              OUTF(9,*)  PERCENTAGE OF NO+ IONS IN %
C                 AND, IF JF(6)=.FALSE.:
C              OUTF(10,*)  PERCENTAGE OF CLUSTER IONS IN %
C              OUTF(11,*)  PERCENTAGE OF N+ IONS IN %
C
C            OARR(1:30)   ADDITIONAL OUTPUT PARAMETERS
C              OARR(1) = NMF2/M-3        OARR(2) = HMF2/KM
C              OARR(3) = NMF1/M-3        OARR(4) = HMF1/KM
C              OARR(5) = NME/M-3         OARR(6) = HME/KM
C              OARR(7) = NMD/M-3         OARR(8) = HMD/KM
C              OARR(9) = HHALF/KM        OARR(10) = B0/KM
C              OARR(11) =VALLEY-BASE/M-3 OARR(12) = VALLEY-TOP/KM
C              OARR(13) = TE-PEAK/K      OARR(14) = TE-PEAK HEIGHT/KM
C              OARR(15) = TE-MOD(300KM)  OARR(16) = TE-MOD(400KM)/K
C              OARR(17) = TE-MOD(600KM)  OARR(18) = TE-MOD(1400KM)/K
C              OARR(19) = TE-MOD(3000KM) OARR(20) = TE(120KM)=TN=TI/K
C              OARR(21) = TI-MOD(430KM)  OARR(22) = X/KM, WHERE TE=TI
C              OARR(23) = SOLAR ZENITH ANGLE/DEG
C              OARR(24) = SUN DECLINATION/DEG
C              OARR(25) = DIP
C              OARR(26) = DIP LATITUDE
C              OARR(27) = MODIFIED DIP LATITUDE
C              OARR(28:30) FREE
C-------------------------------------------------------------------
C*** THIS PROGRAM PRODUCES PROFILES OF                         ***
C***      ELECTRON DENSITY                                     ***
C***      NEUTRAL TEMPERATURE (CIRA 86)                        ***
C***      ELECTRON TEMPERATURE                                 ***
C***      ION TEMPERATURE                                      ***
C***      RELATIVE PERCENTAGE DENSITIES OF THE IONS            ***
C***           ATOMIC OXYGEN, HYDROGEN, HELIUM,                ***
C***           MOLECULAR OXYGEN AND NITROGEN OXYD (NO+)        ***
C*****************************************************************
C*** THE ALTITUDE LIMITS ARE:  LOWER (DAY/NIGHT)  UPPER        ***
C***     ELECTRON DENSITY         60/80 KM       1000 KM       ***
C***     TEMPERATURES              120 KM        3000 KM       ***
C***     ION DENSITIES             100 KM        1000 KM       ***
C*****************************************************************
C*     --------------------ADDRESSES------------------------     *
C*     I  PROF. K. RAWER              DR. D. BILITZA       I     *
C*     I  HERRENSTR. 43               GSFC/NSSDC CODE 633  I     *
C*     I  D-7801 MARCH                GREENBELT MD 20771   I     *
C*     I  F.R.G.                      USA                  I     *
C*     -----------------------------------------------------     *
C*****************************************************************
C*****************************************************************
C*****************************************************************
C*********       ALL ANGLES ARE IN DEGREE           **************
C*********       ALL DENSITIES ARE IN M-3           **************
C*********       ALL ALTITUDES ARE IN KM            **************
C*********     ALL TEMPERATURES ARE IN KELVIN       **************
C*********     ALL TIMES ARE IN DECIMAL HOURS       **************
C*****************************************************************
C********************  OPTIONS  **********************************
C*****************************************************************
C* FOR HMF2=0 OR FOF2=0 THE F2 PEAK VALUES ARE CALCULATED WITH   *
C* THE CCIR OR URSI MODELS. THE CCIR COEFFICIENT SET FOR THE     *
C* MONTH "mm" IS EXPECTED IN THE BINARY FILE "CCIRmm.BIN" AND    *
C* THE URSI SET IN "URSImm.BIN". IF YOU USE THE ASCII CODED      *
C* FILES "CCIRmm.ASC", YOU HAVE TO INCORPORATE THE CHANGES       *
C* INDICTED IN PROGRAM SECTION ENTITLED "READ CCIR COEFFICIENT   *
C* SET FOR CHOSEN MONTH."                                        *
C*****************************************************************
C*****************************************************************
C*****************************************************************
C
       SUBROUTINE IRI90(JF,JMAG,ALATI,ALONG,RZ12,MMDD,DHOUR,
     &                  ZKM,NZ,drect,OUTF,OARR)

      use, intrinsic :: iso_fortran_env, only : stdout=>output_unit, 
     &                                          stderr=>error_unit

      logical, intent(in) :: JF(12)
      integer,intent(in) :: JMAG,MMDD,nz
      real,intent(in) :: alati,along,rz12
      real,intent(out) :: outf(11,nz),oarr(30)

      real, intent(in) :: zkm(nz)
      character(*), intent(in) :: drect
      character(256) :: path
      character(128) :: filename
      character(2) ::   fmonth
      INTEGER ::    imonth, month,  DAYNR,DDO,DO2,SEASON,SEADAY, IU
      REAL               LATI,LONGI,MO2,MO,MODIP,NMF2,MAGBR
      REAL                NMF1,NME,NMD,MM,MLAT,MLONG,NOBO2
      DIMENSION  F(3),RIF(4),E(4),XDELS(4),DNDS(4)
      DIMENSION  FF0(988),XM0(441),F2(13,76,2),FM3(9,49,2)
      DIMENSION  AMP(4),HXL(4),SCL(4),B0B1(5)
      DIMENSION  XSM(4),MM(5),DTI(4)
      DIMENSION  AHH(7),STTE(6),DTE(5),ATE(7),TEA(6),HOA(3),XNAR(3)
      DIMENSION  PG1O(80),PG2O(32),PG3O(80),PF1O(12),PF2O(4),PF3O(12)
      DIMENSION  HO(4),MO(5),DDO(4),HO2(2),MO2(3),DO2(2),DION(7)
      LOGICAL              EXT,SCHALT,NIGHT,TCON(3)
      LOGICAL              F1REG,FOF2IN,HMF2IN,URSIF2,LAYVER,DY,GULB0
      LOGICAL              NODEN,NOTEM,NOION,TENEOP
      LOGICAL           OLD79,TOPSI,BOTTO,BELOWE,URSIFO
      COMMON       /BLOCK1/HMF2,NMF2,HMF1                /CONST/UMR
     &              /BLOCK2/B0,B1,C1      /BLOCK3/HZ,T,HST,STR
     &         /BLOCK4/HME,NME,HEF   /BLOCK5/NIGHT,E
     &            /BLOCK6/HMD,NMD,HDX   /BLOCK7/D1,XKK,FP30,FP3U,FP1,FP2
     &         /BLOCK8/HS,TNHS,XSM,MM,DTI,MXSM
     &         /BLOTN/XSM1,TEXOS,TLBDH,SIGMA /BLOTE/AHH,ATE1,STTE,DTE
     &              /BLO10/BETA,ETA,DELTA,ZETA        /ARGEXP/ARGMAX
     
      EXTERNAL :: XE1,XE2,XE3,XE4,XE5,XE6,TEDER
      
      DATA  HOA  /300.,400.,600./,   XNAR       /3*0.0/,
     &      XDELS   /3*5.,10./,      DNDS   /.016,.01,2*.016/,
     &      DDO         /9,5,5,25/,        DO2        /5,5/,
     &      B0B1  /.755566,.778596,.797332,.812928,.826146/
      data icalls/0/

      SAVE DAYNR,DO2,SEASON,SEADAY,LATI,LONGI,MO2,
     &     MODIP,MAGBR,NMF1,MLAT,MLONG,NOBO2,
     &     F,RIF,FF0,XM0,F2,FM3,AMP,HXL,SCL,
     &     ATE,TEA,HOA,XNAR,PG1O,
     &     PG2O,PG3O,PF1O,PF2O,PF3O,HO,MO,DDO,HO2,DION,EXT,
     &     SCHALT,TCON,F1REG,FOF2IN,HMF2IN,URSIF2,LAYVER,
     &     DY,GULB0,NODEN,NOTEM,NOION,TENEOP,OLD79,TOPSI,BOTTO,BELOWE,
     &     URSIFO,MONTH,MONTHO,RG,RGO
C
C PROGAM CONSTANTS
C
       icalls=icalls+1
       ARGMAX=88.0
            UMR=ATAN(1.0)*4./180.
             ALOG2=ALOG(2.)
       ALG100=ALOG(100.)
        ISTART=1
        heibeg=zkm(1)
        heiend=zkm(nz)
C
C Code inserted to aleviate block data problem for PC version.
C Thus avoiding DATA statement with parameters from COMMON block.
C
        AHH(1)=120.
        AHH(2)=0.
        AHH(3)=300.
        AHH(4)=400.
        AHH(5)=600.
        AHH(6)=1400.
        AHH(7)=3000.
        DTE(1)=5.
        DTE(2)=5.
        DTE(3)=10.
        DTE(4)=20.
        DTE(5)=20.
        DTI(1)=10.
        DTI(2)=10.
        DTI(3)=20.
        DTI(4)=20.

C FIRST SPECIFY YOUR COMPUTERS CHANNEL NUMBERS ....................
C AGNR=OUTPUT (OUTPUT IS DISPLAYED OR STORED IN FILE OUTPUT.IRI)...

      KONSOL=stdout
      IF (JF(12)) KONSOL=12

c
c selection of density and ion composition options ..................
c

      NODEN=(.NOT.JF(1))
      NOTEM=(.NOT.JF(2))
      NOION=(.NOT.JF(3))
      DY=(.NOT.JF(6))
      LAYVER=(.NOT.JF(11))
      OLD79=(.NOT.JF(7))
      GULB0=(.NOT.JF(4))
c
c f peak density ....................................................
c
      FOF2IN=(.NOT.JF(8))
       IF(FOF2IN) THEN
          AFOF2=OARR(1)
          IF(AFOF2.GT.100.) AFOF2=SQRT(AFOF2/1.24E10)
          ENDIF
      URSIF2=(.NOT.JF(5))
c
c f peak altitude ..................................................
c
      HMF2IN=(.NOT.JF(9))
       IF(HMF2IN) AHMF2=OARR(2)
c
C TE-NE MODEL OPTION ..............................................
C
      TENEOP=(.NOT.JF(10))
        IF(TENEOP) THEN
           DO 8154 JXNAR=1,3
              XNAR(JXNAR)=OARR(JXNAR+2)
             TCON(JXNAR)=.FALSE.
8154             IF(XNAR(JXNAR).GT.0.) TCON(JXNAR)=.TRUE.
           ENDIF

      if(icalls.gt.1) goto 8201
!       write(konsol,*) '*** IRI parameters are being calculated ***'
      if(NODEN) goto 2889
       if(LAYVER) write(konsol,*) 'Ne, E-F: The LAY-Version is ',
     &         'preliminary. Erroneous profile features can occur.'
       if(GULB0) write(konsol,*) 'Ne, B0: Bottomside thickness is ',
     &         'obtained with Gulyaeva-1987 model.'
       if(OLD79) write(konsol,*) 'Ne: Using IRI-79. Correction',
     &         ' of equatorial topside is not included.'
       if(HMF2IN) write(konsol,*) 'Ne, hmF2: Input values are used.'
       if(FOF2IN) then
         write(konsol,*) 'IRI-90: Ne, foF2: Input values are used.'
         goto 2889
         endif
       if(URSIF2) then
         write(konsol,*) 'IRI-90: Ne, foF2: URSI model is used.'
       else
         write(konsol,*) 'IRI-90: Ne, foF2: CCIR model is used.'
       endif
2889  if((.not.NOION).and.(DY))
     &        write(konsol,*) 'Ion Com.: Using Danilov-Yaichnikov-1985.'
      if((.not.NOTEM).and.(TENEOP))
     &     write(konsol,*) 'Te: Temperature-density correlation is used'
8201       continue
C
C CALCULATION OF MEAN F10.7CM SOLAR RADIO FLUX (COV)................
C CALCULATION OF RESTRICTED SOLAR ACTIVITIES (RG,COVG)..............
C
      IF(RZ12.GE.0.0) THEN
        R=RZ12
        COV=63.75+R*(0.728+R*0.00089)
      ELSE
        COV=-RZ12
        R=33.52*(SQRT(COV+85.12)-12.2)
      ENDIF
      RG=R
      COVG=COV
      IF(R.GT.150.) RG=150.
      IF(COV.GT.193.) COVG=193.
C
C CALCULATION OF GEOG. OR GEOM. COORDINATES IN DEG....................
C CALCULATION OF MAGNETIC INCLINATION (DIP), DECLINATION (DEC)........
C   DIP LATITUDE (MAGBR) AND MODIFIED DIP (MODIP). ALL IN DEGREE......
C
        IF(JMAG.GT.0) THEN
           MLAT=ALATI
           MLONG=ALONG
           if (mlong .lt. 0.) mlong=mlong+360.
        ELSE
           LATI=ALATI
           LONGI=ALONG
           if (longi .lt. 0.) longi=longi+360.
        ENDIF
        CALL GGM(JMAG,LONGI,LATI,MLONG,MLAT)
        ABSLAT=ABS(LATI)
        CALL FIELDG(LATI,LONGI,300.0,XMA,YMA,ZMA,BET,DIP,DEC,MODIP)
        MAGBR=ATAN(0.5*TAN(DIP*UMR))/UMR
       ABSMLT=ABS(MLAT)
       ABSMDP=ABS(MODIP)
       ABSMBR=ABS(MAGBR)
C
C CALCULATION OF SEASON (SUMMER=2, WINTER=4)..........................
C CALCULATION OF DAY OF YEAR AND SUN DECLINATION......................
C
         if(MMDD.lt.0) then
              DAYNR=-MMDD
              call MODA(1,MONTH,IDAY,DAYNR)
       else
              MONTH=MMDD/100
              IDAY=MMDD-MONTH*100
              call MODA(0,MONTH,IDAY,DAYNR)
       endif
      SEASON=INT((DAYNR+45.0)/92.0)
      IF(SEASON.LT.1) SEASON=4
      NSESON=SEASON
      seaday=daynr
      IF(LATI.GT.0.0) GOTO 5592
          SEASON=SEASON-2
           IF(SEASON.LT.1) SEASON=SEASON+4
       seaday=daynr+183
       if(seaday.gt.366) seaday=seaday-366
C
C CALCULATION OF SOLAR ZENITH ANGLE (XHI/DEG).........................
C NOON VALUE (XHINON).................................................
C
5592  IF(DHOUR.GT.24.1) THEN
       UT=DHOUR-25.
       HOUR=UT+LONGI/15.
       IF(HOUR.GT.24.) HOUR=HOUR-24.
      ELSE
       HOUR=DHOUR
        UT=HOUR-LONGI/15.
        IF(UT.LT.0.) UT=UT+24.
      ENDIF

       CALL SOCO(DAYNR,HOUR,LATI,LONGI,SUNDEC,XHI,SAX,SUX)
       CALL SOCO(DAYNR,12.0,LATI,LONGI,SUNDE1,XHINON,SAXNON,SUXNON)

               NIGHT=.FALSE.
       if(abs(sax).gt.25.0) then
                if(sax.lt.0.0) NIGHT=.TRUE.
              goto 1334
              endif
             if(SAX.le.SUX) goto 1386
       if((hour.gt.sux).and.(hour.lt.sax)) night=.true.
       goto 1334
1386         IF((HOUR.GT.SUX).OR.(HOUR.LT.SAX)) NIGHT=.TRUE.
C
C CALCULATION OF ELECTRON DENSITY PARAMETERS................
C
1334  HNEA=65.
      IF(NIGHT) HNEA=80.
      HNEE=2000.
      IF(NODEN) GOTO 4933
      DELA=4.32
      IF(ABSMDP.GE.18.) DELA=1.0+EXP(-(ABSMDP-30.0)/10.0)
      DELL=1+EXP(-(ABSLAT-20.)/10.)
C!!!!!!! F-REGION PARAMETERS AND E-PEAK !!!!!!!!!!!!!!!!!!!!!!!!!!
      FOE=FOEEDI(COV,XHI,XHINON,ABSLAT)
      NME=1.24E10*FOE*FOE
      HME=105.0
      IF((FOF2IN).AND.(HMF2IN)) GOTO 501
      IF (URSIF2 .NEQV. URSIFO) GOTO 7797
      IF((MONTH.EQ.MONTHO).AND.(RG.EQ.RGO)) GOTO 4292
      IF(MONTH.EQ.MONTHO) GOTO 4291
C
C READ CCIR COEFFICIENT SET FOR CHOSEN MONTH....................
7797  write(fmonth,'(I2)') month +10
!      print '(A2,I3.3)',fmonth,month+10
!      print *,drect,month,' ',fmonth  !'(I2,I2,A1,A2,A1,A25)'
      path = trim(drect)//'ccir'//fmonth//'.asc'
!      print *,trim(path)
      !call dfp(drect,filename,path)
      OPEN(newunit=iu,FILE=trim(path),
     &      STATUS='OLD',action='read',ERR=8448)
      READ(IU,4689) F2,FM3
4689  FORMAT(4E15.8)
      CLOSE(IU)
C
C READ URSI COEFFICIENT SET FOR CHOSEN MONTH....................
C
      if (URSIF2) then
        path = trim(drect)//'ursi'//fmonth//'.asc'
        !call dfp(drect,filename,path)
        OPEN(newunit=IU,FILE=trim(path),
     &         STATUS='OLD',action='read',ERR=8448)
        READ(IU,4689) F2
        CLOSE(IU)
      endif
        URSIFO=URSIF2
        MONTHO=MONTH
       GOTO 4291

8448  write(stderr,*) ' IRI90: File ',trim(path),' not found'
      error stop

C LINEAR INTERPOLATION IN SOLAR ACTIVITY
C
4291    RR2=RG/100.
        RR1=1.-RR2
        DO 20 I=1,76
        DO 20 J=1,13
        K=J+13*(I-1)
20      FF0(K)=F2(J,I,1)*RR1+F2(J,I,2)*RR2
        DO 30 I=1,49
        DO 30 J=1,9
        K=J+9*(I-1)
30      XM0(K)=FM3(J,I,1)*RR1+FM3(J,I,2)*RR2
       RGO=RG

4292  CALL F2OUT(MODIP,LATI,LONGI,FF0,XM0,UT,YFOF2,XM3000)

501       IF(FOF2IN) THEN
         FOF2=AFOF2
       ELSE
          FOF2=YFOF2
       ENDIF
             NMF2=1.24E10*FOF2*FOF2

       IF(HMF2IN) THEN
         HMF2=AHMF2
       ELSE
          HMF2=HMF2ED(MAGBR,RG,FOF2/FOE,XM3000)
       ENDIF

        TOPSI=(HEIEND.GT.HMF2)
       BOTTO=((HEIEND.GE.HME).AND.(HEIBEG.LE.HMF2))
       BELOWE=(HEIBEG.LT.HME)
c
c topside profile parameters .............................
c
       IF(.NOT.TOPSI) GOTO 1501
      COS2=COS(MLAT*UMR)
      COS2=COS2*COS2
      FLU=(COVG-40.0)/30.0
      IF(OLD79) then
        ETA1=-0.0070305*COS2
      else
        EX=EXP(-MLAT/15.)
        EX1=EX+1
        EPIN=4.*EX/(EX1*EX1)
        ETA1=-0.02*EPIN
      endif
      ETA=0.058798+ETA1+FLU*(-0.014065+0.0069724*COS2)+
     &(0.0024287+0.0042810*COS2-0.00015280*FOF2)*FOF2
      ZETA=0.078922-0.0046702*COS2+FLU*(-0.019132+0.0076545*COS2)+
     &(0.0032513+0.0060290*COS2-0.00020872*FOF2)*FOF2
      BETA=-128.03+20.253*COS2+FLU*(-8.0755-0.65896*COS2)+(0.44041
     &+0.71458*COS2-0.042966*FOF2)*FOF2
      Z=EXP(94.45/BETA)
      Z1=Z+1
      Z2=Z/(BETA*Z1*Z1)
      DELTA=(ETA/Z1-ZETA/2.0)/(ETA*Z2+ZETA/400.0)
c
c bottomside profile parameters .............................
C
1501    HMF1=HMF2
       HZ=HMF2
       HEF=HME
       IF(.not.BOTTO) GOTO 2727
       B1=3.0
C!!!!!!! INTERPOLATION FOR B0 OUT OF ARRAY B0F !!!!!!!!!!!!!!!!!!!!!
       if(GULB0) then
         call ROGUL(SEADAY,XHI,SEAX,GRAT)
         if(NIGHT) GRAT=0.91-HMF2/4000.
         B0CNEW=HMF2*(1.-GRAT)
         B0=B0CNEW/B0B1(1)
       else
          B0 = B0POL(HOUR,SAX,SUX,SEASON,RG,DELA)
       endif
C!!!!!!! F1-REGION PARAMETERS !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      F1REG=.FALSE.
      HMF1=0.
      PNMF1=0.
      C1=0.
      IF(NIGHT.OR.(SEASON.EQ.4)) GOTO 150
        FOF1=FOF1ED(ABSMBR,R,XHI)
        IF(FOF1.LT.1.E-3) GOTO 150
          F1REG=.TRUE.
          C1=.09+.11/DELA
          PNMF1=1.24E10*FOF1*FOF1
150   NMF1=PNMF1
C!!!!!!! PARAMETER FOR E AND VALLEY-REGION !!!!!!!!!!!!!!!!!!!!!
      XDEL=XDELS(SEASON)/DELA
      DNDHBR=DNDS(SEASON)/DELA
      HDEEP=HPOL(HOUR,10.5/DELA,28.,SAX,SUX,1.,1.)
      WIDTH=HPOL(HOUR,17.8/DELA,45.+22./DELA,SAX,SUX,1.,1.)
      DEPTH=HPOL(HOUR,XDEL,81.,SAX,SUX,1.,1.)
      DLNDH=HPOL(HOUR,DNDHBR,.06,SAX,SUX,1.,1.)
      IF(DEPTH.LT.1.0) GOTO 600
       IF(NIGHT) DEPTH=-DEPTH
             CALL TAL(HDEEP,DEPTH,WIDTH,DLNDH,EXT,E)
             IF(.NOT.EXT) GOTO 667
               WRITE(KONSOL,650)
650   FORMAT(1X,'*NE* E-REGION VALLEY CAN NOT BE MODELLED')
600            WIDTH=.0
667   HEF=HME+WIDTH
      VNER = (1. - ABS(DEPTH) / 100.) * NME
c
c Parameters below E  .............................
c
2727       IF(.not.BELOWE) GOTO 2726
C!!!!!!!D-REGION PARAMETER!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      NMD=XMDED(XHI,R,4.0E8)
      HMD=HPOL(HOUR,81.0,88.0,SAX,SUX,1.,1.)
      F(1)=HPOL(HOUR,0.02+0.03/DELA,0.05,SAX,SUX,1.,1.)
      F(2)=HPOL(HOUR,4.6,4.5,SAX,SUX,1.,1.)
      F(3)=HPOL(HOUR,-11.5,-4.0,SAX,SUX,1.,1.)
      FP1=F(1)
      FP2=-FP1*FP1/2.0
      FP30=(-F(2)*FP2-FP1+1.0/F(2))/(F(2)*F(2))
      FP3U=(-F(3)*FP2-FP1-1.0/F(3))/(F(3)*F(3))
      HDX=HMD+F(2)
      X=HDX-HMD
      XDX=NMD*EXP(X*(FP1+X*(FP2+X*FP30)))
      DXDX=XDX*(FP1+X*(2.0*FP2+X*3.0*FP30))
      X=HME-HDX
      XKK=-DXDX*X/(XDX*ALOG(XDX/NME))
      D1=DXDX/(XDX*XKK*X**(XKK-1.0))
!
! SEARCH FOR HMF1 ..................................................
!
2726       IF(.not.BOTTO) GOTO 4933
       if(LAYVER) goto 6153
924       IF(.not.F1REG) GOTO 380
       XE2H=XE2(HEF)
      CALL REGFA1(HEF,HMF2,XE2H,NMF2,0.001,NMF1,XE2,SCHALT,HMF1)
       IF(.not.SCHALT) GOTO 380
         WRITE(KONSOL,11)
11    FORMAT(1X,'*NE* HMF1 IS NOT EVALUATED BY THE FUNCTION XE2')
       IREGFA=1
c
c change B1 and try again ..........................................
c
9244        IF(B1.GT.4.5) GOTO (7398,8922) IREGFA
                 B1=B1+0.5
               WRITE(KONSOL,902) B1-0.5,B1
902   FORMAT(6X,'CORR.: B1(OLD)=',F4.1,' B1(NEW)=',F4.1)
              IF(GULB0) then
                     ib1=int(b1*2.-5.)
                     B0=B0CNEW/b0b1(ib1)
                     endif
                 GOTO 924
c
c omit F1 feature ....................................................
c
7398  WRITE(KONSOL,9269)
9269  FORMAT(1X,'CORR.: NO F1 REGION, B1=3, C1=0.0')
             HMF1=0.
             NMF1=0.
             C1=0.0
             B1=3.
             F1REG=.FALSE.

C
C SEARCH FOR HST [NE3(HST)=NME] ..........................................
C
380       RRRR=0.5
       IF(F1REG) then
              hf1=hmf1
              xf1=nmf1
              GOTO 3972
              ENDIF
       RATHH=0.5
3973       hf1=hef+(hmf2-hef)*RATHH
       xf1=xe3(hf1)
       IF(XF1.LT.NME) THEN
              RATHH=RATHH+.1
              GOTO 3973
              ENDIF
3972       h=hf1
       deh=10.
       XXMIN=XF1
       HHMIN=HF1
3895    h=h-deh
       if(h.lt.HEF) then
         h=h+2*deh
         deh=deh/10.
         if(deh.lt.1.) goto 3885
         endif
          XE3H=XE3(h)
       IF(XE3H.LT.XXMIN) then
         XXMIN=XE3H
         HHMIN=h
         endif
       if(XE3H.gt.NME) goto 3895
      CALL REGFA1(h,HF1,XE3H,XF1,0.001,NME,XE3,SCHALT,HST)
       STR=HST
       IF(.not.SCHALT) GOTO 360
3885       WRITE(KONSOL,100)
100   FORMAT(1X,'*NE* HST IS NOT EVALUATED BY THE FUNCTION XE3')
       IREGFA=2
       IF(XXMIN/NME.LT.1.3) GOTO 9244
c
c assume linear interpolation between HZ and HEF ..................
c
8922    HZ=HHMIN+(HF1-HHMIN)*RRRR
        XNEHZ=XE3(HZ)
        if(xnehz-nme.lt.0.001) then
          RRRR=RRRR+.1
          GOTO 8922
          endif
        WRITE(KONSOL,901) HZ,HEF
901   FORMAT(6X,'CORR.: LIN. APP. BETWEEN HZ=',F5.1,
     &          ' AND HEF=',F5.1)
        T=(XNEHZ-NME)/(HZ-HEF)
        HST=-333.
        GOTO 4933
c
c calculate HZ, D and T ............................................
c
360       HZ=(HST+HF1)/2.0
           D=HZ-HST
           T=D*D/(HZ-HEF-D)
       GOTO 4933
C
C LAY-functions for middle ionosphere
C
6153       HMF1M=165.+0.6428*XHI
       HHALF = GRAT * HMF2
       HV1R = HME + WIDTH
       HV2R = HME + HDEEP
       HHMF2 = HMF2
       CALL INILAY(NIGHT,NMF2,NMF1,NME,VNER,HHMF2,HMF1M,HME,
     &                     HV1R,HV2R,HHALF,HXL,SCL,AMP,IIQU)
       IF(IIQU.EQ.1) WRITE(KONSOL,7733)
7733      FORMAT('*NE* LAY amplitudes found with 2nd choice of HXL(1).')
       IF(IIQU.EQ.2) WRITE(KONSOL,7722)
7722       FORMAT('*NE* LAY amplitudes could not be found.')

C---------- CALCULATION OF NEUTRAL TEMPERATURE PARAMETER-------

4933  HTA=120.0
      HTE=3000.0
       IF(NOTEM) GOTO 240
      SEC=UT*3600.
      CALL CIRA86(DAYNR,SEC,LATI,LONGI,HOUR,COV,TEXOS,TN120,SIGMA)
        IF(HOUR.NE.0.0) THEN
      SECNI=(24.-LONGI/15.)*3600.
      CALL CIRA86(DAYNR,SECNI,LATI,LONGI,0.,COV,TEXNI,TN1NI,SIGNI)
       ELSE
      TEXNI=TEXOS
      TN1NI=TN120
      SIGNI=SIGMA
        ENDIF
      TLBDH=TEXOS-TN120
      TLBDN=TEXNI-TN1NI

!--------- CALCULATION OF ELECTRON TEMPERATURE PARAMETER--------

      CONTINUE

!!!!!!!!!! TE(120KM)=TN(120KM) !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      ATE(1)=TN120

!!!!!!!!!! TE-MAXIMUM (JICAMARCA,ARECIBO) !!!!!!!!!!!!!!!!!!!!
      HMAXD=60.*EXP(-(MLAT/22.41)**2)+210.
      HMAXN=150.
      AHH(2)=HPOL(HOUR,HMAXD,HMAXN,SAX,SUX,1.,1.)
      TMAXD=800.*EXP(-(MLAT/33.)**2)+1500.
      TMAXN=TN(HMAXN,TEXNI,TLBDN,SIGNI)+20
      ATE(2)=HPOL(HOUR,TMAXD,TMAXN,SAX,SUX,1.,1.)

!!!!!!!!!! TE(300,400KM)=TE-AE-C !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!! TE(1400,3000KM)=TE-ISIS !!!!!!!!!!!!!!!!!!!!!!!!!!!
       DIPLAT=MAGBR
      CALL TEBA(DIPLAT,HOUR,NSESON,TEA)
      ATE(3)=TEA(1)
      ATE(4)=TEA(2)
      ATE(6)=TEA(3)
      ATE(7)=TEA(4)

C !!!!!!!!!! TE(600KM)=TE-AEROS !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      ETT=EXP(-MLAT/11.35)
      TET=2900.-5600.*ETT/((ETT+1)**2.)
      TEN=839.+1161./(1.+EXP(-(ABSMLT-45.)/5.))
      ATE(5)=HPOL(HOUR,TET,TEN,SAX,SUX,1.5,1.5)

C !!!!!!!!!! OPTION TO USE TE-NE-RELATION !!!!!!!!!!!!!!!!!!!!!!
C !!!!!!!!!! AT 300, 400 OR 600 KM  !!!!!!!!!!!!!!!!!!!!!!!!!!!!
      IF(TENEOP) THEN
        DO 3395 I=1,3
3395         IF(TCON(I)) ATE(I+2)=TEDE(HOA(I),XNAR(I),-COV)
       ENDIF
C !!!!!!!!!! TE'S ARE CORRECTED !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C !!!!!!!!!! ALSO TE > TN ENFORCED !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      TNAHH2=TN(AHH(2),TEXOS,TLBDH,SIGMA)
      IF(ATE(2).LT.TNAHH2) ATE(2)=TNAHH2
      STTE1=(ATE(2)-ATE(1))/(AHH(2)-AHH(1))
      DO 1901 I=2,6
       TNAHHI=TN(AHH(I+1),TEXOS,TLBDH,SIGMA)
       IF(ATE(I+1).LT.TNAHHI) ATE(I+1)=TNAHHI
       STTE2=(ATE(I+1)-ATE(I))/(AHH(I+1)-AHH(I))
       ATE(I)=ATE(I)-(STTE2-STTE1)*DTE(I-1)*ALOG2
1901  STTE1=STTE2
C !!!!!!!!!! GRADIENTS ARE CALCULATED WITH !!!!!!!!!!!!!!!!!!!!
C !!!!!!!!!! CORRECTED REGION BOUNDARIES !!!!!!!!!!!!!!!!!!!!!!
      DO 1902 I=1,6
1902  STTE(I)=(ATE(I+1)-ATE(I))/(AHH(I+1)-AHH(I))
      ATE1=ATE(1)
      CONTINUE
C
C------------ CALCULATION OF ION TEMPERATURE PARAMETERS--------
C
C !!!!!!!!!! TI(430KM,DAY)=TI-AEROS !!!!!!!!!!!!!!!!!!!!!!!!!!!
      XSM1=430.0
      XSM(1)=XSM1
      Z1=EXP(-0.09*MLAT)
      Z2=Z1+1.
      TID1 = 1240.0 - 1400.0 * Z1 / ( Z2 * Z2 )
      MM(2)=HPOL(HOUR,3.0,0.0,SAX,SUX,1.,1.)
C !!!!!!!!!!  TI < TE   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        TED1=TEA(6)+30.
        IF(TID1.GT.TED1) TID1=TED1

C !!!!!!!!!! TI(430KM,NIGHT)=TI-AEROS !!!!!!!!!!!!!!!!!!!!!!!!!
      Z1=ABSMLT
      Z2=Z1*(0.47+Z1*0.024)*UMR
      Z3=COS(Z2)
      TIN1=1200.0-300.0*SIGN(1.0,Z3)*SQRT(ABS(Z3))
C !!!!!!!!!! TN < TI < TE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        TEN1=TEA(5)
       TNN1=TN(XSM1,TEXNI,TLBDN,SIGNI)
        IF(TEN1.LT.TNN1) TEN1=TNN1
        IF(TIN1.GT.TEN1) TIN1=TEN1
        IF(TIN1.LT.TNN1) TIN1=TNN1

C !!!!!!!!!! TI(430KM,LT) FROM STEP FUNCTION !!!!!!!!!!!!!!!!!!
       TI1=TIN1
        IF(TID1.GT.TIN1) TI1=HPOL(HOUR,TID1,TIN1,SAX,SUX,1.,1.)

C !!!!!!!!!! TANGENT ON TN DETERMINES HS !!!!!!!!!!!!!!!!!!!!!!
       TI13=TEDER(130.)
       TI50=TEDER(500.)
      CALL REGFA1(130.0,500.0,TI13,TI50,0.01,TI1,TEDER,SCHALT,HS)
      IF(SCHALT) HS=200.
      TNHS=TN(HS,TEXOS,TLBDH,SIGMA)
      MM(1)=DTNDH(HS,  TLBDH,SIGMA)
      IF(SCHALT) MM(1)=(TI1-TNHS)/(XSM1-HS)
      MXSM=2

C !!!!!!!!!! XTETI ALTITTUDE WHERE TE=TI !!!!!!!!!!!!!!!!!!!!!!
        XTTS=500.
        X=500.
2390    X=X+XTTS
        IF(X.GE.AHH(7)) GOTO 240
        TEX=ELTE(X)
        TIX=TI(X)
        IF(TIX.LT.TEX) GOTO 2390
        X=X-XTTS
        XTTS=XTTS/10.
        IF(XTTS.GT.0.1) GOTO 2390
        XTETI=X+XTTS*5.

C !!!!!!!!!! TI=TE ABOVE XTETI !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        MXSM=3
        MM(3)=STTE(6)
        XSM(2)=XTETI
        IF(XTETI.GT.AHH(6)) GOTO 240
        MXSM=4
        MM(3)=STTE(5)
        MM(4)=STTE(6)
        XSM(3)=AHH(6)
        IF(XTETI.GT.AHH(5)) GOTO 240
        MXSM=5
        DTI(1)=5.
        DTI(2)=5.
        MM(3)=STTE(4)
        MM(4)=STTE(5)
        MM(5)=STTE(6)
        XSM(3)=AHH(5)
        XSM(4)=AHH(6)
C
C CALCULATION OF ION DENSITY PARAMETER..................
C
240   IF(NOION) GOTO 141
      HNIA=100.
      HNIE=2000.
       if(DY) goto 141
C
C INPUT OF THE ION DENSITY PARAMETER ARRAYS PF1O,PF2O AND PF3O......
C
      RIF(1)=2.
      IF(ABSLAT.LT.30.0) RIF(1)=1.
      RIF(2)=2.
      IF(COV.LT.100.0) RIF(2)=1.
      RIF(3)=SEASON
      IF(SEASON.EQ.1) RIF(3)=3.
      RIF(4)=1.
      IF(NIGHT) RIF(4)=2.
      CALL KOEFP1(PG1O)
      CALL KOEFP2(PG2O)
      CALL KOEFP3(PG3O)
      CALL SUFE(PG1O,RIF,12,PF1O)
      CALL SUFE(PG2O,RIF, 4,PF2O)
      CALL SUFE(PG3O,RIF,12,PF3O)
c
c calculate O+ profile parameters
c
      IF(ABS(XHI).LE.90.0) THEN
       ZZZ1=COS(XHI*UMR)
      ELSE
       ZZZ1=0.0
      ENDIF
      msumo=4
      RDOMAX=100.0
      MO(1)=EPSTEP(PF1O(1),PF1O(2),PF1O(3),PF1O(4),ZZZ1)
      MO(2)=EPSTEP(PF1O(5),PF1O(6),PF1O(7),PF1O(8),ZZZ1)
      MO(3)=0.0
      HO(1)=EPSTEP(PF1O(9),PF1O(10),PF1O(11),PF1O(12),ZZZ1)
      HO(2)=290.0
      IF((RIF(2).EQ.2.).AND.(RIF(3).EQ.2.)) HO(2)=237.0
      HO(4)=PF2O(1)
       ho05=pf2o(4)
      MO(4)=PF2O(2)
      MO(5)=PF2O(3)
c
c adjust gradient MO(4) of O+ profile segment above F peak
c
7100          HO(3)=(ALG100-MO(5)*(HO(4)-ho05))/MO(4)+HO(4)
             IF(HO(3).LE.HO(2)+20.) THEN
              MO(4)=MO(4)-0.001
               GOTO 7100
              endif
       hfixo=(ho(2)+ho(3))/2.
c
c find height H0O of maximum O+ relative density
c
      DELX=5.0
      X=HO(2)
      YMAXX=0.0
7102  X=X+DELX
      Y=RPID(X,HFIXO,RDOMAX,msumo,MO,DDO,HO)
      IF(Y.LE.YMAXX) then
       if(delx.le.0.1) GOTO 7104
       x=x-delx
       delx=delx/5.
      ELSE
             YMAXX=Y
      ENDIF
      GOTO 7102
7104  H0O=X-DELX/2.
7101       if(y.lt.100.0) goto 7103
          rdomax=rdomax-0.01
       y=rpid(h0o,hfixo,rdomax,msumo,mo,ddo,ho)
       goto 7101
7103       yo2h0o=100.-y
       yoh0o=y
c
c calculate parameters for O2+ profile
c
       hfixo2  = pf3o(1)
       rdo2mx = pf3o(2)
      DO 7105 L=1,2
              I = L * 2
                    HO2(L)=PF3O(1+I)+PF3O(2+I)*ZZZ1
7105                MO2(L+1)=PF3O(7+I)+PF3O(8+I)*ZZZ1
      MO2(1)=PF3O(7)+PF3O(8)*ZZZ1
       if(hfixo2.gt.ho2(1)) then
          ymo2z=mo2(2)
       else
          ymo2z=mo2(1)
       endif
       aldo21=alog(rdo2mx)+ymo2z*(ho2(1)-hfixo2)
       hfixo2=(ho2(2)+ho2(1))/2.
       rdo2mx=exp(aldo21+mo2(2)*(hfixo2-ho2(1)))
c
c make sure that rd(O2+) is less or equal 100-rd(O+) at O+ maximum
c
7106  Y=RPID(H0O,hfixo2,rdo2mx,2,MO2,DO2,HO2)
      IF(Y.GT.yo2h0o) then
             MO2(3)=MO2(3)-0.02
             GOTO 7106
       endif
c
C use ratio of NO+ to O2+ density at O+ maximum to calculate
c NO+ density above the O+ maximum (H0O)
c
      IF(y.LT.1.) then
       NOBO2=0.0
      ELSE
       NOBO2= (yo2h0o-y)/y
      ENDIF
C
C CALCULATION FOR THE REQUIRED HEIGHT RANGE.......................
C
141   IF(.NOT.F1REG) HMF1=HZ

      DO 7397 KI=1,11
      DO 7397 KK=1,nz
7397    OUTF(KI,KK)=-1.

      do 7118 kk=1,nz
      height=zkm(kk)
      IF(NODEN) GOTO 330
      IF((HEIGHT.GT.HNEE).OR.(HEIGHT.LT.HNEA)) GOTO 330
       IF(LAYVER) THEN
         ELEDE=-9.
         IF(IIQU.LT.2) ELEDE=XEN(HEIGHT,HMF2,NMF2,HME,4,HXL,SCL,AMP)
       ELSE
         ELEDE=XE(HEIGHT)
       ENDIF
             OUTF(1,KK)=ELEDE
330   IF(NOTEM) GOTO 7108
      IF((HEIGHT.GT.HTE).OR.(HEIGHT.LT.HTA)) GOTO 7108
             TNH=TN(HEIGHT,TEXOS,TLBDH,SIGMA)
             TIH=TNH
             IF(HEIGHT.GE.HS) TIH=TI(HEIGHT)
             TEH=ELTE(HEIGHT)
       IF(TIH.LT.TNH) TIH=TNH
       IF(TEH.LT.TIH) TEH=TIH
             OUTF(2,KK)=TNH
             OUTF(3,KK)=TIH
             OUTF(4,KK)=TEH
7108  IF(NOION) GOTO 7118
      IF((HEIGHT.GT.HNIE).OR.(HEIGHT.LT.HNIA)) GOTO 7118
       if(DY) then
      call IONCOM(HEIGHT,XHI*UMR,LATI*UMR,COV,MONTH,DION)
      ROX=DION(1)
      RHX=DION(2)
      RNX=DION(3)
      RHEX=DION(4)
      RNOX=DION(5)
      RO2X=DION(6)
      RCLUST=DION(7)
       else
      ROX=RPID(HEIGHT,HFIXO,RDOMAX,msumo,MO,DDO,HO)
      RO2X=RPID(HEIGHT,HFIXO2,rdo2mx,2,MO2,DO2,HO2)
      CALL RDHHE(HEIGHT,H0O,ROX,RO2X,NOBO2,10.,RHX,RHEX)
      RNOX=RDNO(HEIGHT,H0O,RO2X,ROX,NOBO2)
      RNX=-1.
      RCLUST=-1.
       endif
      OUTF(5,KK)=ROX
      OUTF(6,KK)=RHX
      OUTF(7,KK)=RHEX
      OUTF(8,KK)=RO2X
      OUTF(9,KK)=RNOX
      OUTF(10,KK)=RNX
      OUTF(11,KK)=RCLUST

7118  continue
C
C ADDITIONAL PARAMETER FIELD OARR
C
        IF(NODEN) GOTO 6192
      OARR(1)=NMF2
      OARR(2)=HMF2
      OARR(3)=NMF1
      OARR(4)=HMF1
      OARR(5)=NME
      OARR(6)=HME
      OARR(7)=NMD
      OARR(8)=HMD
      OARR(9)=HHALF
      OARR(10)=B0
      OARR(11)=VNER
      OARR(12)=HEF
6192    IF(NOTEM) GOTO 6092
      OARR(13)=ATE(2)
      OARR(14)=AHH(2)
      OARR(15)=ATE(3)
      OARR(16)=ATE(4)
      OARR(17)=ATE(5)
      OARR(18)=ATE(6)
      OARR(19)=ATE(7)
      OARR(20)=ATE(1)
      OARR(21)=TI1
      OARR(22)=XTETI
6092  OARR(23)=XHI
      OARR(24)=SUNDEC
      OARR(25)=DIP
      OARR(26)=MAGBR
      OARR(27)=MODIP

      END SUBROUTINE IRI90


C
C IRIF12.FOR ------------------------------------- OCTOBER 1991
C**************************************************************
c changes from IRIFU9 to IRIF10:
c       SOCO for solar zenith angle
c       ACOS and ASIN argument forced to be within -1 / +1
c       EPSTEIN functions corrected for large arguments
C**************************************************************
c changes from IRIF10 to IRIF11:
c       LAY subroutines introduced
c       TEBA corrected for 1400 km
C**************************************************************
c changes from IRIF11 to IRIF12:
C       Neutral temperature subroutines now in CIRA86.FOR
C       TEDER changed
C       All names with 6 or more characters replaced
C       10/29/91 XEN: 10^ in loop, instead of at the end
C
C**************************************************************
C********** INTERNATIONAL REFERENCE IONOSPHERE ****************
C**************************************************************
C****************  FUNCTIONS,SUBROUTINES  *********************
C**************************************************************
C** NE:        XE1,DXE1N,XE2,XE3,XE4,XE5,XE6,XE
C** TE/TI:        TEBA,SPHARM,ELTE,TEDE,TI,TEDER
C** NI:              RPID,RDHHE,RDNO,KOEFP1,KOEFP2,KOEFP3,SUFE
C** PEAKS:       F2OUT,HMF2ED,FOF1ED,FOEEDI,XMDED,GAMMA1
C** MAG. FIELD: GGM,FIELDG
C** FUNCTIONS:        REGFA1,TAL
C** TIME:       SOCO,HPOL,MODA
C** INTERPOL.:       B0POL
C** EPSTEIN:       RLAY,D1LAY,D2LAY,EPTR,EPST,EPSTEP,EPLA
C** LAY:       XE2TO5,XEN,ROGUL,VALGUL,LNGLSN,LSKNM,INILAY
C** NI-new:       IONCOM, RPDA
C**************************************************************
C
C**************************************************************
C***  -------------------ADDRESSES------------------------  ***
C***  I  PROF. K. RAWER             DR. D. BILITZA       I  ***
C***  I  HERRENSTR. 43              GSFC CODE 933        I  ***
C***  I  7801 MARCH 1               GREENBELT MD 20771   I  ***
C***  I  F.R.G.                     USA                  I  ***
C***  ----------------------------------------------------  ***
C**************************************************************
C**************************************************************
C
C*************************************************************
C*************** ELECTRON DENSITY ****************************
C*************************************************************
C
C
      FUNCTION XE1(H)
c----------------------------------------------------------------
C REPRESENTING ELECTRON DENSITY(M-3) IN THE TOPSIDE IONOSPHERE
C (H=HMF2....1000 KM) BY HARMONIZED BENT-MODEL ADMITTING
C VARIABILITY OFGLOBAL PARAMETER ETA,ZETA,BETA,DELTA WITH
C GEOM. LATITUDE, SMOOTHED SOLAR FLUX AND CRITICAL FREQUENCY
C (SEE MAIN PROGRAM).
C [REF.:K.RAWER,S.RAMAKRISHNAN,1978]
c----------------------------------------------------------------
      COMMON       /BLOCK1/       HMF2,XNMF2,HMF1
     &              /BLO10/              BETA,ETA,DELTA,ZETA
     &              /ARGEXP/       ARGMAX

      DXDH = (1000.-HMF2)/700.
       x0 = 300. - delta
      xmx0 = (H-HMF2)/DXDH
         x = xmx0 + x0
       eptr1 = eptr(x,beta,394.5) - eptr(x0,beta,394.5)
       eptr2 = eptr(x,100.,300.0) - eptr(x0,100.,300.0)

      y = BETA * ETA * eptr1 + ZETA * (100. * eptr2 - xmx0)

        Y = y * dxdh
       if(abs(Y).gt.argmax) Y = sign(argmax,Y)
      XE1 = XNMF2 * EXP(-Y)
      RETURN
      END
C
C
      FUNCTION DXE1N(H)
C LOGARITHMIC DERIVATIVE OF FUNCTION XE1 (KM-1).
      COMMON       /BLOCK1/       HMF2,XNMF2,HMF1
     &              /BLO10/              BETA,ETA,DELTA,ZETA

       x0 = 300. - delta
      X=(H-HMF2)/(1000.0-HMF2)*700.0 + x0
       epst2 = epst(x,100.0,300.0)
       epst1 = epst(x,beta ,394.5)
      DXE1N = - ETA * epst1 + ZETA * (1. - epst2)
      RETURN
      END
C
C
      REAL FUNCTION XE2(H)
C ELECTRON DENSITY FOR THE BOTTOMSIDE F-REGION (HMF1...HMF2).
      COMMON       /BLOCK1/HMF2,XNMF2,HMF1
     &              /BLOCK2/B0,B1,C1       /ARGEXP/ARGMAX
      X=(HMF2-H)/B0
       z=x**b1
       if(z.gt.argmax) z=argmax
      XE2=XNMF2*EXP(-z)/COSH(X)
      RETURN
      END
C
C
      REAL FUNCTION XE3(H)
C ELECTRON DENSITY FOR THE F1-LAYER (HZ.....HMF1).
      COMMON       /BLOCK1/       HMF2,XNMF2,HMF1
     &              /BLOCK2/       B0,B1,C1
      XE3=XE2(H)+XNMF2*C1*SQRT(ABS(HMF1-H)/B0)
      RETURN
      END
C
C
      REAL FUNCTION XE4(H)
C ELECTRON DENSITY FOR THE INDERMEDIUM REGION (HEF..HZ).
      COMMON       /BLOCK3/       HZ,T,HST,STR
     &              /BLOCK4/       HME,XNME,HEF
      IF(HST.LT.0.) GOTO 100
      XE4=XE3(HZ+T/2.0-SIGN(1.0,T)*SQRT(T*(HZ-H+T/4.0)))
      RETURN
100   XE4=XNME+T*(H-HEF)
      RETURN
      END
C
C
      REAL FUNCTION XE5(H)
C ELECTRON DENSITY FOR THE E AND VALLEY REGION (HME..HEF).
      LOGICAL NIGHT
      COMMON       /BLOCK4/       HME,XNME,HEF
     &         /BLOCK5/       NIGHT,E(4)
      T3=H-HME
      T1=T3*T3*(E(1)+T3*(E(2)+T3*(E(3)+T3*E(4))))
      IF(NIGHT) GOTO 100
      XE5=XNME*(1+T1)
      RETURN
100   XE5=XNME*EXP(T1)

      END FUNCTION XE5
C
C
      REAL FUNCTION XE6(H)
C ELECTRON DENSITY FOR THE D REGION (HA...HME).
      COMMON       /BLOCK4/       HME,XNME,HEF
     &              /BLOCK6/       HMD,XNMD,HDX
     &              /BLOCK7/       D1,XKK,FP30,FP3U,FP1,FP2
      IF(H.GT.HDX) GOTO 100
      Z=H-HMD
      FP3=FP3U
      IF(Z.GT.0.0) FP3=FP30
      XE6=XNMD*EXP(Z*(FP1+Z*(FP2+Z*FP3)))
      RETURN
100   Z=HME-H
      XE6=XNME*EXP(-D1*Z**XKK)

      END FUNCTION XE6
C
C
      REAL FUNCTION XE(H)
C ELECTRON DENSITY BEETWEEN HA(KM) AND 1000 KM
C SUMMARIZING PROCEDURES  NE1....6;
      COMMON       /BLOCK1/HMF2,XNMF2,HMF1
     &              /BLOCK3/HZ,T,HST,STR
     &         /BLOCK4/HME,XNME,HEF
      IF(H.LT.HMF2) GOTO 100
      XE=XE1(H)
      RETURN
100   IF(H.LT.HMF1) GOTO 300
      XE=XE2(H)
      RETURN
300   IF(H.LT.HZ) GOTO 400
      XE=XE3(H)
      RETURN
400   IF(H.LT.HEF) GOTO 500
      XE=XE4(H)
      RETURN
500   IF(H.LT.HME) GOTO 600
      XE=XE5(H)
      RETURN
600   XE=XE6(H)
      RETURN
      END
C
C**********************************************************
C***************** ELECTRON TEMPERATURE ********************
C**********************************************************
C
      SUBROUTINE TEBA(DIPL,SLT,NS,TE)
C CALCULATES ELECTRON TEMPERATURES TE(1) TO TE(4) AT ALTITUDES
C 300, 400, 1400 AND 3000 KM FOR DIP-LATITUDE DIPL/DEG AND
C LOCAL SOLAR TIME SLT/H USING THE BRACE-THEIS-MODELS (J. ATMOS.
C TERR. PHYS. 43, 1317, 1981); NS IS SEASON IN NORTHERN
C HEMISOHERE: IS=1 SPRING, IS=2 SUMMER ....
C ALSO CALCULATED ARE THE TEMPERATURES AT 400 KM ALTITUDE FOR
C MIDNIGHT (TE(5)) AND NOON (TE(6)).
      DIMENSION C(4,2,81),A(82),TE(6)
      COMMON/CONST/UMR
      DATA (C(1,1,J),J=1,81)/
     &.3100E1,-.3215E-2,.2440E+0,-.4613E-3,-.1711E-1,.2605E-1,
     &-.9546E-1,.1794E-1,.1270E-1,.2791E-1,.1536E-1,-.6629E-2,
     &-.3616E-2,.1229E-1,.4147E-3,.1447E-2,-.4453E-3,-.1853,
     &-.1245E-1,-.3675E-1,.4965E-2,.5460E-2,.8117E-2,-.1002E-1,
     &.5466E-3,-.3087E-1,-.3435E-2,-.1107E-3,.2199E-2,.4115E-3,
     &.6061E-3,.2916E-3,-.6584E-1,.4729E-2,-.1523E-2,.6689E-3,
     &.1031E-2,.5398E-3,-.1924E-2,-.4565E-1,.7244E-2,-.8543E-4,
     &.1052E-2,-.6696E-3,-.7492E-3,.4405E-1,.3047E-2,.2858E-2,
     &-.1465E-3,.1195E-2,-.1024E-3,.4582E-1,.8749E-3,.3011E-3,
     &.4473E-3,-.2782E-3,.4911E-1,-.1016E-1,.27E-2,-.9304E-3,
     &-.1202E-2,.2210E-1,.2566E-2,-.122E-3,.3987E-3,-.5744E-1,
     &.4408E-2,-.3497E-2,.83E-3,-.3536E-1,-.8813E-2,.2423E-2,
     &-.2994E-1,-.1929E-2,-.5268E-3,-.2228E-1,.3385E-2,
     &.413E-1,.4876E-2,.2692E-1,.1684E-2/
      DATA (C(1,2,J),J=1,81)/.313654E1,.6796E-2,.181413,.8564E-1,
     &-.32856E-1,-.3508E-2,-.1438E-1,-.2454E-1,.2745E-2,.5284E-1,
     &.1136E-1,-.1956E-1,-.5805E-2,.2801E-2,-.1211E-2,.4127E-2,
     &.2909E-2,-.25751,-.37915E-2,-.136E-1,-.13225E-1,.1202E-1,
     &.1256E-1,-.12165E-1,.1326E-1,-.7123E-1,.5793E-3,.1537E-2,
     &.6914E-2,-.4173E-2,.1052E-3,-.5765E-3,-.4041E-1,-.1752E-2,
     &-.542E-2,-.684E-2,.8921E-3,-.2228E-2,.1428E-2,.6635E-2,-.48045E-2,
     &-.1659E-2,-.9341E-3,.223E-3,-.9995E-3,.4285E-1,-.5211E-3,
     &-.3293E-2,.179E-2,.6435E-3,-.1891E-3,.3844E-1,.359E-2,-.8139E-3,
     &-.1996E-2,.2398E-3,.2938E-1,.761E-2,.347655E-2,.1707E-2,.2769E-3,
     &-.157E-1,.983E-3,-.6532E-3,.929E-4,-.2506E-1,.4681E-2,.1461E-2,
     &-.3757E-5,-.9728E-2,.2315E-2,.6377E-3,-.1705E-1,.2767E-2,
     &-.6992E-3,-.115E-1,-.1644E-2,.3355E-2,-.4326E-2,.2035E-1,.2985E-1/
      DATA (C(2,1,J),J=1,81)/.3136E1,.6498E-2,.2289,.1859E-1,-.3328E-1,
     &-.4889E-2,-.3054E-1,-.1773E-1,-.1728E-1,.6555E-1,.1775E-1,
     &-.2488E-1,-.9498E-2,.1493E-1,.281E-2,.2406E-2,.5436E-2,-.2115,
     &.7007E-2,-.5129E-1,-.7327E-2,.2402E-1,.4772E-2,-.7374E-2,
     &-.3835E-3,-.5013E-1,.2866E-2,.2216E-2,.2412E-3,.2094E-2,.122E-2
     &,-.1703E-3,-.1082,-.4992E-2,-.4065E-2,.3615E-2,-.2738E-2,
     &-.7177E-3,.2173E-3,-.4373E-1,-.375E-2,.5507E-2,-.1567E-2,
     &-.1458E-2,-.7397E-3,.7903E-1,.4131E-2,.3714E-2,.1073E-2,
     &-.8991E-3,.2976E-3,.2623E-1,.2344E-2,.5608E-3,.4124E-3,.1509E-3,
     &.5103E-1,.345E-2,.1283E-2,.7238E-3,-.3464E-4,.1663E-1,-.1644E-2,
     &-.71E-3,.5281E-3,-.2729E-1,.3556E-2,-.3391E-2,-.1787E-3,.2154E-2,
     &.6476E-2,-.8282E-3,-.2361E-1,.9557E-3,.3205E-3,-.2301E-1,
     &-.854E-3,-.1126E-1,-.2323E-2,-.8582E-2,.2683E-1/
      DATA (C(2,2,J),J=1,81)/.3144E1,.8571E-2,.2539,.6937E-1,-.1667E-1,
     &.2249E-1,-.4162E-1,.1201E-1,.2435E-1,.5232E-1,.2521E-1,-.199E-1,
     &-.7671E-2,.1264E-1,-.1551E-2,-.1928E-2,.3652E-2,-.2019,.5697E-2,
     &-.3159E-1,-.1451E-1,.2868E-1,.1377E-1,-.4383E-2,.1172E-1,
     &-.5683E-1,.3593E-2,.3571E-2,.3282E-2,.1732E-2,-.4921E-3,-.1165E-2
     &,-.1066,-.1892E-1,.357E-2,-.8631E-3,-.1876E-2,-.8414E-4,.2356E-2,
     &-.4259E-1,-.322E-2,.4641E-2,.6223E-3,-.168E-2,-.1243E-3,.7393E-1,
     &-.3143E-2,-.2362E-2,.1235E-2,-.1551E-2,.2099E-3,.2299E-1,.5301E-2
     &,-.4306E-2,-.1303E-2,.7687E-5,.5305E-1,.6642E-2,-.1686E-2,
     &.1048E-2,.5958E-3,.4341E-1,-.8819E-4,-.333E-3,-.2158E-3,-.4106E-1
     &,.4191E-2,.2045E-2,-.1437E-3,-.1803E-1,-.8072E-3,-.424E-3,
     &-.26E-1,-.2329E-2,.5949E-3,-.1371E-1,-.2188E-2,.1788E-1,
     &.6405E-3,.5977E-2,.1333E-1/
      DATA (C(3,1,J),J=1,81)/.3372E1,.1006E-1,.1436,.2023E-2,-.5166E-1,
     &.9606E-2,-.5596E-1,.4914E-3,-.3124E-2,-.4713E-1,-.7371E-2,
     &-.4823E-2,-.2213E-2,.6569E-2,-.1962E-3,.3309E-3,-.3908E-3,
     &-.2836,.7829E-2,.1175E-1,.9919E-3,.6589E-2,.2045E-2,-.7346E-2
     &,-.89E-3,-.347E-1,-.4977E-2,.147E-2,-.2823E-5,.6465E-3,
     &-.1448E-3,.1401E-2,-.8988E-1,-.3293E-4,-.1848E-2,.4439E-3,
     &-.1263E-2,.317E-3,-.6227E-3,.1721E-1,-.199E-2,-.4627E-3,
     &.2897E-5,-.5454E-3,.3385E-3,.8432E-1,-.1951E-2,.1487E-2,
     &.1042E-2,-.4788E-3,-.1276E-3,.2373E-1,.2409E-2,.5263E-3,
     &.1301E-2,-.4177E-3,.3974E-1,.1418E-3,-.1048E-2,-.2982E-3,
     &-.3396E-4,.131E-1,.1413E-2,-.1373E-3,.2638E-3,-.4171E-1,
     &-.5932E-3,-.7523E-3,-.6883E-3,-.2355E-1,.5695E-3,-.2219E-4,
     &-.2301E-1,-.9962E-4,-.6761E-3,.204E-2,-.5479E-3,.2591E-1,
     &-.2425E-2,.1583E-1,.9577E-2/
      DATA (C(3,2,J),J=1,81)/.3367E1,.1038E-1,.1407,.3622E-1,-.3144E-1,
     &.112E-1,-.5674E-1,.3219E-1,.1288E-2,-.5799E-1,-.4609E-2,
     &.3252E-2,-.2859E-3,.1226E-1,-.4539E-2,.1310E-2,-.5603E-3,
     &-.311,-.1268E-2,.1539E-1,.3146E-2,.7787E-2,-.143E-2,-.482E-2
     &,.2924E-2,-.9981E-1,-.7838E-2,-.1663E-3,.4769E-3,.4148E-2,
     &-.1008E-2,-.979E-3,-.9049E-1,-.2994E-2,-.6748E-2,-.9889E-3,
     &.1488E-2,-.1154E-2,-.8412E-4,-.1302E-1,-.4859E-2,-.7172E-3,
     &-.9401E-3,.9101E-3,-.1735E-3,.7055E-1,.6398E-2,-.3103E-2,
     &-.938E-3,-.4E-3,-.1165E-2,.2713E-1,-.1654E-2,.2781E-2,
     &-.5215E-5,.2258E-3,.5022E-1,.95E-2,.4147E-3,.3499E-3,
     &-.6097E-3,.4118E-1,.6556E-2,.3793E-2,-.1226E-3,-.2517E-1,
     &.1491E-3,.1075E-2,.4531E-3,-.9012E-2,.3343E-2,.3431E-2,
     &-.2519E-1,.3793E-4,.5973E-3,-.1423E-1,-.132E-2,-.6048E-2,
     &-.5005E-2,-.115E-1,.2574E-1/
      DATA (C(4,1,J),J=1,81)/.3574E1,.0,.7537E-1,.0,-.8459E-1,
     &0.,-.294E-1,0.,.4547E-1,-.5321E-1,0.,.4328E-2,0.,.6022E-2,
     &.0,-.9168E-3,.0,-.1768,.0,.294E-1,.0,.5902E-3,.0,-.9047E-2,
     &.0,-.6555E-1,.0,-.1033E-2,.0,.1674E-2,.0,.2802E-3,-.6786E-1
     &,.0,.4193E-2,.0,-.6448E-3,.0,.9277E-3,-.1634E-1,.0,-.2531E-2
     &,.0,.193E-4,.0,.528E-1,.0,.2438E-2,.0,-.5292E-3,.0,.1555E-1
     &,.0,-.3259E-2,.0,-.5998E-3,.3168E-1,.0,.2382E-2,.0,-.4078E-3
     &,.2312E-1,.0,.1481E-3,.0,-.1885E-1,.0,.1144E-2,.0,-.9952E-2
     &,.0,-.551E-3,-.202E-1,.0,-.7283E-4,-.1272E-1,.0,.2224E-2,
     &.0,-.251E-2,.2434E-1/
      DATA (C(4,2,J),J=1,81)/.3574E1,-.5639E-2,.7094E-1,
     &-.3347E-1,-.861E-1,-.2877E-1,-.3154E-1,-.2847E-2,.1235E-1,
     &-.5966E-1,-.3236E-2,.3795E-3,-.8634E-3,.3377E-2,-.1071E-3,
     &-.2151E-2,-.4057E-3,-.1783,.126E-1,.2835E-1,-.242E-2,
     &.3002E-2,-.4684E-2,-.6756E-2,-.7493E-3,-.6147E-1,-.5636E-2
     &,-.1234E-2,-.1613E-2,-.6353E-4,-.2503E-3,-.1729E-3,-.7148E-1
     &,.5326E-2,.4006E-2,.6484E-3,-.1046E-3,-.6034E-3,-.9435E-3,
     &-.2385E-2,.6853E-2,.151E-2,.1319E-2,.9049E-4,-.1999E-3,
     &.3976E-1,.2802E-2,-.103E-2,.5599E-3,-.4791E-3,-.846E-4,
     &.2683E-1,.427E-2,.5911E-3,.2987E-3,-.208E-3,.1396E-1,
     &-.1922E-2,-.1063E-2,.3803E-3,.1343E-3,.1771E-1,-.1038E-2,
     &-.4645E-3,-.2481E-3,-.2251E-1,-.29E-2,-.3977E-3,-.516E-3,
     &-.8079E-2,-.1528E-2,.306E-3,-.1582E-1,-.8536E-3,.1565E-3,
     &-.1252E-1,.2319E-3,.4311E-2,.1024E-2,.1296E-5,.179E-1/
       IF(NS.LT.3) THEN
          IS=NS
       ELSE IF(NS.GT.3) THEN
          IS=2
          DIPL=-DIPL
       ELSE
          IS=1
       ENDIF
      COLAT=UMR*(90.-DIPL)
      AZ=.2618*SLT
      CALL SPHARM(A,8,8,COLAT,AZ)
       IF(IS.EQ.2) THEN
          KEND=3
       ELSE
          KEND=4
       ENDIF
      DO 2 K=1,KEND
      STE=0.
      DO 1 I=1,81
1       STE=STE+A(I)*C(K,IS,I)
2     TE(K)=10.**STE
       IF(IS.EQ.2) THEN
          DIPL=-DIPL
          COLAT=UMR*(90.-DIPL)
           CALL SPHARM(A,8,8,COLAT,AZ)
           STE=0.
           DO 11 I=1,81
11            STE=STE+A(I)*C(4,2,I)
           TE(4)=10.**STE
           ENDIF

C---------- TEMPERATURE AT 400KM AT MIDNIGHT AND NOON
      DO 4 J=1,2
        STE=0.
        AZ=.2618*(J-1)*12.
        CALL SPHARM(A,8,8,COLAT,AZ)
        DO 3 I=1,81
3         STE=STE+A(I)*C(2,IS,I)
4       TE(J+4)=10.**STE
      RETURN
      END
C
      SUBROUTINE SPHARM(C,L,M,COLAT,AZ)
C CALCULATES THE COEFFICIENTS OF THE SPHERICAL HARMONIC
C EXPANSION THAT WAS USED FOR THE BRACE-THEIS-MODELS.
      DIMENSION C(82)
      C(1)=1.
      K=2
      X=COS(COLAT)
      C(K)=X
      K=K+1
      DO 10 I=2,L
      C(K)=((2*I-1)*X*C(K-1)-(I-1)*C(K-2))/I
10    K=K+1
      Y=SIN(COLAT)
      DO 20 MT=1,M
      CAZ=COS(MT*AZ)
      SAZ=SIN(MT*AZ)
      C(K)=Y**MT
      K=K+1
      IF(MT.EQ.L) GOTO 16
      C(K)=C(K-1)*X*(2*MT+1)
      K=K+1
      IF((MT+1).EQ.L) GOTO 16
      DO 15 I=2+MT,L
      C(K)=((2*I-1)*X*C(K-1)-(I+MT-1)*C(K-2))/(I-MT)
15    K=K+1
16    N=L-MT+1
      DO 18 I=1,N
      C(K)=C(K-N)*CAZ
      C(K-N)=C(K-N)*SAZ
18    K=K+1
20    CONTINUE

      END SUBROUTINE SPHARM
C
C
      REAL FUNCTION ELTE(H)
c----------------------------------------------------------------
C ELECTRON TEMPERATURE PROFILE BASED ON THE TEMPERATURES AT 120
C HMAX,300,400,600,1400,3000 KM ALTITUDE. INBETWEEN CONSTANT
C GRADIENT IS ASSUMED. ARGMAX IS MAXIMUM ARGUMENT ALLOWED FOR
C EXP-FUNCTION.
c----------------------------------------------------------------
      COMMON /BLOTE/AH(7),ATE1,ST(6),D(5)
C
      SUMM=ATE1+ST(1)*(H-AH(1))
      DO 1 I=1,5
       aa = eptr(h    ,d(i),ah(i+1))
       bb = eptr(ah(1),d(i),ah(i+1))
1     SUMM=SUMM+(ST(I+1)-ST(I))*(AA-BB)*D(I)
      ELTE=SUMM

      END FUNCTION ELTE
C
C
      Pure Real FUNCTION TEDE(H,DEN,COV)
      Implicit None

      Real,Intent(In) :: h,den,cov

      Real y,acov,yc
C ELECTRON TEMEPERATURE MODEL AFTER BRACE,THEIS .
C FOR NEG. COV THE MEAN COV-INDEX (3 SOLAR ROT.) IS EXPECTED.
C DEN IS THE ELECTRON DENSITY IN M-3.
      Y=1051.+(17.01*H-2746.)*
     &EXP(-5.122E-4*H+(6.094E-12-3.353E-14*H)*DEN)
      ACOV=ABS(COV)
      YC=1.+(.117+2.02E-3*ACOV)/(1.+EXP(-(ACOV-102.5)/5.))
      IF(COV.LT.0.)
     &YC=1.+(.123+1.69E-3*ACOV)/(1.+EXP(-(ACOV-115.)/10.))
      TEDE=Y*YC

      END FUNCTION TEDE
C
C
C*************************************************************
C**************** ION TEMPERATURE ****************************
C*************************************************************
C
C
      REAL FUNCTION TI(H)
c----------------------------------------------------------------
C ION TEMPERATURE FOR HEIGHTS NOT GREATER 1000 KM AND NOT LESS HS
C EXPLANATION SEE FUNCTION RPID.
c----------------------------------------------------------------
      REAL               MM
      COMMON  /BLOCK8/  HS,TNHS,XSM(4),MM(5),G(4),M

      SUMM=MM(1)*(H-HS)+TNHS
      DO 100 I=1,M-1
       aa = eptr(h ,g(i),xsm(i))
       bb = eptr(hs,g(i),xsm(i))
100          SUMM=SUMM+(MM(I+1)-MM(I))*(AA-BB)*G(I)
      TI=SUMM

      END FUNCTION TI
C
C
      REAL FUNCTION TEDER(H)
      Implicit None

      Real,Intent(In) :: H

      Real :: TN,DTNDH !functions
      Real XSM1,TEX,TLBD,SIG,dtdx,tnh
C THIS FUNCTION ALONG WITH PROCEDURE REGFA1 ALLOWS TO FIND
C THE  HEIGHT ABOVE WHICH TN BEGINS TO BE DIFFERENT FROM TI
      COMMON       /BLOTN/XSM1,TEX,TLBD,SIG
      TNH = TN(H,TEX,TLBD,SIG)
      DTDX = DTNDH(H,TLBD,SIG)
      TEDER = DTDX * ( XSM1 - H ) + TNH

      END FUNCTION TEDER
C
C
C*************************************************************
C************* ION RELATIVE PRECENTAGE DENSITY *****************
C*************************************************************
C
C
      REAL FUNCTION RPID (H, H0, N0, M, ST, ID, XS)
      Implicit None
c------------------------------------------------------------------
C D.BILITZA,1977,THIS ANALYTIC FUNCTION IS USED TO REPRESENT THE
C RELATIVE PRECENTAGE DENSITY OF ATOMAR AND MOLECULAR OXYGEN IONS.
C THE M+1 HEIGHT GRADIENTS ST(M+1) ARE CONNECTED WITH EPSTEIN-
C STEP-FUNCTIONS AT THE STEP HEIGHTS XS(M) WITH TRANSITION
C THICKNESSES ID(M). RPID(H0,H0,N0,....)=N0.
C ARGMAX is the highest allowed argument for EXP in your system.
c------------------------------------------------------------------
      Real, Intent(In) :: H,H0,n0, ST(*),XS(*)
      Integer, Intent(In) :: M,ID(*)

      Real eptr
      Real aa,bb,xi,summ,sm,argmax
      integer i

      COMMON  /ARGEXP/       ARGMAX

      SUMM=(H-H0)*ST(1)
      DO 100  I=1,M
             XI=ID(I)
              aa = eptr(h ,xi,xs(i))
              bb = eptr(h0,xi,xs(i))
100             SUMM=SUMM+(ST(I+1)-ST(I))*(AA-BB)*XI
      IF(ABS(SUMM).LT.ARGMAX) then
       SM=EXP(SUMM)
      else IF(SUMM.Gt.0.0) then
       SM=EXP(ARGMAX)
      else
       SM=0.0
      endif
      RPID= n0 * SM
      RETURN
      END
C
c
      SUBROUTINE RDHHE (H,HB,RDOH,RDO2H,RNO,PEHE,RDH,RDHE)
C BILITZA,FEB.82,H+ AND HE+ RELATIVE PERECENTAGE DENSITY BELOW
C 1000 KM. THE O+ AND O2+ REL. PER. DENSITIES SHOULD BE GIVEN
C (RDOH,RDO2H). HB IS THE ALTITUDE OF MAXIMAL O+ DENSITY. PEHE
C IS THE PRECENTAGE OF HE+ IONS COMPARED TO ALL LIGHT IONS.
C RNO IS THE RATIO OF NO+ TO O2+DENSITY AT H=HB.
      RDHE=0.0
      RDH=0.0
      IF(H.LE.HB) GOTO 100
      REST=100.0-RDOH-RDO2H-RNO*RDO2H
      RDH=REST*(1.-PEHE/100.)
      RDHE=REST*PEHE/100.
100   RETURN
      END
C
C
      REAL FUNCTION RDNO(H,HB,RDO2H,RDOH,RNO)
C D.BILITZA, 1978. NO+ RELATIVE PERCENTAGE DENSITY ABOVE 100KM.
C FOR MORE INFORMATION SEE SUBROUTINE RDHHE.
      IF (H.GT.HB) GOTO 200
      RDNO=100.0-RDO2H-RDOH
      RETURN
200   RDNO=RNO*RDO2H
      RETURN
      END
C
C
      SUBROUTINE  KOEFP1(PG1O)
C THIEMANN,1979,COEFFICIENTS PG1O FOR CALCULATING  O+ PROFILES
C BELOW THE F2-MAXIMUM. CHOSEN TO APPROACH DANILOV-
C SEMENOV'S COMPILATION.
      DIMENSION PG1O(80)
      REAL FELD (80)
      DATA FELD/-11.0,-11.0,4.0,-11.0,0.08018,
     &0.13027,0.04216,0.25  ,-0.00686,0.00999,
     &5.113,0.1 ,170.0,180.0,0.1175,0.15,-11.0,
     &1.0 ,2.0,-11.0,0.069,0.161,0.254,0.18,0.0161,
     &0.0216,0.03014,0.1,152.0,167.0,0.04916,
     &0.17,-11.0,2.0,2.0,-11.0,0.072,0.092,0.014,0.21,
     &0.01389,0.03863,0.05762,0.12,165.0,168.0,0.008,
     &0.258,-11.0,1.0,3.0,-11.0,0.091,0.088,
     &0.008,0.34,0.0067,0.0195,0.04,0.1,158.0,172.0,
     &0.01,0.24,-11.0,2.0,3.0, -11.0,0.083,0.102,
     &0.045,0.03,0.00127,0.01,0.05,0.09,167.0,185.0,
     &0.015,0.18/
      K=0
      DO 10 I=1,80
      K=K+1
10    PG1O(K)=FELD(I)
      RETURN
      END
C
C
      SUBROUTINE KOEFP2(PG2O)
C THIEMANN,1979,COEFFICIENTS FOR CALCULATION OF O+ PROFILES
C ABOVE THE F2-MAXIMUM (DUMBS,SPENNER:AEROS-COMPILATION)
      DIMENSION PG2O(32)
      REAL FELD(32)
      DATA FELD/1.0,-11.0,-11.0,1.0,695.0,-.000781,
     &-.00264,2177.0,1.0,-11.0,-11.0,2.0,570.0,
     &-.002,-.0052,1040.0,2.0,-11.0,-11.0,1.0,695.0,
     &-.000786,-.00165,3367.0,2.0,-11.0,-11.0,2.0,
     &575.0,-.00126,-.00524,1380.0/
      K=0
      DO 10 I=1,32
      K=K+1
10    PG2O(K)=FELD(I)
      END
C
C
      SUBROUTINE  KOEFP3(PG3O)
C THIEMANN,1979,COEFFICIENTS FOR CALCULATING O2+ PROFILES.
C CHOSEN AS TO APPROACH DANILOV-SEMENOV'S COMPILATION.
      DIMENSION PG3O(80)
      REAL FELD(80)
      DATA FELD/-11.0,1.0,2.0,-11.0,160.0,31.0,130.0,
     &-10.0,198.0,0.0,0.05922,-0.07983,
     &-0.00397,0.00085,-0.00313,0.0,-11.0,2.0,2.0,-11.0,
     &140.0,30.0,130.0,-10.0,
     &190.0,0.0,0.05107,-0.07964,0.00097,-0.01118,-0.02614,
     &-0.09537,
     &-11.0,1.0,3.0,-11.0,140.0,37.0,125.0,0.0,182.0,
     &0.0,0.0307,-0.04968,-0.00248,
     &-0.02451,-0.00313,0.0,-11.0,2.0,3.0,-11.0,
     &140.0,37.0,125.0,0.0,170.0,0.0,
     &0.02806,-0.04716,0.00066,-0.02763,-0.02247,-0.01919,
     &-11.0,-11.0,4.0,-11.0,140.0,45.0,136.0,-9.0,
     &181.0,-26.0,0.02994,-0.04879,
     &-0.01396,0.00089,-0.09929,0.05589/
      K=0
      DO 10 I=1,80
      K=K+1
10    PG3O(K)=FELD(I)
      END
C
C
      SUBROUTINE SUFE (FIELD,RFE,M,FE)
      Implicit None
C SELECTS THE REQUIRED ION DENSITY PARAMETER SET.
C THE INPUT FIELD INCLUDES DIFFERENT SETS OF DIMENSION M EACH
C CARACTERISED BY 4 HEADER NUMBERS. RFE(4) SHOULD CONTAIN THE
C CHOSEN HEADER NUMBERS.FE(M) IS THE CORRESPONDING SET.
      Real,Intent(out) :: FE(*)
      Real,Intent(In)  :: field(*),rfe(*)
      integer,Intent(In):: M

      Real EFE(4)
      Integer K,I

      K=0
100   DO 101 I=1,4
      K=K+1
101   EFE(I)=FIELD(K)
      DO 111 I=1,M
      K=K+1
111   FE(I)=FIELD(K)
      DO 120 I=1,4
      IF((EFE(I).GT.-10.0).AND.(RFE(I).NE.EFE(I))) GOTO 100
120   CONTINUE

      END Subroutine SUFE
C
C
C*************************************************************
C************* PEAK VALUES ELECTRON DENSITY ******************
C*************************************************************
C
C
      SUBROUTINE F2OUT(XMODIP,XLATI,XLONGI,FF0,XM0,UT,
     &                              FOF2,XM3000)
C CALCULATES FOF2/MHZ AND M3000 USING THE CCIR-MAPS.
C INPUT: MODIFIED DIP LATITUDE XMODIP, GEOG. LATITUDE XLATI,
C LONGITUDE XLONGI (ALL IN DEG.), SMOOTHED SUNSPOT NUMBER R,
C MONTH AND UNIVERSAL TIME UT (DEC. HOURS).
C D.BILITZA,JULY 85.
      DIMENSION FF0(988),XM0(441)
      INTEGER QM(7),QF(9)
      DATA QF/11,11,8,4,1,0,0,0,0/,QM/6,7,5,2,1,0,0/
      FOF2=GAMMA1(XMODIP,XLATI,XLONGI,UT,6,QF,9,76,13,988,FF0)
      XM3000=GAMMA1(XMODIP,XLATI,XLONGI,UT,4,QM,7,49,9,441,XM0)
      RETURN
      END
C
C
      REAL FUNCTION HMF2ED(XMAGBR,R,X,XM3)
C CALCULATES THE PEAK HEIGHT HMF2/KM FOR THE MAGNETIC
C LATITUDE XMAGBR/DEG. AND THE SMOOTHED ZUERICH SUNSPOT
C NUMBER R USING CCIR-M3000 XM3 AND THE RATIO X=FOF2/FOE.
C [REF. D.BILITZA ET AL., TELECOMM.J., 46, 549-553, 1979]
C D.BILITZA,1980.
      F1=(2.32E-3)*R+0.222
      F2=1.2-(1.16E-2)*EXP((2.39E-2)*R)
      F3=0.096*(R-25.0)/150.0
      DELM=F1*(1.0-R/150.0*EXP(-XMAGBR*XMAGBR/1600.0))/(X-F2)+F3
      HMF2ED=1490.0/(XM3+DELM)-176.0

      END FUNCTION HMF2ED
C
C
      REAL FUNCTION FOF1ED(YLATI,R,CHI)
c--------------------------------------------------------------
C CALCULATES THE F1 PEAK PLASMA FREQUENCY (FOF1/MHZ)
C FOR        DIP-LATITUDE (YLATI/DEGREE)
c       SMOOTHED ZURICH SUNSPOT NUMBER (R)
c       SOLAR ZENITH ANGLE (CHI/DEGREE)
C REFERENCE:
c       E.D.DUCHARME ET AL., RADIO SCIENCE 6, 369-378, 1971
C                                    AND 8, 837-839, 1973
c       HOWEVER WITH MAGNETIC DIP LATITUDE INSTEAD OF GEOMAGNETIC
c       DIPOLE LATITUDE, EYFRIG, 1979
C--------------------------------------------- D. BILITZA, 1988.
       COMMON/CONST/UMR
       FOF1 = 0.0
       DLA =  YLATI
              CHI0 = 49.84733 + 0.349504 * DLA
              CHI100 = 38.96113 + 0.509932 * DLA
              CHIM = ( CHI0 + ( CHI100 - CHI0 ) * R / 100. )
              IF(CHI.GT.CHIM) GOTO 1
         F0 = 4.35 + DLA * ( 0.0058 - 1.2E-4 * DLA )
       F100 = 5.348 + DLA * ( 0.011 - 2.3E-4 * DLA )
       FS = F0 + ( F100 - F0 ) * R / 100.0
       XMUE = 0.093 + DLA * ( 0.0046 - 5.4E-5 * DLA ) + 3.0E-4 * R
       FOF1 = FS * COS( CHI * UMR ) ** XMUE
1       FOF1ED = FOF1
       RETURN
       END
C
C
      REAL FUNCTION FOEEDI(COV,XHI,XHIM,XLATI)
C-------------------------------------------------------
C CALCULATES FOE/MHZ BY THE EDINBURGH-METHOD.
C INPUT: MEAN 10.7CM SOLAR RADIO FLUX (COV), GEOGRAPHIC
C LATITUDE (XLATI/DEG), SOLAR ZENITH ANGLE (XHI/DEG AND
C XHIM/DEG AT NOON).
C REFERENCE:
C        KOURIS-MUGGELETON, CCIR DOC. 6/3/07, 1973
C        TROST, J. GEOPHYS. RES. 84, 2736, 1979 (was used
C              to improve the nighttime varition)
C D.BILITZA--------------------------------- AUGUST 1986.
      COMMON/CONST/UMR
C variation with solar activity (factor A) ...............
      A=1.0+0.0094*(COV-66.0)
C variation with noon solar zenith angle (B) and with latitude (C)
      SL=COS(XLATI*UMR)
       IF(XLATI.LT.32.0) THEN
              SM=-1.93+1.92*SL
              C=23.0+116.0*SL
        ELSE
               SM=0.11-0.49*SL
               C=92.0+35.0*SL
         ENDIF
       if(XHIM.ge.90.) XHIM=89.999
       B = COS(XHIM*UMR) ** SM
C variation with solar zenith angle (D) ..........................
        IF(XLATI.GT.12.0) THEN
              SP=1.2
       ELSE
              SP=1.31
       ENDIF
C adjusted solar zenith angle during nighttime (XHIC) .............
      XHIC=XHI-3.*ALOG(1.+EXP((XHI-89.98)/3.))
      D=COS(XHIC*UMR)**SP
C determine foE**4 ................................................
      R4FOE=A*B*C*D
C minimum allowable foE (sqrt[SMIN])...............................
      SMIN=0.121+0.0015*(COV-60.)
      SMIN=SMIN*SMIN
      IF(R4FOE.LT.SMIN) R4FOE=SMIN
      FOEEDI=R4FOE**0.25
      RETURN
      END
C
C
      REAL FUNCTION XMDED(XHI,R,YW)
C D. BILITZA, 1978, CALCULATES ELECTRON DENSITY OF D MAXIMUM.
C XHI/DEG. IS SOLAR ZENITH ANGLE, R SMOOTHED ZURICH SUNSPOT NUMBER
C AND YW/M-3 THE ASSUMED CONSTANT NIGHT VALUE.
C [REF.: D.BILITZA, WORLD DATA CENTER A REPORT UAG-82,7,
C       BOULDER,1981]
      COMMON/CONST/UMR
      Y=6.05E8+0.088E8*R
      Z=(-0.1/(ALOG(YW/Y)))**0.3704
       if(abs(z).gt.1.) z=sign(1.,z)
      SUXHI=ACOS(Z)
      IF (SUXHI.LT.1.0472) SUXHI=1.0472
      XXHI=XHI*UMR
      IF (XXHI.GT.SUXHI) GOTO 100
      X=COS(XXHI)
      XMDED=Y*EXP(-0.1/X**2.7)
      RETURN
100   XMDED=YW
      RETURN
      END
C
C
      REAL FUNCTION GAMMA1(SMODIP,SLAT,SLONG,HOUR,IHARM,NQ,
     &                       K1,M,MM,M3,SFE)
C CALCULATES GAMMA1=FOF2 OR M3000 USING CCIR NUMERICAL MAP
C COEFFICIENTS SFE(M3) FOR MODIFIED DIP LATITUDE (SMODIP/DEG)
C GEOGRAPHIC LATITUDE (SLAT/DEG) AND LONGITUDE (SLONG/DEG)
C AND UNIVERSIAL TIME (HOUR/DECIMAL HOURS).
C NQ(K1) IS AN INTEGER ARRAY GIVING THE HIGHEST DEGREES IN
C LATITUDE FOR EACH LONGITUDE HARMONIC.
C M=1+NQ1+2(NQ2+1)+2(NQ3+1)+... .
C SHEIKH,4.3.77.
      REAL*8 C(12),S(12),COEF(100),SUMM
      DIMENSION NQ(K1),XSINX(13),SFE(M3)
      COMMON/CONST/UMR
      HOU=(15.0*HOUR-180.0)*UMR
      S(1)=SIN(HOU)
      C(1)=COS(HOU)
      DO 250 I=2,IHARM
      C(I)=C(1)*C(I-1)-S(1)*S(I-1)
      S(I)=C(1)*S(I-1)+S(1)*C(I-1)
250   CONTINUE
      DO 300 I=1,M
      MI=(I-1)*MM
      COEF(I)=SFE(MI+1)
      DO 300 J=1,IHARM
      COEF(I)=COEF(I)+SFE(MI+2*J)*S(J)+SFE(MI+2*J+1)*C(J)
300   CONTINUE
      SUMM=COEF(1)
      SS=SIN(SMODIP*UMR)
      S3=SS
      XSINX(1)=1.0
      INDX=NQ(1)
      DO 350 J=1,INDX
      SUMM=SUMM+COEF(1+J)*SS
      XSINX(J+1)=SS
      SS=SS*S3
350   CONTINUE
      XSINX(NQ(1)+2)=SS
      NP=NQ(1)+1
      SS=COS(SLAT*UMR)
      S3=SS
      DO 400 J=2,K1
      S0=SLONG*(J-1.)*UMR
      S1=COS(S0)
      S2=SIN(S0)
      INDX=NQ(J)+1
      DO 450 L=1,INDX
      NP=NP+1
      SUMM=SUMM+COEF(NP)*XSINX(L)*SS*S1
      NP=NP+1
      SUMM=SUMM+COEF(NP)*XSINX(L)*SS*S2
450   CONTINUE
      SS=SS*S3
400   CONTINUE
      GAMMA1=real(SUMM)

      END FUNCTION GAMMA1
C
C
C************************************************************
C*************** EARTH MAGNETIC FIELD ***********************
C**************************************************************
C
C
      SUBROUTINE GGM(ART,LONG,LATI,MLONG,MLAT)
C CALCULATES GEOMAGNETIC LONGITUDE (MLONG) AND LATITUDE (MLAT)
C FROM GEOGRAFIC LONGITUDE (LONG) AND LATITUDE (LATI) FOR ART=0
C AND REVERSE FOR ART=1. ALL ANGLES IN DEGREE.
C LATITUDE:-90 TO 90. LONGITUDE:0 TO 360 EAST.
      INTEGER ART
      REAL MLONG,MLAT,LONG,LATI
      COMMON/CONST/FAKTOR
      ZPI=FAKTOR*360.
      CBG=11.4*FAKTOR
      CI=COS(CBG)
      SI=SIN(CBG)
      IF(ART.EQ.0) GOTO 10
      CBM=COS(MLAT*FAKTOR)
      SBM=SIN(MLAT*FAKTOR)
      CLM=COS(MLONG*FAKTOR)
      SLM=SIN(MLONG*FAKTOR)
      SBG=SBM*CI-CBM*CLM*SI
        IF(ABS(SBG).GT.1.) SBG=SIGN(1.,SBG)
      LATI=ASIN(SBG)
      CBG=COS(LATI)
      SLG=(CBM*SLM)/CBG
      CLG=(SBM*SI+CBM*CLM*CI)/CBG
        IF(ABS(CLG).GT.1.) CLG=SIGN(1.,CLG)
      LONG=ACOS(CLG)
      IF(SLG.LT.0.0) LONG=ZPI-LONG
      LATI=LATI/FAKTOR
      LONG=LONG/FAKTOR
      LONG=LONG-69.8
      IF(LONG.LT.0.0) LONG=LONG+360.0
      RETURN
10    YLG=LONG+69.8
      CBG=COS(LATI*FAKTOR)
      SBG=SIN(LATI*FAKTOR)
      CLG=COS(YLG*FAKTOR)
      SLG=SIN(YLG*FAKTOR)
      SBM=SBG*CI+CBG*CLG*SI
        IF(ABS(SBM).GT.1.) SBM=SIGN(1.,SBM)
      MLAT=ASIN(SBM)
      CBM=COS(MLAT)
      SLM=(CBG*SLG)/CBM
      CLM=(-SBG*SI+CBG*CLG*CI)/CBM
        IF(ABS(CLM).GT.1.) CLM=SIGN(1.,CLM)
      MLONG=ACOS(CLM)
      IF(SLM.LT..0) MLONG=ZPI-MLONG
      MLAT=MLAT/FAKTOR
      MLONG=MLONG/FAKTOR

      END
C
C
      SUBROUTINE FIELDG(DLAT,DLONG,ALT,X,Y,Z,F,DIP,DEC,SMODIP)
C THIS IS A SPECIAL VERSION OF THE POGO 68/10 MAGNETIC FIELD
C LEGENDRE MODEL. TRANSFORMATION COEFF. G(144) VALID FOR 1973.
C INPUT: DLAT, DLONG=GEOGRAPHIC COORDINATES/DEG.(-90/90,0/360),
C        ALT=ALTITUDE/KM.
C OUTPUT: F TOTAL FIELD (GAUSS), Z DOWNWARD VERTICAL COMPONENT
C        X,Y COMPONENTS IN THE EQUATORIAL PLANE (X TO ZERO LONGITUDE).
C        DIP INCLINATION ANGLE(DEGREE). SMODIP RAWER'S MODFIED DIP.
C SHEIK,1977.
      DIMENSION H(144),XI(3),G(144),FEL1(72),FEL2(72)
      COMMON/CONST/UMR
      DATA FEL1/0.0, 0.1506723,0.0101742, -0.0286519, 0.0092606,
     & -0.0130846, 0.0089594, -0.0136808,-0.0001508, -0.0093977,
     & 0.0130650, 0.0020520, -0.0121956, -0.0023451, -0.0208555,
     & 0.0068416,-0.0142659, -0.0093322, -0.0021364, -0.0078910,
     & 0.0045586,  0.0128904, -0.0002951, -0.0237245,0.0289493,
     & 0.0074605, -0.0105741, -0.0005116, -0.0105732, -0.0058542,
     &0.0033268, 0.0078164,0.0211234, 0.0099309, 0.0362792,
     &-0.0201070,-0.0046350,-0.0058722,0.0011147,-0.0013949,
     & -0.0108838,  0.0322263, -0.0147390,  0.0031247, 0.0111986,
     & -0.0109394,0.0058112,  0.2739046, -0.0155682, -0.0253272,
     &  0.0163782, 0.0205730,  0.0022081, 0.0112749,-0.0098427,
     & 0.0072705, 0.0195189, -0.0081132, -0.0071889, -0.0579970,
     & -0.0856642, 0.1884260,-0.7391512, 0.1210288, -0.0241888,
     & -0.0052464, -0.0096312, -0.0044834, 0.0201764,  0.0258343,
     &0.0083033,  0.0077187/
      DATA FEL2/0.0586055,0.0102236,-0.0396107,
     & -0.0167860, -0.2019911, -0.5810815,0.0379916,  3.7508268,
     & 1.8133030, -0.0564250, -0.0557352, 0.1335347, -0.0142641,
     & -0.1024618,0.0970994, -0.0751830,-0.1274948, 0.0402073,
     &  0.0386290, 0.1883088,  0.1838960, -0.7848989,0.7591817,
     & -0.9302389,-0.8560960, 0.6633250, -4.6363869, -13.2599277,
     & 0.1002136,  0.0855714,-0.0991981, -0.0765378,-0.0455264,
     &  0.1169326, -0.2604067, 0.1800076, -0.2223685, -0.6347679,
     &0.5334222, -0.3459502,-0.1573697,  0.8589464, 1.7815990,
     &-6.3347645, -3.1513653, -9.9927750,13.3327637, -35.4897308,
     &37.3466339, -0.5257398,  0.0571474, -0.5421217,  0.2404770,
     & -0.1747774,-0.3433644, 0.4829708,0.3935944, 0.4885033,
     &  0.8488121, -0.7640999, -1.8884945, 3.2930784,-7.3497229,
     & 0.1672821,-0.2306652, 10.5782146, 12.6031065, 8.6579742,
     & 215.5209961, -27.1419220,22.3405762,1108.6394043/
      K=0
      DO 10 I=1,72
      K=K+1
      G(K)=FEL1(I)
10    G(72+K)=FEL2(I)
      RLAT=DLAT*UMR
      CT=SIN(RLAT)
      ST=COS(RLAT)
      NMAX=11
      D=SQRT(40680925.0-272336.0*CT*CT)
      RLONG=DLONG*UMR
      CP=COS(RLONG)
      SP=SIN(RLONG)
      ZZZ=(ALT+40408589.0/D)*CT/6371.2
      RHO=(ALT+40680925.0/D)*ST/6371.2
      XXX=RHO*CP
      YYY=RHO*SP
      RQ=1.0/(XXX*XXX+YYY*YYY+ZZZ*ZZZ)
      XI(1)=XXX*RQ
      XI(2)=YYY*RQ
      XI(3)=ZZZ*RQ
      IHMAX=NMAX*NMAX+1
      LAST=IHMAX+NMAX+NMAX
      IMAX=NMAX+NMAX-1
      DO 100 I=IHMAX,LAST
100   H(I)=G(I)
      DO 200 K=1,3,2
      I=IMAX
      IH=IHMAX
300   IL=IH-I
      F1=2./(I-K+2.)
      X1=XI(1)*F1
      Y1=XI(2)*F1
      Z1=XI(3)*(F1+F1)
      I=I-2
      IF((I-1).LT.0) GOTO 400
      IF((I-1).EQ.0) GOTO 500
      DO 600 M=3,I,2
      H(IL+M+1)=G(IL+M+1)+Z1*H(IH+M+1)+X1*(H(IH+M+3)-H(IH+M-1))-
     &Y1*(H(IH+M+2)+H(IH+M-2))
      H(IL+M)=G(IL+M)+Z1*H(IH+M)+X1*(H(IH+M+2)-H(IH+M-2))+
     &Y1*(H(IH+M+3)+H(IH+M-1))
600   CONTINUE
500   H(IL+2)=G(IL+2)+Z1*H(IH+2)+X1*H(IH+4)-Y1*(H(IH+3)+H(IH))
      H(IL+1)=G(IL+1)+Z1*H(IH+1)+Y1*H(IH+4)+X1*(H(IH+3)-H(IH))
400   H(IL)=G(IL)+Z1*H(IH)+2.0*(X1*H(IH+1)+Y1*H(IH+2))
      IH=IL
      IF(I.GE.K) GOTO 300
200   CONTINUE
      S=0.5*H(1)+2.0*(H(2)*XI(3)+H(3)*XI(1)+H(4)*XI(2))
      XT=(RQ+RQ)*SQRT(RQ)
      X=XT*(H(3)-S*XXX)
      Y=XT*(H(4)-S*YYY)
      Z=XT*(H(2)-S*ZZZ)
      F=SQRT(X*X+Y*Y+Z*Z)
      BRH0=Y*SP+X*CP
      Y=Y*CP-X*SP
      X=Z*ST-BRH0*CT
      Z=-Z*CT-BRH0*ST
       zdivf=z/f
        IF(ABS(zdivf).GT.1.) zdivf=SIGN(1.,zdivf)
      DIP=ASIN(zdivf)
       ydivs=y/sqrt(x*x+y*y)
        IF(ABS(ydivs).GT.1.) ydivs=SIGN(1.,ydivs)
      DEC=ASIN(ydivs)
       dipdiv=DIP/SQRT(DIP*DIP+ST)
        IF(ABS(dipdiv).GT.1.) dipdiv=SIGN(1.,dipdiv)
      SMODIP=ASIN(dipdiv)
      DIP=DIP/UMR
      DEC=DEC/UMR
      SMODIP=SMODIP/UMR
      RETURN
      END
C
C
C************************************************************
C*********** INTERPOLATION AND REST ***************************
C**************************************************************
C
C
      SUBROUTINE REGFA1(X11,X22,FX11,FX22,EPS,FW,F,SCHALT,X)
C REGULA-FALSI-PROCEDURE TO FIND X WITH F(X)-FW=0. X1,X2 ARE THE
C STARTING VALUES. THE COMUTATION ENDS WHEN THE X-INTERVAL
C HAS BECOME LESS THAN EPS . IF SIGN(F(X1)-FW)= SIGN(F(X2)-FW)
C THEN SCHALT=.TRUE.
      LOGICAL L1,LINKS,K,SCHALT
      SCHALT=.FALSE.
      EP=EPS
      X1=X11
      X2=X22
      F1=FX11-FW
      F2=FX22-FW
      K=.FALSE.
      NG=2
      LFD=0
      IF(F1*F2.LE.0.0) GOTO 200
          X=0.0
           SCHALT=.TRUE.
             RETURN
200   X=(X1*F2-X2*F1)/(F2-F1)
      GOTO 400
300          L1=LINKS
       DX=(X2-X1)/NG
            IF(.NOT.LINKS) DX=DX*(NG-1)
            X=X1+DX
400   FX=F(X)-FW
      LFD=LFD+1
      IF(LFD.GT.20) THEN
       EP=EP*10.
       LFD=0
      ENDIF
      LINKS=(F1*FX.GT.0.0)
      K=.NOT.K
      IF(LINKS) THEN
       X1=X
        F1=FX
      ELSE
       X2=X
       F2=FX
      ENDIF
      IF(ABS(X2-X1).LE.EP) return
      IF(K) GOTO 300
      IF((LINKS.AND.(.NOT.L1)).OR.(.NOT.LINKS.AND.L1)) NG=2*NG
      GOTO 200
      END
C
C
      SUBROUTINE TAL(SHABR,SDELTA,SHBR,SDTDH0,AUS6,SPT)
C CALCULATES THE COEFFICIENTS SPT FOR THE POLYNOMIAL
C Y(X)=1+SPT(1)*X**2+SPT(2)*X**3+SPT(3)*X**4+SPT(4)*X**5
C TO FIT THE VALLEY IN Y, REPRESENTED BY:
C Y(X=0)=1, THE X VALUE OF THE DEEPEST VALLEY POINT (SHABR),
C THE PRECENTAGE DEPTH (SDELTA), THE WIDTH (SHBR) AND THE
C DERIVATIVE DY/DX AT THE UPPER VALLEY BOUNDRY (SDTDH0).
C IF THERE IS AN UNWANTED ADDITIONAL EXTREMUM IN THE VALLEY
C REGION, THEN AUS6=.TRUE., ELSE AUS6=.FALSE..
C FOR -SDELTA THE COEFF. ARE CALCULATED FOR THE FUNCTION
C Y(X)=EXP(SPT(1)*X**2+...+SPT(4)*X**5).
      DIMENSION SPT(4)
      LOGICAL AUS6
      Z1=-SDELTA/(100.0*SHABR*SHABR)
      IF(SDELTA.GT.0.) GOTO 500
      SDELTA=-SDELTA
      Z1=ALOG(1.-SDELTA/100.)/(SHABR*SHABR)
500   Z3=SDTDH0/(2.*SHBR)
      Z4=SHABR-SHBR
      SPT(4)=2.0*(Z1*(SHBR-2.0*SHABR)*SHBR+Z3*Z4*SHABR)/
     &  (SHABR*SHBR*Z4*Z4*Z4)
      SPT(3)=Z1*(2.0*SHBR-3.0*SHABR)/(SHABR*Z4*Z4)-
     &  (2.*SHABR+SHBR)*SPT(4)
      SPT(2)=-2.0*Z1/SHABR-2.0*SHABR*SPT(3)-3.0*SHABR*SHABR*SPT(4)
      SPT(1)=Z1-SHABR*(SPT(2)+SHABR*(SPT(3)+SHABR*SPT(4)))
      AUS6=.FALSE.
      B=4.*SPT(3)/(5.*SPT(4))+SHABR
      C=-2.*SPT(1)/(5*SPT(4)*SHABR)
      Z2=B*B/4.-C
      IF(Z2.LT.0.0) return
      Z3=SQRT(Z2)
      Z1=B/2.
      Z2=-Z1+Z3
      IF(Z2.GT.0.0.AND.Z2.LT.SHBR) AUS6=.TRUE.
      IF (ABS(Z3).GT.1.E-15) GOTO 400
      Z2=C/Z2
      IF(Z2.GT.0.0.AND.Z2.LT.SHBR) AUS6=.TRUE.
      RETURN
400   Z2=-Z1-Z3
      IF(Z2.GT.0.0.AND.Z2.LT.SHBR) AUS6=.TRUE.
      END
C
C
C******************************************************************
C********** ZENITH ANGLE, DAY OF YEAR, TIME ***********************
C******************************************************************
C
C
       subroutine soco (ld,t,flat,Elon,
     &              DECLIN, ZENITH, SUNRSE, SUNSET)
c--------------------------------------------------------------------
c       s/r to calculate the solar declination, zenith angle, and
c       sunrise & sunset times  - based on Newbern Smith's algorithm
c       [leo mcnamara, 1-sep-86, last modified 16-jun-87]
c       {dieter bilitza, 30-oct-89, modified for IRI application}
c
c in:       ld       local day of year
c       t       local hour (decimal)
c       flat       northern latitude in degrees
c       elon       east longitude in degrees
c
c out:       declin      declination of the sun in degrees
c       zenith           zenith angle of the sun in degrees
c       sunrse           local time of sunrise in hours
c       sunset           local time of sunset in hours
c-------------------------------------------------------------------
c
       common/const/       dtr
c amplitudes of Fourier coefficients  --  1955 epoch.................
       data         p1,p2,p3,p4,p6 /
     &     0.017203534,0.034407068,0.051610602,0.068814136,0.103221204 /
c
c s/r is formulated in terms of WEST longitude.......................
       wlon = 360. - Elon
c
c time of equinox for 1980...........................................
       td = ld + (t + Wlon/15.) / 24.
       te = td + 0.9369
c
c declination of the sun..............................................
       dcl = 23.256 * sin(p1*(te-82.242)) + 0.381 * sin(p2*(te-44.855))
     &      + 0.167 * sin(p3*(te-23.355)) - 0.013 * sin(p4*(te+11.97))
     &      + 0.011 * sin(p6*(te-10.41)) + 0.339137
       DECLIN = dcl
       dc = dcl * dtr
c
c the equation of time................................................
       tf = te - 0.5
       eqt = -7.38*sin(p1*(tf-4.)) - 9.87*sin(p2*(tf+9.))
     &      + 0.27*sin(p3*(tf-53.)) - 0.2*cos(p4*(tf-17.))
       et = eqt * dtr / 4.
c
       fa = flat * dtr
       phi = 0.26179939 * ( t - 12.) + et
c
       a = sin(fa) * sin(dc)
       b = cos(fa) * cos(dc)
       cosx = a + b * cos(phi)
       if(abs(cosx).gt.1.) cosx=sign(1.,cosx)
       zenith = acos(cosx) / dtr
c
c calculate sunrise and sunset times --  at the ground...........
c see Explanatory Supplement to the Ephemeris (1961) pg 401......
c sunrise at height h metres is at...............................
c       chi(h) = 90.83 + 0.0347 * sqrt(h)........................
c this includes corrections for horizontal refraction and........
c semi-diameter of the solar disk................................
       ch = cos(90.83 * dtr)
       cosphi = (ch -a ) / b
c if abs(secphi) > 1., sun does not rise/set.....................
c allow for sun never setting - high latitude summer.............
       secphi = 999999.
       if(cosphi.ne.0.) secphi = 1./cosphi
       sunset = 99.
       sunrse = 99.
       if(secphi.gt.-1.0.and.secphi.le.0.) return
c allow for sun never rising - high latitude winter..............
       sunset = -99.
       sunrse = -99.
       if(secphi.gt.0.0.and.secphi.lt.1.) return
c
       if(cosphi.gt.1.) cosphi=sign(1.,cosphi)
       phi = acos(cosphi)
       et = et / 0.26179939
       phi = phi / 0.26179939
       sunrse = 12. - phi - et
       sunset = 12. + phi - et
       if(sunrse.lt.0.) sunrse = sunrse + 24.
       if(sunset.ge.24.) sunset = sunset - 24.

       end

      FUNCTION HPOL(HOUR,TW,XNW,SA,SU,DSA,DSU)
C-------------------------------------------------------
C PROCEDURE FOR SMOOTH TIME-INTERPOLATION USING EPSTEIN
C STEP FUNCTION AT SUNRISE (SA) AND SUNSET (SU). THE
C STEP-WIDTH FOR SUNRISE IS DSA AND FOR SUNSET DSU.
C TW,NW ARE THE DAY AND NIGHT VALUE OF THE PARAMETER TO
C BE INTERPOLATED. SA AND SU ARE TIME OF SUNRIES AND
C SUNSET IN DECIMAL HOURS.
C BILITZA----------------------------------------- 1979.
       IF(ABS(SU).GT.25.) THEN
              IF(SU.GT.0.0) THEN
                     HPOL=TW
              ELSE
                     HPOL=XNW
              ENDIF
              RETURN
       ENDIF
      HPOL=XNW+(TW-XNW)*EPST(HOUR,DSA,SA)+
     &       (XNW-TW)*EPST(HOUR,DSU,SU)

      END FUNCTION HPOL
C
C
      SUBROUTINE MODA(IN,MONTH,IDAY,IDOY)
C-------------------------------------------------------------------
C CALCULATES DAY OF YEAR (IDOY) FROM MONTH (MONTH) AND DAY (IDAY)
C IF IN=0, OR MONTH (MONTH) AND DAY (IDAY) FROM DAY OF
C YEAR (IDOY), IF IN=1.
C-------------------------------------------------------------------
      integer, intent(in) :: in
      integer, intent(inout) :: month,iday
      integer, intent(out) :: idoy
 
      integer, parameter :: MO(*)=[0,31,59,90,120,151,181,212,243,
     &                             273,304,334]
       IMO=0
       MOBE=0
       IF(IN>0) GOTO 5
       
      IDOY=MO(MONTH)+IDAY
      RETURN
5     IMO=IMO+1
      MOOLD=MOBE
      IF(IMO.GT.12) GOTO 55
      MOBE=MO(IMO)
      IF(MOBE.LT.IDOY) GOTO 5
55    MONTH=IMO-1
      IDAY=IDOY-MOOLD

      END SUBROUTINE MODA


      REAL FUNCTION B0POL ( HOUR, SAX, SUX, ISEASON, R, DELA)
C-----------------------------------------------------------------
C Interpolation procedure for bottomside thickness parameter B0.
C Array B0F(ILT,ISEASON,IR,ILATI) distinguishes between day and
C night (ILT=1,2), four seasons (ISEASON=1 spring), low and high
C solar activity (IR=1,2), and low and middle modified dip
C latitudes (ILATI=1,2). In the DATA statement the first value
C corresponds to B0F(1,1,1,1), the second to B0F(2,1,1,1), the
C third to B0F(1,2,1,1) and so on.
C JUNE 1989 --------------------------------------- Dieter Bilitza
C
      REAL              NITVAL
      DIMENSION        B0F(2,4,2,2),SIPH(2),SIPL(2)
      DATA        B0F/114.,64.0,134.,77.0,128.,66.0,75.,73.0,
     &                  113.,115.,150.,116.,138.,123.,94.,132.,
     &                  72.0,84.0,83.0,89.0,75.0,85.0,57.,76.0,
     &                  102.,100.,120.,110.,107.,103.,76.,86.0/

         DO 7033 ISR=1,2
               DO 7034 ISL=1,2
                     DAYVAL   = B0F(1,ISEASON,ISR,ISL)
                     NITVAL = B0F(2,ISEASON,ISR,ISL)

C Interpolation day/night with transitions at SAX (sunrise) and SUX (sunset)
7034                       SIPH(ISL) = HPOL(HOUR,DAYVAL,NITVAL,
     &                            SAX,SUX,1.,1.)

C Interpolation low/middle modip with transition at 30 degrees modip
7033              SIPL(ISR) = SIPH(1) + (SIPH(2) - SIPH(1)) / DELA

C Interpolation low/high Rz12: linear from 10 to 100
       B0POL=SIPL(1)+(SIPL(2)-SIPL(1))/90.*(R-10.)

       END FUNCTION B0POL
c
C
C *********************************************************************
C ************************ EPSTEIN FUNCTIONS **************************
C *********************************************************************
C REF:       H. G. BOOKER, J. ATMOS. TERR. PHYS. 39, 619-623, 1977
C        K. RAWER, ADV. SPACE RES. 4, #1, 11-15, 1984
C *********************************************************************
C
C
       REAL FUNCTION  RLAY ( X, XM, SC, HX )
       implicit none
       real,intent(in) :: x,xm,sc,hx
       real y1,y1m,y2m,eptr,epst
C -------------------------------------------------------- RAWER  LAYER
       Y1  = EPTR ( X , SC, HX )
       Y1M = EPTR ( XM, SC, HX )
       Y2M = EPST ( XM, SC, HX )
       RLAY = Y1 - Y1M - ( X - XM ) * Y2M / SC
       END function rlay
C
C
       REAL FUNCTION D1LAY ( X, XM, SC, HX )
       implicit none
       real,intent(in) :: x,xm,sc,hx
       real epst
C ------------------------------------------------------------ dLAY/dX
       D1LAY = ( EPST(X,SC,HX) - EPST(XM,SC,HX) ) /  SC
       END function d1lay
C
C
       REAL FUNCTION D2LAY ( X, SC, HX )
       Implicit None
       Real,Intent(In) :: X,SC,HX
       Real Epla !function
C ---------------------------------------------------------- d2LAY/dX2
       D2LAY = EPLA(X,SC,HX) /  (SC * SC)
       END FUNCTION D2LAY
C
C
       REAL FUNCTION EPTR ( X, SC, HX )
C ------------------------------------------------------------ TRANSITION
       COMMON/ARGEXP/ARGMAX
       D1 = ( X - HX ) / SC
       IF (ABS(D1).LT.ARGMAX) GOTO 1
       IF (D1.GT.0.0) THEN
         EPTR = D1
       ELSE
         EPTR = 0.0
       ENDIF
       RETURN
1       EPTR = ALOG ( 1. + EXP( D1 ))
       RETURN
       END
C
C
       REAL FUNCTION EPST ( X, SC, HX )
       implicit none
       Real,intent(in) :: x,sc,hx
       real d1,argmax
C -------------------------------------------------------------- STEP
       COMMON/ARGEXP/ARGMAX
       D1 = ( X - HX ) / SC
       IF (ABS(D1).LT.ARGMAX) GOTO 1
       IF (D1.GT.0.0) THEN
         EPST = 1.
       ELSE
         EPST = 0.
       ENDIF
       RETURN
1       EPST = 1. / ( 1. + EXP( -D1 ))
       END FUNCTION epst
C
C
       REAL FUNCTION EPSTEP ( Y2, Y1, SC, HX, X)
       implicit none
       real,intent(in) :: y2,y1,sc,hx,x
       real epst
C---------------------------------------------- STEP FROM Y1 TO Y2
       EPSTEP = Y1 + ( Y2 - Y1 ) * EPST ( X, SC, HX)
       END function epstep
C
C
       Pure REAL FUNCTION EPLA ( X, SC, HX )
       Implicit None
       Real,Intent(In) :: X,SC,HX
       Real Argmax,d1,d0,d2
C ------------------------------------------------------------ PEAK
       COMMON/ARGEXP/ARGMAX
       D1 = ( X - HX ) / SC
       IF (ABS(D1).LT.ARGMAX) GOTO 1
              EPLA = 0
              RETURN
1       D0 = EXP ( D1 )
       D2 = 1. + D0
       EPLA = D0 / ( D2 * D2 )

       END FUNCTION EPLA
c
c
       real FUNCTION XE2TO5(H,HMF2,NL,HX,SC,AMP)
       implicit none
C----------------------------------------------------------------------
C NORMALIZED ELECTRON DENSITY (N/NMF2) FOR THE MIDDLE IONOSPHERE FROM
C HME TO HMF2 USING LAY-FUNCTIONS.
C----------------------------------------------------------------------
       Real,intent(in) :: H,HMF2, HX(NL),SC(NL),AMP(NL)
       integer,intent(in) :: Nl

       real ylay,zlay,summ,rlay
       integer i    

       SUMM = 1.0
       DO 1 I=1,NL
          YLAY = AMP(I) * RLAY( H, HMF2, SC(I), HX(I) )
          zlay=10.**ylay
1          summ=summ*zlay
       XE2TO5 = summ
       END FUNCTION XE2TO5
C
C
       REAL FUNCTION XEN(H,HMF2,XNMF2,HME,NL,HX,SC,AMP)
C----------------------------------------------------------------------
C ELECTRON DENSITY WITH NEW MIDDLE IONOSPHERE
C----------------------------------------------------------------------
       DIMENSION       HX(NL),SC(NL),AMP(NL)
C
       IF(H.LT.HMF2) GOTO 100
              XEN = XE1(H)
              RETURN
100       IF(H.LT.HME) GOTO 200
              XEN = XNMF2 * XE2TO5(H,HMF2,NL,HX,SC,AMP)
              RETURN
200       XEN = XE6(H)
       RETURN
       END
C
C
       SUBROUTINE VALGUL(XHI,HVB,VWU,VWA,VDP)
C ---------------------------------------------------------------------
C   CALCULATES E-F VALLEY PARAMETERS; T.L. GULYAEVA, ADVANCES IN
C   SPACE RESEARCH 7, #6, 39-48, 1987.
C
C       INPUT:       XHI       SOLAR ZENITH ANGLE [DEGREE]
C
C       OUTPUT:       VDP       VALLEY DEPTH  (NVB/NME)
C              VWU       VALLEY WIDTH  [KM]
C              VWA       VALLEY WIDTH  (SMALLER, CORRECTED BY RAWER)
C              HVB       HEIGHT OF VALLEY BASE [KM]
C -----------------------------------------------------------------------
C
       COMMON       /CONST/UMR
C
       CS = 0.1 + COS(UMR*XHI)
       ABC = ABS(CS)
       VDP = 0.45 * CS / (0.1 + ABC ) + 0.55
       ARL = ( 0.1 + ABC + CS ) / ( 0.1 + ABC - CS)
       ZZZ = ALOG( ARL )
       VWU = 45. - 10. * ZZZ
       VWA = 45. -  5. * ZZZ
       HVB = 1000. / ( 7.024 + 0.224 * CS + 0.966 * ABC )
       RETURN
       END
C
C
       SUBROUTINE ROGUL(IDAY,XHI,SX,GRO)
C ---------------------------------------------------------------------
C   CALCULATES RATIO H0.5/HMF2 FOR HALF-DENSITY POINT (NE(H0.5)=0.5*NMF2)
C   T.L. GULYAEVA, ADVANCES IN SPACE RESEARCH 7, #6, 39-48, 1987.
C
C       INPUT:       IDAY       DAY OF YEAR
C              XHI       SOLAR ZENITH ANGLE [DEGREE]
C
C       OUTPUT:       GRO       RATIO OF HALF DENSITY HEIGHT TO F PEAK HEIGHT
C              SX       SMOOTHLY VARYING SEASON PARAMTER (SX=1 FOR
C                     DAY=1; SX=3 FOR DAY=180; SX=2 FOR EQUINOX)
C -----------------------------------------------------------------------
C
       SX = 2. - COS ( IDAY * 0.017214206 )
       XS = ( XHI - 20. * SX) / 15.
       GRO = 0.8 - 0.2 / ( 1. + EXP(XS) )
c same as gro=0.6+0.2/(1+exp(-xs))
       RETURN
       END
C
C
       SUBROUTINE LNGLSN ( N, A, B, AUS)
C --------------------------------------------------------------------
C SOLVES QUADRATIC SYSTEM OF LINEAR EQUATIONS:
C
C       INPUT:       N       NUMBER OF EQUATIONS (= NUMBER OF UNKNOWNS)
C              A(N,N)       MATRIX (LEFT SIDE OF SYSTEM OF EQUATIONS)
C              B(N)       VECTOR (RIGHT SIDE OF SYSTEM)
C
C       OUTPUT:       AUS       =.TRUE.         NO SOLUTION FOUND
C                     =.FALSE.  SOLUTION IS IN  A(N,J) FOR J=1,N
C --------------------------------------------------------------------
C
       DIMENSION       A(5,5), B(5), AZV(10)
       LOGICAL              AUS
C
       NN = N - 1
       AUS = .FALSE.
       DO 1 K=1,N-1
              IMAX = K
              L    = K
              IZG  = 0
              AMAX  = ABS( A(K,K) )
110              L = L + 1
              IF (L.GT.N) GOTO 111
              HSP = ABS( A(L,K) )
              IF (HSP.LT.1.E-8) IZG = IZG + 1
              IF (HSP.LE.AMAX) GOTO 110
111              IF (ABS(AMAX).GE.1.E-10) GOTO 133
                     AUS = .TRUE.
                     RETURN
133              IF (IMAX.EQ.K) GOTO 112
              DO 2 L=K,N
                     AZV(L+1)  = A(IMAX,L)
                     A(IMAX,L) = A(K,L)
2                     A(K,L)    = AZV(L+1)
              AZV(1)  = B(IMAX)
              B(IMAX) = B(K)
              B(K)    = AZV(1)
112              IF (IZG.EQ.(N-K)) GOTO 1
              AMAX = 1. / A(K,K)
              AZV(1) = B(K) * AMAX
              DO 3 M=K+1,N
3                     AZV(M+1) = A(K,M) * AMAX
              DO 4 L=K+1,N
                     AMAX = A(L,K)
                     IF (ABS(AMAX).LT.1.E-8) GOTO 4
                     A(L,K) = 0.0
                     B(L) = B(L) - AZV(1) * AMAX
                     DO 5 M=K+1,N
5                            A(L,M) = A(L,M) - AMAX * AZV(M+1)
4              CONTINUE
1       CONTINUE
       DO 6 K=N,1,-1
              AMAX = 0.0
              IF (K.LT.N) THEN
                     DO 7 L=K+1,N
7                            AMAX = AMAX + A(K,L) * A(N,L)
                     ENDIF
              IF (ABS(A(K,K)).LT.1.E-6) THEN
                     A(N,K) = 0.0
              ELSE
                     A(N,K) = ( B(K) - AMAX ) / A(K,K)
              ENDIF
6       CONTINUE
       RETURN
       END
C
C
       SUBROUTINE LSKNM ( N, M, M0, M1, HM, SC, HX, W, X, Y, VAR, SING)
C --------------------------------------------------------------------
C   DETERMINES LAY-FUNCTIONS AMPLITUDES FOR A NUMBER OF CONSTRAINTS:
C
C       INPUT:       N       NUMBER OF AMPLITUDES ( LAY-FUNCTIONS)
C              M       NUMBER OF CONSTRAINTS
C              M0       NUMBER OF POINT CONSTRAINTS
C              M1       NUMBER OF FIRST DERIVATIVE CONSTRAINTS
C              HM       F PEAK ALTITUDE  [KM]
C              SC(N)       SCALE PARAMETERS FOR LAY-FUNCTIONS  [KM]
C              HX(N)       HEIGHT PARAMETERS FOR LAY-FUNCTIONS  [KM]
C              W(M)       WEIGHT OF CONSTRAINTS
C              X(M)       ALTITUDES FOR CONSTRAINTS  [KM]
C              Y(M)       LOG(DENSITY/NMF2) FOR CONSTRAINTS
C
C       OUTPUT:       VAR(M)       AMPLITUDES
C              SING       =.TRUE.   NO SOLUTION
C ------------------------------------------------------------------------
C
       LOGICAL              SING
       DIMENSION       VAR(N), HX(N), SC(N), W(M), X(M), Y(M),
     &                     BLI(5), ALI(5,5), XLI(5,10)
C
       M01=M0+M1
       SCM=0
       DO 1 J=1,5
              BLI(J) = 0.
              DO 1 I=1,5
1                     ALI(J,I) = 0.
       DO 2 I=1,N
              DO 3 K=1,M0
3                     XLI(I,K) = RLAY( X(K), HM, SC(I), HX(I) )
              DO 4 K=M0+1,M01
4                     XLI(I,K) = D1LAY( X(K), HM, SC(I), HX(I) )
              DO 5 K=M01+1,M
5                     XLI(I,K) = D2LAY( X(K),     SC(I), HX(I) )
2       CONTINUE
              DO 7 J=1,N
              DO 6 K=1,M
                     BLI(J) = BLI(J) + W(K) * Y(K) * XLI(J,K)
                     DO 6 I=1,N
6                            ALI(J,I) = ALI(J,I) + W(K) * XLI(I,K)
     &                                   * XLI(J,K)
7       CONTINUE
       CALL LNGLSN( N, ALI, BLI, SING )
       IF (.NOT.SING) THEN
              DO 8 I=1,N
8                     VAR(I) = ALI(N,I)
              ENDIF
       RETURN
       END
C
C
       SUBROUTINE INILAY(NIGHT,XNMF2,XNMF1,XNME,VNE,HMF2,HMF1,
     &                            HME,HV1,HV2,HHALF,HXL,SCL,AMP,IQUAL)
C-------------------------------------------------------------------
C CALCULATES AMPLITUDES FOR LAY FUNCTIONS
C D. BILITZA, DECEMBER 1988
C
C INPUT:       NIGHT       LOGICAL VARIABLE FOR DAY/NIGHT DISTINCTION
C              XNMF2       F2 PEAK ELECTRON DENSITY [M-3]
C              XNMF1       F1 PEAK ELECTRON DENSITY [M-3]
C              XNME       E  PEAK ELECTRON DENSITY [M-3]
C              VNE       ELECTRON DENSITY AT VALLEY BASE [M-3]
C              HMF2       F2 PEAK ALTITUDE [KM]
C              HMF1       F1 PEAK ALTITUDE [KM]
C              HME       E  PEAK ALTITUDE [KM]
C              HV1       ALTITUDE OF VALLEY TOP [KM]
C              HV2       ALTITUDE OF VALLEY BASE [KM]
C              HHALF       ALTITUDE OF HALF-F2-PEAK-DENSITY [KM]
C
C OUTPUT:       HXL(4)       HEIGHT PARAMETERS FOR LAY FUNCTIONS [KM]
C              SCL(4)       SCALE PARAMETERS FOR LAY FUNCTIONS [KM]
C              AMP(4)       AMPLITUDES FOR LAY FUNCTIONS
C              IQUAL       =0 ok, =1 ok using second choice for HXL(1)
C                       =2 NO SOLUTION
C---------------------------------------------------------------
       DIMENSION       XX(8),YY(8),WW(8),AMP(4),HXL(4),SCL(4)
       LOGICAL              SSIN,NIGHT
c
c constants --------------------------------------------------------
              NUMLAY=4
              NC1 = 2
              ALG102=ALOG10(2.)
c
c constraints: xx == height       yy == log(Ne/NmF2)    ww == weights
c -----------------------------------------------------------------
              ALOGF = ALOG10(XNMF2)
              ALOGEF = ALOG10(XNME) - ALOGF
              XHALF=XNMF2/2.
              XX(1) = HHALF
               XX(2) = HV1
              XX(3) = HV2
              XX(4) = HME
              XX(5) = HME - ( HV2 - HME )
              YY(1) = -ALG102
              YY(2) = ALOGEF
              YY(3) = ALOG10(VNE) - ALOGF
              YY(4) = ALOGEF
              YY(5) = YY(3)
              YY(7) = 0.0
              WW(2) = 1.
              WW(3) = 2.
              WW(4) = 5.
c
c geometric paramters for LAY -------------------------------------
c difference to earlier version:  HXL(3) = HV2 + SCL(3)
c
              SCL0 = 0.7 * ( 0.216 * ( HMF2 - HHALF ) + 56.8 )
              SCL(1) = 0.8 * SCL0
              SCL(2) = 10.
               SCL(3) = 9.
                SCL(4) = 6.
              HXL(3) = HV2
c
C DAY CONDITION--------------------------------------------------
c earlier tested:        HXL(2) = HMF1 + SCL(2)
c
           IF(NIGHT) GOTO 7711
              NUMCON = 8
              HXL(1) = 0.9 * HMF2
                HXL1T  = HHALF
              HXL(2) = HMF1
              HXL(4) = HME - SCL(4)
              XX(6) = HMF1
               XX(7) = HV2
              XX(8) = HME
              YY(8) = 0.0
              WW(5) = 1.
                 WW(7) = 50.
                 WW(8) = 500.
c without F-region ----------------------------------------------
              IF(XNMF1.GT.0) GOTO 100
                     HXL(2)=(HMF2+HHALF)/2.
                     YY(6) = 0.
                     WW(6) = 0.
                     WW(1) = 1.
                     GOTO 7722
c with F-region --------------------------------------------
100              YY(6) = ALOG10(XNMF1) - ALOGF
              WW(6) = 3.
              IF((XNMF1-XHALF)*(HMF1-HHALF).LT.0.0) THEN
                WW(1)=0.5
              ELSE
                ZET = YY(1) - YY(6)
                WW(1) = EPST( ZET, 0.1, 0.15)
              ENDIF
              IF(HHALF.GT.HMF1) THEN
                HFFF=HMF1
                XFFF=XNMF1
              ELSE
                HFFF=HHALF
                XFFF=XHALF
              ENDIF
               GOTO 7722
c
C NIGHT CONDITION---------------------------------------------------
c different HXL,SCL values were tested including:
c       SCL(1) = HMF2 * 0.15 - 27.1       HXL(2) = 200.
c       HXL(2) = HMF1 + SCL(2)              HXL(3) = 140.
c         SCL(3) = 5.                     HXL(4) = HME + SCL(4)
c       HXL(4) = 105.
c
7711              NUMCON = 7
              HXL(1) = HHALF
                HXL1T  = 0.4 * HMF2 + 30.
              HXL(2) = ( HMF2 + HV1 ) / 2.
              HXL(4) = HME
              XX(6) = HV2
               XX(7) = HME
              YY(6) = 0.0
              WW(1) = 1.
              WW(3) = 3.
              WW(5) = 0.5
              WW(6) = 50.
               WW(7) = 500.
              HFFF=HHALF
              XFFF=XHALF
c
C are valley-top and bottomside point compatible ? -------------
C
7722       IF((HV1-HFFF)*(XNME-XFFF).LT.0.0) WW(2)=0.5
       IF(HV1.LE.HV2+5.0) WW(2)=0.5
c
C DETERMINE AMPLITUDES-----------------------------------------
C
           NC0=NUMCON-NC1
           IQUAL=0
2299           CALL LSKNM(NUMLAY,NUMCON,NC0,NC1,HMF2,SCL,HXL,WW,XX,YY,
     &              AMP,SSIN)
                 IF(IQUAL.gt.0) GOTO 1937
           IF((ABS(AMP(1)).GT.10.0).OR.(SSIN)) THEN
              IQUAL=1
              HXL(1)=HXL1T
              GOTO 2299
              ENDIF
1937           IF(SSIN) IQUAL=2
           RETURN
           END
c
c
       subroutine ioncom(h,z,f,fs,t,cn)

       integer,intent(in) :: t
c---------------------------------------------------------------
c ion composition model
c A.D. Danilov and A.P. Yaichnikov, A New Model of the Ion
c   Composition at 75 to 1000 km for IRI, Adv. Space Res. 5, #7,
c   75-79, 107-108, 1985
c
c        h       altitude in km
c       z       solar zenith angle in radians
c       f       latitude in radians
c       fs       10.7cm solar radio flux
c       t       season (month)
c       cn(1)   O+  relative density in percent
c       cn(2)   H+  relative density in percent
c       cn(3)   N+  relative density in percent
c       cn(4)   He+ relative density in percent
c       cn(5)   NO+ relative density in percent
c       cn(6)   O2+ relative density in percent
c       cn(7)   cluster ions  relative density in percent
c---------------------------------------------------------------
c
       dimension       cn(7),cm(7),hm(7),alh(7),all(7),beth(7),
     &                     betl(7),p(5,6,7),var(6),po(5,6),ph(5,6),
     &                     pn(5,6),phe(5,6),pno(5,6),po2(5,6),pcl(5,6)

       data po/4*0.,98.5,4*0.,320.,4*0.,-2.59E-4,2.79E-4,-3.33E-3,
     &              -3.52E-3,-5.16E-3,-2.47E-2,4*0.,-2.5E-6,1.04E-3,
     &              -1.79E-4,-4.29E-5,1.01E-5,-1.27E-3/
       data ph/-4.97E-7,-1.21E-1,-1.31E-1,0.,98.1,355.,-191.,
     &              -127.,0.,2040.,4*0.,-4.79E-6,-2.E-4,5.67E-4,
     &              2.6E-4,0.,-5.08E-3,10*0./
       data pn/7.6E-1,-5.62,-4.99,0.,5.79,83.,-369.,-324.,0.,593.,
     &              4*0.,-6.3E-5,-6.74E-3,-7.93E-3,-4.65E-3,0.,-3.26E-3,
     &              4*0.,-1.17E-5,4.88E-3,-1.31E-3,-7.03E-4,0.,-2.38E-3/
       data phe/-8.95E-1,6.1,5.39,0.,8.01,4*0.,1200.,4*0.,-1.04E-5,
     &              1.9E-3,9.53E-4,1.06E-3,0.,-3.44E-3,10*0./
       data pno/-22.4,17.7,-13.4,-4.88,62.3,32.7,0.,19.8,2.07,115.,
     &              5*0.,3.94E-3,0.,2.48E-3,2.15E-4,6.67E-3,5*0.,
     &              -8.4E-3,0.,-3.64E-3,2.E-3,-2.59E-2/
       data po2/8.,-12.2,9.9,5.8,53.4,-25.2,0.,-28.5,-6.72,120.,
     &              5*0.,-1.4E-2,0.,-9.3E-3,3.3E-3,2.8E-2,5*0.,4.25E-3,
     &              0.,-6.04E-3,3.85E-3,-3.64E-2/
       data pcl/4*0.,100.,4*0.,75.,10*0.,4*0.,-9.04E-3,-7.28E-3,
     &              2*0.,3.46E-3,-2.11E-2/

       DO 8 I=1,5
       DO 8 J=1,6
              p(i,j,1)=po(i,j)
              p(i,j,2)=ph(i,j)
              p(i,j,3)=pn(i,j)
              p(i,j,4)=phe(i,j)
              p(i,j,5)=pno(i,j)
              p(i,j,6)=po2(i,j)
              p(i,j,7)=pcl(i,j)
8       continue

       s=0.
       do 5 i=1,7
         do 7 j=1,6
              var(j) = p(1,j,i)*cos(z) + p(2,j,i)*cos(f) +
     &                 p(3,j,i)*cos(0.013*(300.-fs)) +
     &                      p(4,j,i)*cos(0.52*(real(t)-6.)) + p(5,j,i)
7         continue
         cm(i)  = var(1)
         hm(i)  = var(2)
         all(i) = var(3)
         betl(i)= var(4)
         alh(i) = var(5)
         beth(i)= var(6)
         hx=h-hm(i)
          if(hx) 1,2,3
1              cn(i) = cm(i) * exp( hx * (hx * all(i) + betl(i)) )
              goto 4
2                cn(i) = cm(i)
              goto 4
3              cn(i) = cm(i) * exp( hx * (hx * alh(i) + beth(i)) )
4         continue
         if(cn(i).LT.0.005*cm(i)) cn(i)=0.
         if(cn(i).GT.cm(i)) cn(i)=cm(i)
         s=s+cn(i)
5       continue
       do 6 i=1,7
6              cn(i)=cn(i)/s*100.

       end subroutine ioncom
C
C
C
C
      SUBROUTINE CIRA86(IDAY,SEC,GLAT,GLONG,STL,F107A,TINF,TLB,SIGMA)
C*******************************************************************
C   Calculates neutral temperature parameters for IRI using the
C   MSIS-86/CIRA 1986 Neutral Thermosphere Model. The subroutines
C   GTS5, GLOBE5 and GLOBL5 developed by A.E. Hedin (2/26/87) were
C   modified for use in IRI --------- D. Bilitza -------- March 1991
C
C     INPUT:
C        IDAY - DAY OF YEAR
C        SEC - UT(SEC)
C        GLAT - GEODETIC LATITUDE(DEG)
C        GLONG - GEODETIC LONGITUDE(DEG)
C        STL - LOCAL APPARENT SOLAR TIME(HRS)
C        F107A - 3 MONTH AVERAGE OF F10.7 FLUX
C
C     OUTPUT:
C        TINF - EXOSPHERIC TEMPERATURE (K)
C        TLB - TEMPERATURE AT LOWER BOUNDARY (K)
C        SIGMA - SHAPE PARAMETER FOR TEMPERATURE PROFILE
C
C **********************************************************************
      DIMENSION         PLG(9,4)
      DATA DR,DR2/1.72142E-2,0.0344284/,HR/.2618/,SR/7.2722E-5/,
     $     XL/1000./,TLL/1000./,DGTR/1.74533E-2/
      save plg, c, s, c2, c4, s2,
     $     stloc, ctloc, s2tloc, c2tloc, s3tloc, c3tloc
C
C CALCULATE LEGENDRE POLYNOMIALS
C
      IF(XL.EQ.GLAT)   GO TO 15
      C = SIN(GLAT*DGTR)
      S = COS(GLAT*DGTR)
      C2 = C*C
      C4 = C2*C2
      S2 = S*S
      PLG(2,1) = C
      PLG(3,1) = 0.5*(3.*C2 -1.)
      PLG(4,1) = 0.5*(5.*C*C2-3.*C)
      PLG(5,1) = (35.*C4 - 30.*C2 + 3.)/8.
      PLG(6,1) = (63.*C2*C2*C - 70.*C2*C + 15.*C)/8.
      PLG(2,2) = S
      PLG(3,2) = 3.*C*S
      PLG(4,2) = 1.5*(5.*C2-1.)*S
      PLG(5,2) = 2.5*(7.*C2*C-3.*C)*S
      PLG(6,2) = 1.875*(21.*C4 - 14.*C2 +1.)*S
      PLG(7,2) = (11.*C*PLG(6,2)-6.*PLG(5,2))/5.
      PLG(3,3) = 3.*S2
      PLG(4,3) = 15.*S2*C
      PLG(5,3) = 7.5*(7.*C2 -1.)*S2
      PLG(6,3) = 3.*C*PLG(5,3)-2.*PLG(4,3)
      PLG(4,4) = 15.*S2*S
      PLG(5,4) = 105.*S2*S*C
      PLG(6,4)=(9.*C*PLG(5,4)-7.*PLG(4,4))/2.
      PLG(7,4)=(11.*C*PLG(6,4)-8.*PLG(5,4))/3.
      XL=GLAT
   15 CONTINUE
      IF(TLL.EQ.STL)   GO TO 16
      STLOC = SIN(HR*STL)
      CTLOC = COS(HR*STL)
      S2TLOC = SIN(2.*HR*STL)
      C2TLOC = COS(2.*HR*STL)
      S3TLOC = SIN(3.*HR*STL)
      C3TLOC = COS(3.*HR*STL)
      TLL = STL
   16 CONTINUE
C
      DFA=F107A-150.
C
C EXOSPHERIC TEMPERATURE
C
C         F10.7 EFFECT
      T1 =  ( 3.11701E-3 - 0.64111E-5 * DFA ) * DFA
        F1 = 1. + 0.426385E-2 * DFA
        F2 = 1. + 0.511819E-2 * DFA
        F3 = 1. + 0.292246E-2 * DFA
C        TIME INDEPENDENT
      T2 = 0.385528E-1 * PLG(3,1) + 0.303445E-2 * PLG(5,1)
C        SYMMETRICAL ANNUAL AND SEMIANNUAL
       CD14 = COS( DR  * (IDAY+8.45398) )
             CD18 = COS( DR2 * (IDAY-125.818) )
             CD32 = COS( DR  * (IDAY-30.0150) )
             CD39 = COS( DR2 * (IDAY-2.75905) )
      T3 = 0.805486E-2 * CD32 + 0.14237E-1 * CD18
C        ASYMMETRICAL ANNUAL AND SEMIANNUAL
      T5 = F1 * (-0.127371 * PLG(2,1) - 0.302449E-1 * PLG(4,1) ) * CD14
     &       - 0.192645E-1 * PLG(2,1) * CD39
C        DIURNAL
      T71 =  0.123512E-1 * PLG(3,2) * CD14
      T72 = -0.526277E-2 * PLG(3,2) * CD14
      T7 = ( -0.105531 *PLG(2,2) - 0.607134E-2 *PLG(4,2) + T71 ) *CTLOC
     4   + ( -0.115622 *PLG(2,2) + 0.202240E-2 *PLG(4,2) + T72 ) *STLOC
C        SEMIDIURNAL
      T81 = 0.386578E-2 * PLG(4,3) * CD14
      T82 = 0.389146E-2 * PLG(4,3) * CD14
      T8= (-0.516278E-3 *PLG(3,3) - 0.117388E-2 *PLG(5,3) +T81)*C2TLOC
     3   +( 0.990156E-2 *PLG(3,3) - 0.354589E-3 *PLG(5,3) +T82)*S2TLOC
C        TERDIURNAL
      Z1 =  PLG(5,4) * CD14
      Z2 =  PLG(7,4) * CD14
      T14=(0.147284E-2*PLG(4,4)-0.173933E-3*Z1+0.365016E-4*Z2)*S3TLOC
     2   +(0.341345E-3*PLG(4,4)-0.153218E-3*Z1+0.115102E-3*Z2)*C3TLOC
      T7814 = F2 * ( T7 + T8 + T14 )
C        LONGITUDINAL
      T11= F3 * (( 0.562606E-2 * PLG(3,2) + 0.594053E-2 * PLG(5,2) +
     $       0.109358E-2 * PLG(7,2) - 0.301801E-2 * PLG(2,2) -
     $       0.423564E-2 * PLG(4,2) - 0.248289E-2 * PLG(6,2) +
     $      (0.189689E-2 * PLG(2,2) + 0.415654E-2 * PLG(4,2)) * CD14
     $     ) * COS(DGTR*GLONG) +
     $     ( -0.11654E-1 * PLG(3,2) - 0.449173E-2 * PLG(5,2) -
     $       0.353189E-3 * PLG(7,2) + 0.919286E-3 * PLG(2,2) +
     $       0.216372E-2 * PLG(4,2) + 0.863968E-3 * PLG(6,2) +
     $      (0.118068E-1 * PLG(2,2) + 0.331190E-2 * PLG(4,2)) * CD14
     $     ) * SIN(DGTR*GLONG) )
C        UT AND MIXED UT,LONGITUDE
      T12 = ( 1. - 0.565411 * PLG(2,1) ) * COS( SR*(SEC-31137.0) ) *
     $ (-0.13341E-1*PLG(2,1)-0.243409E-1*PLG(4,1)-0.135688E-1*PLG(6,1))
     $ +    ( 0.845583E-3 * PLG(4,3) + 0.538706E-3  * PLG(6,3) ) *
     $      COS( SR * (SEC-247.956) + 2.*DGTR*GLONG )
C  Exospheric temperature TINF/K  [Eq. A7]
      TINF = 1041.3 * ( 1. + T1+T2+T3+T5+T7814+T11+T12 ) * 0.99604
C
C TEMPERATURE DERIVATIVE AT LOWER BOUNDARY
C
C         F10.7 EFFECT
      T1 =  0.252317E-2 * DFA
C        TIME INDEPENDENT
      T2 = -0.467542E-1 * PLG(3,1) + 0.12026 * PLG(5,1)
C        ASYMMETRICAL ANNUAL
             CD14 = COS( DR  * (IDAY+8.45398) )
      T5 = -0.13324 * PLG(2,1)  * CD14
C        SEMIDIURNAL
      ZZ = PLG(4,3) * CD14
      T81 = -0.973404E-2 * ZZ
      T82 = -0.718482E-3 * ZZ
      T8 =(0.191357E-1 *PLG(3,3) + 0.787683E-2 *PLG(5,3) + T81) *C2TLOC
     3  + (0.125429E-2 *PLG(3,3) - 0.233698E-2 *PLG(5,3) + T82) *S2TLOC
C  dTn/dh at lower boundary  [Eq. A6]
      G0 = 0.166728E2 * ( 1. + T1+T2+T5+T8 ) * 0.951363
C
C NEUTRAL TEMPERATURE AT LOWER BOUNDARY 120KM
C
             CD9  = COS( DR2 * (IDAY-89.3820) )
             CD11 = COS( DR  * (IDAY+8.45398) )
      T1 = 0.568478E-3 * DFA
      T4 = 0.107674E-1 * CD9
      T5 =-0.192414E-1 * PLG(2,1) * CD11
      T7 = -0.2002E-1 *PLG(2,2) *CTLOC - 0.195833E-2 *PLG(2,2) *STLOC
      T8 = (-0.938391E-2 * PLG(3,3) - 0.260147E-2 * PLG(5,3)
     $       + 0.511651E-4 * PLG(6,3) * CD11 ) * C2TLOC
     $   + ( 0.131480E-1 * PLG(3,3) - 0.808556E-3 * PLG(5,3)
     $       + 0.255717E-2 * PLG(6,3) * CD11 ) * S2TLOC
C  Tn at lower boundary 120km   [Eq. A8]
      TLB = 386.0 * ( 1. + T1+T4+T5+T7+T8 ) * 0.976619
C  Sigma      [Eq. A5]
      SIGMA = G0 / ( TINF - TLB )
      RETURN
      END
C
C
      pure real FUNCTION TN(H,TINF,TLBD,S)
      implicit none

      Real,intent(in) :: h,tinf,tlbd,s

      Real zg2
C--------------------------------------------------------------------
C       Calculate Temperature for MSIS/CIRA-86 model
C--------------------------------------------------------------------
      ZG2 = ( H - 120. ) * 6476.77 / ( 6356.77 + H )
      TN = TINF - TLBD * EXP ( - S * ZG2 )

      END function TN
C
C
      pure real FUNCTION DTNDH(H,TLBD,S)
      implicit None

      Real,Intent(In) :: h,tlbd,s

      Real zg1,zg2,zg3
C---------------------------------------------------------------------
      ZG1 = 6356.77 + H
      ZG2 = 6476.77 / ZG1
      ZG3 = ( H - 120. ) * ZG2
      DTNDH = - TLBD * EXP ( - S * ZG3 ) * ( S / ZG1 * ( ZG3 - ZG2 ) )

      END FUNCTION DTNDH

! Subroutine SSFLUX
!
! This software is part of the GLOW model.  Use is governed by the Open Source
! Academic Research License Agreement contained in the file glowlicense.txt.
! For more information see the file glow.txt.
!
! Subroutine SSFLUX calculates the solar EUV and FUV flux in the range
! 0.5 to 1750 Angstroms for a specified level of solar activity.
!
! The calling routine supplies a scaling switch ISCALE, the daily 10.7
! cm flux F107, its 81-day centered average F107A, and, optionally,
! the H Lyman-Beta 1026A ratio to its solar minimum value HLYBR, the
! Fe XVI 335A ratio to its solar minimum value FEXVIR, the H Lyman-alpha
! 1216A flux HLYA, the He I 10830A equivalent width HEIEW, and an XUV
! enhancement factor XUVFAC.  Any optional calling parameters not used
! should be set to zero.
!
! XUVFAC is applied from 18-250 A for the Hinteregger model (ISCALE=0),
! from 18-50 A for the EUVAC model (ISCALE=1), and not at all for
! user-supplied data (ISCALE=2)
!
! The subroutine returns the longwave boundary WAVE1 and shortwave
! boundary WAVE2 of the wavelenth bins, and the solar flux in each bin
! SFLUX.  Bins are arranged in energy multiples of 2 from 0.5 to 8 A,
! aligned with k-shell boundaries at 23, 32, and 44 A from 18 to 44 nm,
! 10 A in width from 60 to 1050 A, and 50 A in width from 1050 to
! 1750 A with the exception of Lyman-alpha which has its own bin from
! 1210 to 1220 A.
!
! Methods used:
!   If ISCALE=0 the flux is scaled using parameterization methods based
! on F107 and F107A.  For ionizing EUV, Hinteregger's contrast ratio
! method (Hinteregger et al., GRL, 8, 1147, 1981) is used, based on the
! reference spectrum SC#21REFW at 1 nm bin resolution.  If the
! H Lyman-Beta (1026A) or Fe XVI (335A) enhancement ratios are provided
! (>0) as calling arguments, they are used to scale the EUV spectrum.
! Otherwise, enhancement ratios for H Ly-B and Fe XVI are calculated
! from F107 and F107A using Hinteregger's formula, employing
! coefficients which reduce to the reference values at F107=67.6,
! F107A=71.5.  The 'best fit' coefficients are not used as they produce
! some negative values at low solar activity, but remain in a
! 'commented out' data statement for reference.  The EUV spectrum is
! then scaled from these modeled ratios.  Scaling factors were
! calculated from contrast ratios in the SC#21REFW data file.
!   If ISCALE=1, the EUV flux (50-1050A) is scaled using the EUVAC model
! (Richards et al., JGR 99, 8981, 1994) re-binned onto ~1 nm intervals.
! The Hinteregger spectrum, scaled using the EUVAC algorithm, is used
! from 18 to 50A.
!   Neither of these models extends shortward of 18A, so from 1-18 A
! an amalgam of sources are used to derive an estimated flux, e.g.,
! DeJager, in Astronomical Observations from Space Vehicles, Steinberg,
! ed., 1964; Smith & Gottlieb, SSR 16, 771, 1974; Manson, in The Solar
! Output and its Variation, White, ed., 1977; Kreplin et al, ibid;
! Horan & Kreplin, Solar Physics 74, 265, 1981; Wagner, Adv. Space Res.
! 8, (7)67, 1988.
!    For FUV from 1050A-1750A, 50A interval bins from the Woods and
! Rottman [2002] reference spectrum and scale factors based on
! UARS SOLSTICE data are used.  The scaling method follows the
! Hinteregger or EUVAC algorithm, whichever is selected, so as to
! linearly scale the spectrum between the reference value and maximum
! value calculated with F10.7=F10.7A=200.  If a value for Lyman-alpha
! (HLYA>0) is provided by the calling program, it is subsituted into
! the spectrum.
!   If ISCALE=2, the solar flux (0-1750A) is read from a file named
! ssflux_user.dat in the current working directory.  The file must
! contain three columns:  WAVES, WAVEL, SFLUX (Angstroms and cm-2 s-1)
! in order of increasing wavelength.  The number of lines in the file
! must match the value of LMAX in glow.h.
!
! Modification history:
!   Stan Solomon, 12/88  Basic Hinteregger EUV, approx. SME FUV
!   Chris Gaskill, 7/89  Added early Tobiska model
!   Stan Solomon,  8/89  Corrections to above
!   Stan Solomon,  1/90  Tobiska SERF2; added W & R spectra
!   Stan Solomon,  6/91  Tobiska EUV 91; Hntggr Ly-B, Fe XVI scaling
!   Stan Solomon,  2/92  Updated Tobiska EUV91; corrected SME FUV
!   Scott Bailey, 12/93  Initial one-nm bins version
!   Stan Solomon,  6/04  Added EUVAC option, cleaned up artifacts
!   Stan Solomon,  9/04  Added ability to specify input data file
!   Stan Solomon,  3/05  Changed all to photon units
!   Stan Solomon,  1/15  Updated for f90; only read file on first call
!
! Calling parameters:
! ISCALE   =0 for Hinteregger contrast ratio method
!          =1 for EUVAC
!          =2 for user-supplied data
! F107     daily 10.7 cm flux (1.E-22 W m-2 Hz-1)
! F107A    81-day centered average 10.7 cm flux
! HLYBR    ratio of H Ly-b 1026A flux to solar minimum value (optional)
! FEXVIR   ratio of Fe XVI 335A flux to solar minimum value (optional)
! HLYA     H Lyman-alpha flux (photons cm-2 s-1) (optional)
! HEIEW    He I 10830A equivalent width (mAngstroms) (obsolete)
! XUVFAC   factor for scaling flux 18-250A or 18-50A (optional)

! Returned parameters:
! WAVE1    longwave bound of spectral intervals (Angstroms)
! WAVE2    shortwave bound of intervals
! SFLUX    scaled solar flux returned by subroutine (photons cm-2 s-1)
!
! Other definitions:
! LMAX     dimension of flux and scaling arrays, currently = 123
! WAVEL    = WAVE1
! WAVES    = WAVE2
! RFLUX    low solar activity flux
! XFLUX    high solar activity flux
! SCALE1   scaling factors for H LyB-keyed chromospheric emissions
! SCALE2   scaling factors for FeXVI-keyed coronal emissions
! B1       fit coefficients for H LyB
! B2       fit coefficients for FeXVI
! R1       enhancement ratio for H LyB
! R2       enhancement ratio for FeXVI
! P107     average of F107 and F107A
! A        scaling factor for EUVAC model
!
!
      SUBROUTINE SSFLUX (ISCALE, F107, F107A, HLYBR, FEXVIR, HLYA,
     >                   HEIEW, XUVFAC, WAVE1, WAVE2, SFLUX)
!      use cglow,only: lmax
      implicit none
      include 'cglow.h'

! Args:
      integer,intent(in) :: iscale
      real,intent(in)    :: f107, f107a,HLYBR, FEXVIR,HLYA,XUVFAC,heiew
      real,intent(out),dimension(Lmax)   :: wave1,wave2,sflux
! Local:
      real WAVEL(LMAX), WAVES(LMAX), RFLUX(LMAX), UFLUX(LMAX),
     >          SCALE1(LMAX), SCALE2(LMAX), A(LMAX),p107,r1,r2
      integer l
      real,parameter :: epsil=1.0E-6
!      integer :: islast=-1  !this didn't work right in f2py


! regression coefficients which reduce to solar min. spectrum:
      real :: B1(NMAJ),B2(NMAJ)
      DATA B1/1.0, 0.0138, 0.005/
      DATA B2/1.0, 0.59425, 0.3811/

! 'best fit' regression coefficients, commented out, for reference:
!     DATA B1/1.31, 0.01106, 0.00492/, B2/-6.618, 0.66159, 0.38319/


! Hinteregger contrast ratio method:

      IF (iscale .eq. 0) then
!        if (islast .ne. iscale) then
          open(unit=1,file='ssflux_hint.dat',status='old')
          read(1,*)
          do l=lmax,1,-1
            read(1,*) waves(l),wavel(l),rflux(l),scale1(l),scale2(l)
          enddo
          close(unit=1)
!         endif

        IF (HLYBR .GT. EPSIL) THEN
          R1 = HLYBR
        ELSE
          R1 =  B1(1) + B1(2)*(F107A-71.5) + B1(3)*(F107-F107A+3.9)
        ENDIF
        IF (FEXVIR .GT. EPSIL) THEN
          R2 = FEXVIR
        ELSE
          R2 =  B2(1) + B2(2)*(F107A-71.5) + B2(3)*(F107-F107A+3.9)
        ENDIF

        do l=1,lmax
          SFLUX(L) = RFLUX(L) + (R1-1.)*SCALE1(L) + (R2-1.)*SCALE2(L)
          IF (SFLUX(L) .LT. 0.0) SFLUX(L) = 0.0
          IF (XUVFAC .GT. EPSIL .AND.
     >        WAVEL(L).LT.251.0 .AND. WAVES(L).GT.17.0)
     >        SFLUX(L)=SFLUX(L)*XUVFAC
        enddo
      endif

! EUVAC Method:

      IF (iscale .eq. 1) then
!        if (islast .ne. iscale) then
          open(unit=1,file='ssflux_euvac.dat',status='old')
          read(1,*)
          do l=lmax,1,-1
            read(1,*) waves(l),wavel(l),rflux(l),a(l)
          enddo
          close(unit=1)
!        endif

      P107 = (F107+F107A)/2.
        do l=1,lmax
          SFLUX(L) = RFLUX(L) * (1. + A(L)*(P107-80.))
          IF (SFLUX(L) .LT. 0.8*RFLUX(L)) SFLUX(L) = 0.8*RFLUX(L)
          IF (XUVFAC .GT. EPSIL .AND.
     >        WAVEL(L).LT.51.0 .AND. WAVES(L).GT.17.0)
     >        SFLUX(L)=SFLUX(L)*XUVFAC
        enddo
      ENDIF

! User-supplied data:

      if (iscale .eq. 2) then
!        if (islast .ne. iscale) then
          open(unit=1,file='ssflux_user.dat',status='old')
          read(1,*)
          do l=lmax,1,-1
            read(1,*) waves(l),wavel(l),uflux(l)
          enddo
          close(unit=1)
!        endif
        do l=1,lmax
          sflux(l)=uflux(l)
        enddo
      endif

! Fill wavelength arrays, substitute in H Lyman-alpha if provided:

      do l=1,lmax
        WAVE1(L) = WAVEL(L)
        WAVE2(L) = WAVES(L)
        IF (HLYA .GT. EPSIL .AND.
     >      WAVEL(L).LT.1221. .AND. WAVES(L).GT.1209.)
     >      SFLUX(L) = HLYA
      enddo

!      islast=iscale

      End SUBROUTINE SSFLUX

C Subroutine GLOW
C
C This software is part of the GLOW model.  Use is governed by the Open Source
C Academic Research License Agreement contained in the file glowlicense.txt.
C For more information see the file glow.txt.
C
C Version 0.973
C
C Stan Solomon, 1988, 1989, 1990, 1991, 1992, 1994, 2000, 2002, 2005, 2015
C
C Subroutine GLOW is the master routine of the /glow package.  It
C receives input parameters from the calling program in common block
C /CGLOW/, calls the other subroutines, and returns results in /CGLOW/.
C Header file glow.h supplies array sizes for the altitude, electron,
C and solar spectrum energy grids.
C
C Subroutines called by GLOW are:
C   EGRID   sets up electron energy grid
C   FIELDM  calculates magnetic dip angle
C   SOLZEN  calculates solar zenith angle
C   SSFLUX  scales solar flux for activity level
C   RCOLUM  calculates slant column density of major species
C   EPHOTO  calculates photoionization and photoelectron production
C   QBACK   estimates background ionization
C   ETRANS  computes electron transport, ionization, excitation
C             calls EXSECT for cross-sections, first call only
C   GCHEM   finds electron/ion/metastable densities, airglow emissions
C             uses VQUART to solve electron density equation
C
C Supplied to subroutine in labeled common /CGLOW/:
C IDATE   Date, in form yyddd
C UT      Universal Time; seconds
C GLAT    Geographic latitude; degrees
C GLONG   Geographic longitude; degrees
C ISCALE  Solar flux scaling switch, see subroutine SSFLUX
C JLOCAL  =0 for electron transport calculation, =1 for local calc only
C KCHEM   Ion/electron chemistry switch, see subroutine GCHEM
C F107    Solar 10.7 cm flux for day being modeled, 1.E-22 W m-2 Hz-1
C F107A   Solar 10.7 cm flux 81-day centered average
C HLYBR   H Ly-b (1026A) enhancement ratio
C FEXVIR  Fe XVI (335A) enhancement ratio
C HLYA    H Ly-a flux; photons cm-2 s-1
C HEIEW   He I 10830 equivalent width; milliAngstroms (obsolete)
C XUVFAC  Factor by which to multiply to solar flux 16-250 A or 16-50 A.
C ZZ      altitude array; cm
C ZO      O number density at each altitude; cm-3
C ZN2     N2  "      "      "   "     "       "
C ZO2     O2         "
C ZNO     NO         "
C ZNS     N(4S)      "
C ZND     N(2D)      "
C ZRHO    mass density at each altitude; gm cm-3
C ZE      electron density at each alt; cm-3
C ZTN     neutral temperature at each alt; K
C ZTI     ion temperature at each alt; K
C ZTE     electron temp at each alt; K
C PHITOP  energetic electron flux into top of atmosphere; cm-2 s-1 eV-1
C EFLUX   obsolete
C EZERO   obsolete
C
C Calculated by subroutine:
C SZA     solar zenith angle; radians
C DIP     magnetic field dip angle; radians
C EFRAC   energy conservation check from ETRANS, (out-in)/in
C IERR    error code returned from ETRANS:
C           0=normal, 1=local problem, 2=transport problem
C ZMAJ    major species density array, O, O2, N2; cm-3
C ZCOL    major species slant column density array, O, O2, N2; cm-2
C WAVE1   longwave edge of solar flux wavelength range; A
C WAVE2   shortwave edge of solar flux wavelength range; A
C SFLUX   scaled solar flux in each wavelength range; photons cm-2 s-1
C ENER    electron energy grid; eV
C DEL     width of each bin in electron energy grid; eV
C PESPEC  photoelectron production rate at energy, altitude; cm-3 s-1
C SESPEC  background electron production rate (obsolete); cm-3 s-1
C PHOTOI  photoionization rates for state, species, altitude; cm-3 s-1
C           O+ states: 4S, 2Do, 2Po, 4Pe, 2Pe
C           O2+ states: X, a+A, b, dissoc.
C           N2+ states: X, A, B, C, F, dissoc.
C PHOTOD  photodissoc. & exc. rates for state, species, alt.; cm-3 s-1
C           (1,2,J) = O2 -> O(3P) + O(1D))
C           (2,2,J) = O2 -> O(3P) + O(1S)
C           (1,3,J) = N2 -> N + N
C PHONO   photoionization/dissociation/excitation rates for NO, cm-3 s-1
C         (1,J) = NO+ from H Ly-a ionization
C QTI     obsolete
C AURI    obsolete
C PIA     obsolete
C SION    electron impact ioniz. rates calculated by ETRANS; cm-3 s-1
C UFLX    upward hemispherical electron flux; cm-2 s-1 eV-1
C DFLX    downward hemispherical electron flux; cm-2 s-1 eV-1
C AGLW    Electron impact exc. rates; state, species, alt.; cm-3 s-1
C           O states: 1D, 1S, 5S, 3S, 3p5P, 3p3P, 3d3D, 3s'3D
C           O2 states: a, b, (A+A'+c), B(SRC), 9.9eV, Ryds., vib.
C           N2 states: (A+B+W), B', C, (a+a'+w), 1Pu, b', Ryds., vib.
C EHEAT   ambient electron heating rate, eV cm-3 s-1
C TEZ     total energetic electron energy deposition, eV cm-3 s-1
C ECALC   electron density, calculated below 200 km, cm-3
C ZXDEN   array of excited and and/or ionized state densities:
C           O+(2P), O+(2D), O+(4S), N+, N2+, O2+, NO+, N2(A), N(2P),
C           N(2D), O(1S), O(1D), 8 spares, at each altitude; cm-3
C ZETA    array of volume emission rates:
C           3371A, 4278A, 5200A, 5577A, 6300A, 7320A, 10400A, 3466A,
C           7774A, 8446A, 3726A, 9 spares; cm-3 s-1
C ZCETA   array of contributions to each v.e.r at each alt; cm-3 s-1
C VCB     array of vertical column brightnesses (as above); Rayleighs
C
C Array dimensions:
C JMAX    number of altitude levels
C NBINS   number of energetic electron energy bins
C LMAX    number of wavelength intervals for solar flux
C NMAJ    number of major species
C NEX     number of ionized/excited species
C NW      number of airglow emission wavelengths
C NC      number of component production terms for each emission
C NST     number of states produced by photoionization/dissociation
C NEI     number of states produced by electron impact
C NF      obsolete
C
C
      SUBROUTINE GLOW(PRATE,LRATE)
!      use cglow,only: nmaj,nex,nw,nc,nst,nei,nf,jmax,nbins,lmax,pi
      implicit none
      include 'cglow.h'

      real, intent(out) :: PRATE(NEX,JMAX), LRATE(NEX,JMAX)

      integer IDATE, ISCALE, JLOCAL, KCHEM, IERR,
     &   i,iei,ist,j,n
      real  UT, GLAT, GLONG,
     >    F107, F107A, HLYBR, FEXVIR, HLYA, HEIEW, XUVFAC,
     >    ZZ(JMAX), ZO(JMAX), ZN2(JMAX), ZO2(JMAX), ZNO(JMAX),
     >    ZNS(JMAX), ZND(JMAX), ZRHO(JMAX), ZE(JMAX),
     >    ZTN(JMAX), ZTI(JMAX), ZTE(JMAX),
     >    PHITOP(NBINS), EFLUX(NF), EZERO(NF),
     >    SZA, DIP, EFRAC,
     >    ZMAJ(NMAJ,JMAX), ZCOL(NMAJ,JMAX),
     >    WAVE1(LMAX), WAVE2(LMAX), SFLUX(LMAX),
     >    ENER(NBINS), DEL(NBINS),
     >    PESPEC(NBINS,JMAX), SESPEC(NBINS,JMAX),
     >    PHOTOI(NST,NMAJ,JMAX), PHOTOD(NST,NMAJ,JMAX), PHONO(NST,JMAX),
     >    QTI(JMAX), AURI(NMAJ,JMAX), PIA(NMAJ,JMAX), SION(NMAJ,JMAX),
     >    UFLX(NBINS,JMAX), DFLX(NBINS,JMAX), AGLW(NEI,NMAJ,JMAX),
     >    EHEAT(JMAX), TEZ(JMAX), ECALC(JMAX),
     >    ZXDEN(NEX,JMAX), ZETA(NW,JMAX), ZCETA(NC,NW,JMAX), VCB(NW)

      COMMON /CGLOW/ IDATE, UT, GLAT, GLONG, ISCALE, JLOCAL, KCHEM,
     >    F107, F107A, HLYBR, FEXVIR, HLYA, HEIEW, XUVFAC,
     >    ZZ, ZO, ZN2, ZO2, ZNO, ZNS, ZND, ZRHO, ZE,
     >    ZTN, ZTI, ZTE, PHITOP, EFLUX, EZERO, SZA, DIP, EFRAC, IERR,
     >    ZMAJ, ZCOL, WAVE1, WAVE2, SFLUX, ENER, DEL, PESPEC, SESPEC,
     >    PHOTOI, PHOTOD, PHONO, QTI, AURI, PIA, SION,
     >    UFLX, DFLX, AGLW, EHEAT, TEZ, ECALC, ZXDEN, ZETA, ZCETA, VCB
C
      real ZVCD(NMAJ,JMAX),dec,ff,sdip,teflux,xf,yf,zf
C
!      Integer :: IFIRST=1
C
C
C First call only: set up energy grid:  NOT NEEDED M.H. Aug 2015
C
!      IF (IFIRST .EQ. 1) THEN
!        IFIRST = 0
!        CALL EGRID (ENER, DEL)
!      ENDIF
C
C
C Find magnetic dip angle and solar zenith angle (radians):
C
      CALL FIELDM (GLAT, GLONG, 300., XF, YF, ZF, FF, DIP, DEC, SDIP)
      DIP = ABS(DIP) * PI/180.

      CALL SOLZEN (IDATE, UT, GLAT, GLONG, SZA)
      SZA = SZA * PI/180.
C
C
C Scale solar flux:
C
        CALL SSFLUX (ISCALE, F107, F107A, HLYBR, FEXVIR, HLYA,
     >               HEIEW, XUVFAC, WAVE1, WAVE2, SFLUX)
C
C
C Pack major species density array:
C
      DO J=1,JMAX
        ZMAJ(1,J) = ZO(J)
        ZMAJ(2,J) = ZO2(J)
        ZMAJ(3,J) = ZN2(J)
        if (isnan(zmaj(1,j)).or.isnan(zmaj(2,j)) .or. isnan(zmaj(3,j)))
     >  stop 'glow.f: NaN in ZMAJ'
      End do
C
C Calculate slant path column densities of major species in the
C direction of the sun:
C
        CALL RCOLUM (SZA, ZZ, ZMAJ, ZTN, ZCOL, ZVCD)
C
C
C Call subroutine EPHOTO to calculate the photoelectron production
C spectrum and photoionization rates as a function of altitude,
C unless all altitudes are dark, in which case zero arrays:
C
      IF (SZA .LT. 2.) THEN
        CALL EPHOTO
      ELSE
        DO 240 J=1,JMAX
          DO 200 I=1,NMAJ
          DO 200 IST=1,NST
            PHOTOI(IST,I,J) = 0.0
            PHOTOD(IST,I,J) = 0.0
  200     CONTINUE
          DO 210 IST=1,NST
            PHONO(IST,J) = 0.0
  210     CONTINUE
          DO 220 N=1,NBINS
            PESPEC(N,J) = 0.0
  220     CONTINUE
  240   CONTINUE
      ENDIF
C
C
C Zero obsolete auroral primary and secondary arrays:
C
      DO 255 J=1,JMAX
        DO 245 I=1,NMAJ
          PIA(I,J) = 0.0
  245   CONTINUE
        DO N=1,NBINS
          SESPEC(N,J) = 0.0
        end do
  255 CONTINUE

C Add background ionization to photoionization:
C
      CALL QBACK (ZMAJ, ZNO, ZVCD, PHOTOI, PHONO)
C
C
C Call subroutine ETRANS to calculate photoelectron and auroral
C electron transport and electron impact excitation rates, unless
C there are no energetic electrons, in which case zero arrays:
C
      TEFLUX = 0.
      DO N=1,NBINS
        TEFLUX = TEFLUX + PHITOP(N)
      end do
C
      IF (TEFLUX.GT.0.001 .OR. SZA.LT.2.) THEN
        CALL ETRANS
      ELSE
        DO 350 J=1,JMAX
          DO 320 N=1,NBINS
            UFLX(N,J) = 0.0
            DFLX(N,J) = 0.0
  320     CONTINUE
          DO 340 I=1,NMAJ
            SION(I,J) = 0.0
            DO 340 IEI=1,NEI
              AGLW(IEI,I,J) = 0.0
  340     CONTINUE
          EHEAT(J) = 0.0
          TEZ(J) = 0.0
  350   CONTINUE
        EFRAC = 0.0
        IERR = 0
      ENDIF
C
C
C Call subroutine GCHEM to calculate the densities of excited and
C ionized consituents, airglow emission rates, and vertical column
C brightnesses:
C
      CALL GCHEM(PRATE,LRATE)

      END Subroutine GLOW

! Subroutine SNOEM calculates nitric oxide zonal mean altitude profile
! as function of magnetic latitude for specified day of year, Kp, and F10.7.

! The NOEM empirical model is based on data from the SNOE ultraviolet
! spectrometer during 1998-2000, using empirical orthogonal function analysis.
! Altitude range is from 100 to 150 km.

! Marsh et al., JGR, 109, A07301, doi:10.1029/2003JA010199, 2004.

! Adapted by Stan Solomon, 5/14, from IDL and F90 code supplied by Dan Marsh.

      subroutine snoem(doy, kp, f107, z, mlat, nozm)
!      use cglow,only: pi
      implicit none
      include 'cglow.h'

!Args:
      integer,intent(in)   :: doy
      real,intent(in)  :: kp, f107
      real,intent(out) :: z(16), mlat(33), nozm(33,16)
! Local:
      real no_mean(33,16), eofs(33,16,3)
      real theta0         ! day number in degrees
      real dec            ! solar declination angle
      real m1, m2, m3     ! coefficients for first 3 eofs
      integer j, k, n

      real cosd, sind,thet
      sind(thet) = sin(thet/180.*pi)
      cosd(thet) = cos(thet*pi/180.)

!      integer :: ifirst=1
!      IFIRST MUST BE DISABLED OR UNINITIALIZED VALUES
!        MAY BE USED DEPENDING ON COMPILER (GFORTRAN/F2PY)

!... read eof file
!      if (ifirst .eq. 1) then
!        ifirst = 0
        open(unit=1,file='snoem_eof.dat',status='old')
            read(1,*) (z(k),k=1,16)
            read(1,*) (mlat(j),j=1,33)
            read(1,*) ((no_mean(j,k),j=1,33),k=1,16)
            read(1,*) (((eofs(j,k,n),j=1,33),k=1,16),n=1,3)
        close(unit=1)
!      endif

!... calculate coefficients (m1 to m3) for eofs based on geophysical parameters
!... eof1 - kp

      m1 =  kp * 0.689254 - 1.53366

!... eof2 - declination

      theta0 = 360. * real(doy - 1) / 365.

      dec = 0.006918
     &    - 0.399912 * cosd(theta0)   + 0.070257 * sind(theta0)
     &    - 0.006758 * cosd(2*theta0) + 0.000907 * sind(2*theta0)
     &    - 0.002697 * cosd(3*theta0) + 0.001480 * sind(3*theta0)

      dec = dec * 180./pi

      m2 = -0.31978
     $   + dec    * 0.097309
     $   + dec**2 * 0.00048979
     $   - dec**3 * 0.00010360

!... eof3 - f107

      m3 =  log10(f107) * 6.35777 - 13.8163

!... zonal mean distrib. is sum of mean and eofs

      do k=1,16
        do j=1,33
          nozm(j,k) = no_mean(j,k)
     $              - m1 * eofs(j,k,1)
     $              + m2 * eofs(j,k,2)
     $              - m3 * eofs(j,k,3)
        end do
      end do

      End subroutine snoem

C Subroutine EPHOTO
C
C This software is part of the GLOW model.  Use is governed by the Open Source
C Academic Research License Agreement contained in the file glowlicense.txt.
C For more information see the file glow.txt.
C
C Adapted from Banks & Nagy 2-stream input code by Stan Solomon, 6/88
C Modified to handle Auger electrons, Stan Solomon, 7/90
C Reads cross sectons from files (for 1-nm bins), Scott Bailey, ~1994
C Modified bin structure, fixed CIII problem, Stan Solomon, 12/2000
C Corrected additional Auger problem, Liying Qian, 11/2002
C Converged above three branches, Stan Solomon, 3/2005
C Removed LIMIN, wavelength loop now runs from 1 to LMAX, SCS, 3/2005
C
C This subroutine calculates photoionization, rates, certain
C photodissociative excitation rates, and the photoelectron production
C spectrum as a function of altitude.  Uses continuously variable energy
C grid.  3 major species: O, O2, N2; NO is treated as a minor (non-
C absorbing) specie.
C
C Supplied by calling routine:
C WAVE1   wavelength array, upper bound; Angstroms
C WAVE2   wavelength array, lower bound; Angstroms
C SFLUX   solar flux array; photons cm-2 sec-1
C ZZ      altitude array; cm above earth
C ZMAJ    density array for species O, O2, N2, altitude; cm-3
C ZNO     density of NO at each altitude; cm-3
C ZCOL    slant column density for species O, O2, N2, altitude; cm-2
C ENER    energy grid for photoelectrons; eV
C DEL     array of energy grid increments; eV
C
C Calculated by subroutine:
C PESPEC  photoelectron production spectrum for each altitude; cm-3 s-1
C PHOTOI  photoionization rates for state, species, altitude; cm-3 s-1
C PHOTOD  photodissoc./exc. rates for state, species, alt.; cm-3 s-1
C PHONO   photoionization/dissoc./exc. rates for NO; cm-3 s-1
C
C Other definitions:
C DSPECT  ionization rate in particular wavelength bin; cm-3 s-1
C TAU     optical depth, dimensionless
C FLUX    solar flux at altitude; cm-2 s-1
C SIGABS  photoabsorption cross sections, O, O2, N2; cm2
C SIGION  photoionization cross sections, O, O2, N2; cm2
C SIGAO, SIGAO2, SIGAN2, SIGIO, SIGIO2, SIGIN2; cross sect. data arrays
C NNN     number of states for each species
C TPOT    ionization potentials for each species, state; eV
C PROB    branching ratios for each state, species, and wavelength bin:
C         O+ states: 4S, 2Do, 2Po, 4Pe, 2Pe
C         O2+ states: X, a+A, b, dissoc.
C         N2+ states: X, A, B, C, F, dissoc.
C PROBO, PROBO2, PROBN2; branching ratio data arrays
C BSO2    yield of O(1S) from dissociation of O2
C EPSIL1  energy loss lower bound for state, species, wavelength; eV
C EPSIL2  energy loss upper bound for state, species, wavelength; eV
C SIGNO   NO photoionization xsect at Ly-alpha
C AUGE    Mean energy of Auger electrons for each species; eV
C AUGL    Wavelength threshold for Auger electrons; Angstroms
C
C Array dimensions:
C JMAX    number of altitude levels
C NBINS   number of energetic electron energy bins
C LMAX    number of wavelength intervals for solar flux
C NMAJ    number of major species
C NEX     number of ionized/excited species
C NW      number of airglow emission wavelengths
C NC      number of component production terms for each emission
C NST     number of states produced by photoionization/dissociation
C NEI     number of states produced by electron impact
C NF      number of available types of auroral fluxes
C
C
      SUBROUTINE EPHOTO
!      use cglow,only: nmaj,nex,nw,nc,nst,nei,nf,jmax,lmax,nbins
      implicit none
      include 'cglow.h'

      integer idate, iscale,ierr,i,j,jlocal,k,kchem,l,m,m1,m2,n,
     &   NNN(NMAJ)
      real  UT, GLAT, GLONG,
     >    F107, F107A, HLYBR, FEXVIR, HLYA, HEIEW, XUVFAC,
     >    ZZ(JMAX), ZO(JMAX), ZN2(JMAX), ZO2(JMAX), ZNO(JMAX),
     >    ZNS(JMAX), ZND(JMAX), ZRHO(JMAX), ZE(JMAX),
     >    ZTN(JMAX), ZTI(JMAX), ZTE(JMAX),
     >    PHITOP(NBINS), EFLUX(NF), EZERO(NF),
     >    SZA, DIP, EFRAC,
     >    ZMAJ(NMAJ,JMAX), ZCOL(NMAJ,JMAX),
     >    WAVE1(LMAX), WAVE2(LMAX), SFLUX(LMAX),
     >    ENER(NBINS), DEL(NBINS),
     >    PESPEC(NBINS,JMAX), SESPEC(NBINS,JMAX),
     >    PHOTOI(NST,NMAJ,JMAX), PHOTOD(NST,NMAJ,JMAX), PHONO(NST,JMAX),
     >    QTI(JMAX), AURI(NMAJ,JMAX), PIA(NMAJ,JMAX), SION(NMAJ,JMAX),
     >    UFLX(NBINS,JMAX), DFLX(NBINS,JMAX), AGLW(NEI,NMAJ,JMAX),
     >    EHEAT(JMAX), TEZ(JMAX), ECALC(JMAX),
     >    ZXDEN(NEX,JMAX), ZETA(NW,JMAX), ZCETA(NC,NW,JMAX), VCB(NW)

      real DSPECT(JMAX), FLUX(LMAX,JMAX),
     >          SIGION(NMAJ,LMAX), SIGABS(NMAJ,LMAX),
     >          TPOT(NST,NMAJ), PROB(NST,NMAJ,LMAX),
     >          EPSIL1(NST,NMAJ,LMAX), EPSIL2(NST,NMAJ,LMAX),
     >          SIGAO(LMAX), SIGAO2(LMAX), SIGAN2(LMAX),
     >          SIGIO(LMAX), SIGIO2(LMAX), SIGIN2(LMAX),
     >          PROBO(NST,LMAX), PROBO2(NST,LMAX), PROBN2(NST,LMAX),
     >          BSO2(LMAX), AUGE(NMAJ), AUGL(NMAJ), TAU(LMAX),
     >          RION(LMAX,NMAJ,JMAX),  aa, bb, e1, e2, fac,r1,r2,y

      COMMON /CGLOW/ IDATE, UT, GLAT, GLONG, ISCALE, JLOCAL, KCHEM,
     >    F107, F107A, HLYBR, FEXVIR, HLYA, HEIEW, XUVFAC,
     >    ZZ, ZO, ZN2, ZO2, ZNO, ZNS, ZND, ZRHO, ZE,
     >    ZTN, ZTI, ZTE, PHITOP, EFLUX, EZERO, SZA, DIP, EFRAC, IERR,
     >    ZMAJ, ZCOL, WAVE1, WAVE2, SFLUX, ENER, DEL, PESPEC, SESPEC,
     >    PHOTOI, PHOTOD, PHONO, QTI, AURI, PIA, SION,
     >    UFLX, DFLX, AGLW, EHEAT, TEZ, ECALC, ZXDEN, ZETA, ZCETA, VCB

      SAVE SIGION, SIGABS, PROB, EPSIL1, EPSIL2

      real,parameter :: SIGNO=2.0E-18

      integer :: IFIRST=1

      DATA NNN/5,4,6/

      DATA TPOT/13.61, 16.93, 18.63, 28.50, 40.00,  0.00,
     >          12.07, 16.10, 18.20, 20.00,  0.00,  0.00,
     >          15.60, 16.70, 18.80, 30.00, 34.80, 25.00/

      DATA BSO2/12*0.,.01,.03,7*.10,8*.07,5*.03,5*.01,84*0./

      DATA AUGE/500., 500., 360./, AUGL/24., 24., 33./


C NB - absorption and ionization cross sections are multiplied by 1.E-18
C on first call.
C
C
C First time only: Read cross section data from files, convert to cm2,
C calculate energy losses:
C
      IF (IFIRST .EQ. 1) THEN
      IFIRST = 0

      open(unit=1,file='ephoto_xn2.dat',status='old')
      read(1,*)
      read(1,*)
      read(1,*)
      read(1,*)
      do 3,l=lmax,1,-1
         read(1,*) aa,bb,(probn2(n,l),n=1,nst),sigin2(l),sigan2(l)
         bso2(l)=0.0
 3       continue
      close(1)
C
      open(unit=1,file='ephoto_xo2.dat',status='old')
      read(1,*)
      read(1,*)
      read(1,*)
      read(1,*)
      do 4,l=lmax,1,-1
         read(1,*) aa,bb,(probo2(n,l),n=1,nst),sigio2(l),sigao2(l)
 4    continue
      close(1)
C
      open(unit=1,file='ephoto_xo.dat',status='old')
      read(1,*)
      read(1,*)
      read(1,*)
      read(1,*)
      do 5,l=lmax,1,-1
         read(1,*) aa,bb,(probo(n,l),n=1,nst),sigio(l),sigao(l)
 5       continue
      close(1)
C
        DO 10 L=1,LMAX
        SIGABS(1,L) = SIGAO(L)  * 1.E-18
        SIGABS(2,L) = SIGAO2(L) * 1.E-18
        SIGABS(3,L) = SIGAN2(L) * 1.E-18
        SIGION(1,L) = SIGIO(L)  * 1.E-18
        SIGION(2,L) = SIGIO2(L) * 1.E-18
        SIGION(3,L) = SIGIN2(L) * 1.E-18
   10   CONTINUE
C
        DO 20 L=1,LMAX
        DO 20 K=1,NST
        PROB(K,1,L) = PROBO(K,L)
        PROB(K,2,L) = PROBO2(K,L)
        PROB(K,3,L) = PROBN2(K,L)
   20   CONTINUE
C
        DO 40 L=1,LMAX
        DO 40 I=1,NMAJ
        DO 40 K=1,NNN(I)
        EPSIL1(K,I,L)=12397.7/WAVE1(L)-TPOT(K,I)
        EPSIL2(K,I,L)=12397.7/WAVE2(L)-TPOT(K,I)
        IF (WAVE1(L) .LE. AUGL(I)) THEN
          EPSIL1(K,I,L) = EPSIL1(K,I,L) - AUGE(I)
          EPSIL2(K,I,L) = EPSIL2(K,I,L) - AUGE(I)
        ENDIF
   40   CONTINUE
C
      END IF !ifirst
C
C
C Zero arrays:
C
      DO 100 J=1,JMAX
      DO 50 I=1,NMAJ
      DO 50 K=1,NST
      PHONO(K,J) = 0.
      PHOTOI(K,I,J) = 0.
      PHOTOD(K,I,J) = 0.
   50 CONTINUE
      DO 60 M=1,NBINS
      PESPEC(M,J) = 0.
   60 CONTINUE
  100 CONTINUE
C
C
C Calculate attenuated solar flux at all altitudes and wavelengths:
C
      DO 200 L=1,LMAX
      DO 200 J=1,JMAX
      TAU(L)=0.
      DO 150 I=1,NMAJ
      TAU(L)=TAU(L)+SIGABS(I,L)*ZCOL(I,J)
  150 CONTINUE
      IF (TAU(L) .LT. 20.) THEN
        FLUX(L,J)=SFLUX(L)*EXP(-TAU(L))
      ELSE
        FLUX(L,J) = 0.0
      ENDIF
C
C
C Calculate SRC photodissociation of O2, dissociative excitation of
C O(1S), photodissociation of N2, and photoionization of NO by solar
C Ly-alpha:
C
      IF (WAVE1(L) .LT. 1751. AND. WAVE2(L) .GT. 1349.)
     >   PHOTOD(1,2,J) = PHOTOD(1,2,J)+ZMAJ(2,J)*SIGABS(2,L)*FLUX(L,J)
      PHOTOD(2,2,J) = PHOTOD(2,2,J) + ZMAJ(2,J)*SIGABS(2,L)*FLUX(L,J)
     >                                * BSO2(L)
      PHOTOD(1,3,J) = PHOTOD(1,3,J) +
     >                ZMAJ(3,J)*(SIGABS(3,L)-SIGION(3,L))*FLUX(L,J)
      IF (WAVE1(L) .LT. 1221. .AND. WAVE2(L) .GT. 1209.)
     >   PHONO(1,J) = PHONO(1,J) + ZNO(J)*SIGNO*FLUX(L,J)
  200 CONTINUE
C
C
C
C Calculate ionization rates and photoelectron production:
C
C
C Loop over wavelengths:
C
      DO 400 L=1,LMAX
C
C
C Loop over species:
C
      DO 350 I=1,NMAJ
C
C
C Calculate total ionization rates for all species and altitudes:
C
      DO 320 J=1,JMAX
        RION(L,I,J)=ZMAJ(I,J)*SIGION(I,L)*FLUX(L,J)
  320 CONTINUE
C
C
C Loop over states:
C
      DO 300 K=1,NNN(I)
C
      E1= EPSIL1(K,I,L)
      E2= EPSIL2(K,I,L)
      IF (E2 .LT. 0.) GO TO 300
      IF (E1 .LT. 0.) E1=0.
C
C
C Calculate state-specific ionization rates at all altitudes:
C
      DO 220 J=1,JMAX
        DSPECT(J) = RION(L,I,J)*PROB(K,I,L)
        PHOTOI(K,I,J) = PHOTOI(K,I,J) + DSPECT(J)
  220 CONTINUE
C
C
C Find box numbers M1, M2 corresponding to energies E1, E2:
C
      CALL BOXNUM (E1, E2, M1, M2, R1, R2, DEL, ENER)
      IF (M1 .GT. NBINS) GOTO 300
C
C
C Fill the boxes from M1 to M2 at all altitudes:
C
      Y = E2 - E1
      DO 280 N=M1,M2
      IF (M1 .EQ. M2) THEN
        FAC = 1.
      ELSE
        IF (N .EQ. M1) THEN
          FAC = (R1-E1) / Y
        ELSE
          IF (N .EQ. M2) THEN
            FAC = (E2-R2) / Y
          ELSE
            FAC = DEL(N) / Y
          ENDIF
        ENDIF
      ENDIF
        DO 250 J=1,JMAX
          PESPEC(N,J) = PESPEC(N,J) + DSPECT(J) * FAC
  250   CONTINUE
  280 CONTINUE
C
  300 CONTINUE
C
C
C Generate Auger electrons if energy is sufficient:
C
      IF (WAVE1(L) .LE. AUGL(I)) THEN
        E1 = AUGE(I)
        E2 = AUGE(I)
        CALL BOXNUM (E1, E2, M1, M2, R1, R2, DEL, ENER)
        IF (M1.GT.NBINS .OR. M2.GT.NBINS) GOTO 350
        DO 330 J=1,JMAX
          PESPEC(M1,J) = PESPEC(M1,J) + RION(L,I,J)
  330   CONTINUE
      ENDIF
C
C
  350 CONTINUE
C
  400 CONTINUE

      END SUBROUTINE EPHOTO
!-----------------------------------------------------------------------
      SUBROUTINE BOXNUM (E1, E2, M1, M2, R1, R2, DEL, ENER)
!      use cglow,only: nbins
      implicit none
      include 'cglow.h'
C This subroutine finds the box numbers corresponding to
C energies E1 and E2, and calls them M1 and M2
C
C R1 is the upper edge of the lower box, R2 is the lower edge of the
C upper box.
! Args:
      Real,Intent(in)    :: DEL(NBINS), ENER(NBINS)
      Real,Intent(out)   :: E1,E2,R1,R2
      Integer,Intent(out):: M1,M2
!Local:
      Integer I

      DO 100 I=1,NBINS
      IF (E1 .LT. ENER(I)+DEL(I)/2.) GOTO 200
  100 CONTINUE

      M1 = NBINS+1
      RETURN
C
  200 M1 = I
      R1 = ENER(I) + DEL(I)/2.
C
      DO 300 I=1,NBINS
      IF (E2 .LT. ENER(I)+DEL(I)/2.) GOTO 400
  300 CONTINUE

      M2 = NBINS
      R2 = E2 - DEL(NBINS)
      RETURN
C
  400 M2 = I
      R2 = ENER(I) - DEL(I)/2.

      END Subroutine BOXNUM

C Subroutine ETRANS
C
! M.H.: this appears to calculate electron precipitation impact outcomes on various species
C
C This software is part of the GLOW model.  Use is governed by the Open Source
C Academic Research License Agreement contained in the file glowlicense.txt.
C For more information see the file glow.txt.
C
C Banks & Nagy 2-stream electron transport code
C Adapted by Stan Solomon, 1986, 1988
C Uses variable altitude and energy grids
C LMAX obtained from glow.h, SMB, 1994
C Updated comments and removed artifacts, SCS, 2005
C
C Subroutine EXSECT called first time only to calculate electron impact
C cross sections.
C
C Definitions:
C COMMON /CGLOW/:  see subroutine GLOW
C COMMON /CXSECT/: see subroutine EXSECT
C COMMON /CXPARS/: see subroutine EXSECT
C PSI    first term of parabolic d.e., = 1
C ALPHA  second term "; cm-1
C BETA   third term  "; cm-2
C GAMA  forth term  "; cm-4 s-1 eV-1
C DELZ   altitude increments; cm
C DEL2   sum of altitude increment and next higher increment; cm
C DELA   average of "
C DELP   product of DELA and next higher DELZ
C DELM   product of DELA and DELZ
C DELS   product of DELZ and next higer DELZ
C DEN    dummy array for transfer of calculated downward flux
C FAC    factor for extrapolating production rate, = 0
C PROD   sum of photo- and secondary electron production; cm-3 s-1 eV-1
C EPROD  energy of "; eV cm-3
C T1     elastic collision term; cm-1
C T2     elastic + inelastic collision term; cm-1
C TSA    total energy loss cross section for each species; cm2
C PRODUP upward   cascade + secondary production; cm-3 s-1 eV-1
C PRODWN downward cascade + secondary production; cm-3 s-1 eV-1
C PHIUP  upward   flux; cm-2 s-1 eV-1
C PHIDWN downward flux; cm-2 s-1 eV-1
C TSIGNE thermal electron collision term; cm-1
C SECION total ionization rate; cm-3 s-1
C SECP   secondary electron production; cm-3 s-1 eV-1
C R1     ratio term for calculating upward flux; cm-2 s-1 eV-1
C EXPT2  exponential term for calculating upward flux
C PRODUA collection array for calculating PRODUP; cm-3 s-1 eV-1
C PRODDA  "                               PRODWN
C PHIINF downward flux at top of atmos., divided by AVMU; cm-2 s-1 eV-1
C POTION ionizaition potential for each species; eV
C AVMU   cosine of the average pitch angle
C
C Array dimensions:
C JMAX    number of altitude levels
C NBINS   number of energetic electron energy bins
C LMAX    number of wavelength intervals for solar flux
C NMAJ    number of major species
C NEX     number of ionized/excited species
C NW      number of airglow emission wavelengths
C NC      number of component production terms for each emission
C NST     number of states produced by photoionization/dissociation
C NEI     number of states produced by electron impact
C NF      number of available types of auroral fluxes
C
C
      SUBROUTINE ETRANS
!      use cglow, only: nmaj,jmax,nw,nst,nbins,nei,nf,lmax,nc,nex
! *************************
! TODO using "implicit none" causes this file to give error with f2py/f2py3
!constructing wrapper function "aurora"...
!         pyion,pyecalc,pypi,pysi,pyisr = aurora(z,pyidate,pyut,pyglat,pyglong,pyf107a,pyf107,pyf107p,pyap,pyphitop)
!{}
!analyzevars: charselector={'len': '4'} unhandled.analyzevars: charselector={'len': '4'} unhandled.analyzevars: charselector={'len': '4'} unhandled.getctype: No C-type found in "{}", assuming void.
!
! issue with common block? Leave it alone till Stan has new F90 code available.
! ************************

      use, intrinsic :: iso_fortran_env, only : stdout=>output_unit, 
     &                                          stderr=>error_unit
!      implicit none
      INCLUDE 'cglow.h'

      logical isfinite

      integer  IDATE, ISCALE, JLOCAL, KCHEM, IERR, IIMAXX(NBINS)

      real   UT, GLAT, GLONG,
     >    F107, F107A, HLYBR, FEXVIR, HLYA, HEIEW, XUVFAC,
     >    ZZ(JMAX), ZO(JMAX), ZN2(JMAX), ZO2(JMAX), ZNO(JMAX),
     >    ZNS(JMAX), ZND(JMAX), ZRHO(JMAX), ZE(JMAX),
     >    ZTN(JMAX), ZTI(JMAX), ZTE(JMAX),
     >    PHITOP(NBINS), EFLUX(NF), EZERO(NF),
     >    SZA, DIP, EFRAC,
     >    ZMAJ(NMAJ,JMAX), ZCOL(NMAJ,JMAX),
     >    WAVE1(LMAX), WAVE2(LMAX), SFLUX(LMAX),
     >    ENER(NBINS), DEL(NBINS),
     >    PESPEC(NBINS,JMAX), SESPEC(NBINS,JMAX),
     >    PHOTOI(NST,NMAJ,JMAX), PHOTOD(NST,NMAJ,JMAX), PHONO(NST,JMAX),
     >    QTI(JMAX), AURI(NMAJ,JMAX), PIA(NMAJ,JMAX), SION(NMAJ,JMAX),
     >    UFLX(NBINS,JMAX), DFLX(NBINS,JMAX), AGLW(NEI,NMAJ,JMAX),
     >    EHEAT(JMAX), TEZ(JMAX), ECALC(JMAX),
     >    ZXDEN(NEX,JMAX), ZETA(NW,JMAX), ZCETA(NC,NW,JMAX), VCB(NW),
     &    SIGS(NMAJ,NBINS), PE(NMAJ,NBINS), PIN(NMAJ,NBINS),
     >                SIGA(NMAJ,NBINS,NBINS), SEC(NMAJ,NBINS,NBINS),
     >                SIGEX(NEI,NMAJ,NBINS), SIGIX(NEI,NMAJ,NBINS),
     &    WW(NEI,NMAJ), AO(NEI,NMAJ), OMEG(NEI,NMAJ),
     >                ANU(NEI,NMAJ), BB(NEI,NMAJ), AUTO(NEI,NMAJ),
     >                THI(NEI,NMAJ),  AK(NEI,NMAJ),   AJ(NEI,NMAJ),
     >                TS(NEI,NMAJ),   TA(NEI,NMAJ),   TB(NEI,NMAJ),
     >                GAMS(NEI,NMAJ), GAMB(NEI,NMAJ),
     &    ALPHA(JMAX), BETA(JMAX), GAMA(JMAX), PSI(JMAX),
     >                DELZ(JMAX), DEL2(JMAX), DELA(JMAX), DELP(JMAX),
     >                DELM(JMAX), DELS(JMAX), DEN(JMAX), FAC

      real    PROD(JMAX), EPROD(JMAX), T1(JMAX), T2(JMAX), TSA(NMAJ),
     >          PRODUP(JMAX,NBINS), PRODWN(JMAX,NBINS),
     >          PHIUP(JMAX), PHIDWN(JMAX), TSIGNE(JMAX), TAUE(JMAX),
     >          SECION(JMAX), SECP(NMAJ,JMAX), R1(JMAX), EXPT2(JMAX),
     >          PRODUA(JMAX), PRODDA(JMAX), PHIINF(NBINS)

      real  APROD,DAG,EDEP,EET,ein,eout,epe,ephi,et,fluxj,phiout,
     &     rmusin, sindip
      integer  i,ib,ibb,ii,im,iq,iv,j,jj,jjj4,k,kk,ll,n

      COMMON /CGLOW/ IDATE, UT, GLAT, GLONG, ISCALE, JLOCAL, KCHEM,
     >    F107, F107A, HLYBR, FEXVIR, HLYA, HEIEW, XUVFAC,
     >    ZZ, ZO, ZN2, ZO2, ZNO, ZNS, ZND, ZRHO, ZE,
     >    ZTN, ZTI, ZTE, PHITOP, EFLUX, EZERO, SZA, DIP, EFRAC, IERR,
     >    ZMAJ, ZCOL, WAVE1, WAVE2, SFLUX, ENER, DEL, PESPEC, SESPEC,
     >    PHOTOI, PHOTOD, PHONO, QTI, AURI, PIA, SION,
     >    UFLX, DFLX, AGLW, EHEAT, TEZ, ECALC, ZXDEN, ZETA, ZCETA, VCB


      COMMON /CXSECT/ SIGS, PE, PIN, SIGA, SEC, SIGEX, SIGIX, IIMAXX

      COMMON /CXPARS/ WW, AO, OMEG, ANU, BB, AUTO,THI, AK, AJ,
     >                TS, TA, TB, GAMS, GAMB

      COMMON /CIMPIT/ ALPHA, BETA, GAMA, PSI,DELZ, DEL2, DELA, DELP,
     >                DELM, DELS, DEN, FAC

      integer :: IFIRST=1
      real,parameter :: AVMU=0.5

      real potion(nmaj)
      DATA POTION/16.,16.,18./

      IERR = 0
      FAC = 0.
      SINDIP = SIN(DIP)
      RMUSIN = 1. / SINDIP / AVMU

C First call only:  calculate cross-sectons:

      IF (IFIRST .EQ. 1) THEN
        CALL EXSECT (ENER, DEL)
        IFIRST = 0
      ENDIF
C
C
C Zero variables:
C
      DO 100 II=1,JMAX
        DO 100 IB=1,NMAJ
          DO 100 IBB=1,NEI
            AGLW(IBB,IB,II) = 0.0
  100 CONTINUE
C
      PSI(1)   = 1.
      ALPHA(1) = 0.
      BETA(1) = 0.
      GAMA(1) = 0.
      PHIOUT = 0.0
C
      DO I = 1, JMAX
        EHEAT(I) = 0.0
        EPROD(I) = 0.0
        SECION(I) = 0.0
        DO N = 1, NMAJ
          SION(N,I) = 0.0
        End Do
      End Do
C
      DO 500 JJ = 1, NBINS
        DO 500 I = 1, JMAX
          PRODUP(I,JJ) = 1.0E-20
          PRODWN(I,JJ) = 1.0E-20
  500 CONTINUE
C
C
C Divide downward flux at top of atmos. by average pitch angle cosine:
C
      DO  J=1,NBINS
        PHIINF(J) = PHITOP(J) / AVMU
        if(debug .and. .not.isfinite(phiinf(j)))
     &             error stop 'etrans: nonfinite PhiInf'
      End Do
C
C
C Calcualte delta z's:
C
      DELZ(1) = ZZ(2)-ZZ(1)
      DO I=2,JMAX
        DELZ(I) = ZZ(I)-ZZ(I-1)
      End Do

      DO I=1,JMAX-1
        DEL2(I) = DELZ(I)+DELZ(I+1)
        DELA(I) = DEL2(I)/2.
        DELP(I) = DELA(I)*DELZ(I+1)
        DELM(I) = DELA(I)*DELZ(I)
        DELS(I) = DELZ(I)*DELZ(I+1)
      End Do

      DEL2(JMAX) = DEL2(JMAX-1)
      DELA(JMAX) = DELA(JMAX-1)
      DELP(JMAX) = DELP(JMAX-1)
      DELM(JMAX) = DELP(JMAX-1)
      DELS(JMAX) = DELS(JMAX-1)
C
C
C
C Top of Energy loop:
C
      DO 1100 J=NBINS,1,-1
C
C
C Calculate production:
C
      DO I = 1, JMAX
          PROD(I) = (PESPEC(J,I)+SESPEC(J,I)) * RMUSIN / DEL(J)
          EPROD(I) = EPROD(I) + PROD(I) * ENER(J) * DEL(J) / RMUSIN
      End Do
C
C
C Total energy loss cross section for each species:
C
      DO 740 I = 1, NMAJ
        TSA(I) = 0.0
  740 CONTINUE
      IF (J .GT. 1) THEN
        DO 760 K = 1, J-1
          DO 760 I = 1, NMAJ
            TSA(I) = TSA(I) + SIGA(I,K,J) * (DEL(J-K)/DEL(J))
  760   CONTINUE
      ELSE
        DO I=1,NMAJ
          TSA(I) = TSA(I) + SIGA(I,1,J) + 1.E-18
        End Do
      ENDIF
C
C
C Thermal electron energy loss:
C
      JJJ4 = J - 1
      IF (J .EQ. 1) JJJ4 = 1
      DAG = ENER(J) - ENER(JJJ4)
      IF (DAG .LE. 0.0) DAG = DEL(1)
C
      DO 800 I = 1, JMAX
        ET = 8.618E-5 * ZTE(I)
        EET = ENER(J) - ET
        IF (EET .LE. 0.0) GO TO 780
        TSIGNE(I) = ((3.37E-12*ZE(I)**0.97)/(ENER(J)**0.94))
     >              * ((EET)/(ENER(J) - (0.53*ET))) ** 2.36
        GO TO 790
  780   TSIGNE(I) = 0.0
  790   CONTINUE
        TSIGNE(I) = TSIGNE(I) * RMUSIN / DAG
  800 CONTINUE
C
C
C Collision terms:
C
      DO 870 I = 1, JMAX
        T1(I) = 0.0
        T2(I) = 0.0
        DO IV = 1, NMAJ
          T1(I) = T1(I) + ZMAJ(IV,I) * SIGS(IV,J) * PE(IV,J)
          T2(I) = T2(I) + ZMAJ(IV,I) * (SIGS(IV,J)*PE(IV,J) + TSA(IV))
        End Do
        T1(I) = T1(I) * RMUSIN
        T2(I) = T2(I) * RMUSIN + TSIGNE(I)
  870 CONTINUE
C
C
C Bypass next section if local calculation was specified:
C
      IF (JLOCAL .EQ. 1) GO TO 910
C
C
C Solve parabolic d.e. by Crank-Nicholson method to find downward flux:
C
      DO I = 2, JMAX-1
        PSI(I) = 1.
        ALPHA(I) = (T1(I-1) - T1(I+1)) / (DEL2(I) * T1(I))
        BETA(I) = T2(I) * (T1(I+1) - T1(I-1)) / (T1(I) * DEL2(I))
     >            - (T2(I+1) - T2(I-1)) / DEL2(I)
     >            - T2(I)**2 + T1(I)**2
        IF (PROD(I) .LT. 1.E-30) PROD(I) = 1.E-30
        IF (PRODWN(I,J) .LT. 1.E-30) PRODWN(I,J) = 1.E-30
        GAMA(I) = (PROD(I)/2.0)
     >             * (-T1(I) - T2(I) - ALPHA(I)
     >                - (PROD(I+1) - PROD(I-1))/PROD(I)/DEL2(I))
     >             + PRODWN(I,J)
     >             * (-ALPHA(I) - T2(I)
     >                - (PRODWN(I+1,J) - PRODWN(I-1,J))
     >                   /PRODWN(I,J)/DEL2(I))
     >             - PRODUP(I,J) * T1(I)
        !if (.not.isfinite(GAMA(I))) GAMA(I) = 0. 
        if (debug .and. .not.isfinite(GAMA(I))) then
         write (stderr,*),'etrans.f: GAMA PRODWNn1 PRODWN PRODWNp1',
     &     ' PRODUP PRODn1 PROD PRODp1 T1 T2 ALPHA DEL2'
         write(stderr,*), GAMA(I),PRODWN(I-1,J),PRODWN(I,J),
     &     PRODWN(I+1,J), PRODUP(I,J),PROD(I-1),PROD(I),PROD(I+1),
     &     T1(I),T2(I),ALPHA(I), DEL2(I)
         error stop 'etran: non-finite GAMA'
        end if
      End DO

      IF (ABS(BETA(2)) .LT. 1.E-20) THEN
        BETA(2) = 1.E-20
        IERR = 2
      ENDIF
      PHIDWN(2) = GAMA(2) / BETA(2)
      DEN(1) = PHIDWN(2)
      FLUXJ = PHIINF(J)
      CALL IMPIT(FLUXJ) !computes DEN via COMMON array
      DO I = 1, JMAX
        PHIDWN(I) = DEN(I)
        if(debug .and. phidwn(i).gt.1e30) then
            write(stderr,*) 'GAMA(i), beta(i)',gama(i),beta(i)
          error stop 'etrans: very large PHIDWN (jlocal != 1)'
        endif
      End Do
C
C
C Apply lower boundary condition: PHIUP=PHIDWN.  Should be nearly zero.
C Then integrate back upward to calculate upward flux:
C
      PHIUP(1) = PHIDWN(1)
      DO 900 I = 2, JMAX
        R1(I) = (T1(I)*PHIDWN(I) + (PROD(I)+2.*PRODUP(I,J))/2.) / T2(I)
        TAUE(I) = T2(I)*DELZ(I)
        IF (TAUE(I) .GT. 60.) TAUE(I)=60.
        EXPT2(I) = EXP(-TAUE(I))
  900 CONTINUE
      DO I=2,JMAX
        PHIUP(I) = R1(I) + (PHIUP(I-1)-R1(I)) * EXPT2(I)        
        if (debug .and. .not.isfinite(phiup(i))) 
     &           error stop 'etrans: nonfinite PHIUP  (jlocal != 1)'
      End DO

      GOTO 930
C
C
C Local calculation only  (if jlocal=1):
C
  910 CONTINUE
      DO I = 1, JMAX
        IF (T2(I) .LE. T1(I)) THEN
          IERR = 1
          T2(I) = T1(I) * 1.0001
        ENDIF
        PHIUP(I) = (PROD(I)/2.0 + PRODUP(I,J)) / (T2(I) - T1(I))
        PHIDWN(I) = (PROD(I)/2.0 + PRODWN(I,J)) / (T2(I) - T1(I))
        if (debug .and. .not. isfinite(phiup(i))) 
     &       error stop 'etrans: nonfinite PHIUP  (jlocal=1)'
        if (debug .and. phidwn(i).gt.1e30) 
     &       error stop 'etrans: very large PHIDWN (jlocal=1)'
      End Do
C
  930 CONTINUE  ! if jlocal != 1
C
C
C Multiply fluxes by average pitch angle cosine and put in arrays,
C and calculate outgoing electron energy flux for conservation check:
C
      DO I=1,JMAX
        UFLX(J,I) = PHIUP(I) * AVMU
        DFLX(J,I) = PHIDWN(I) * AVMU
      End do
C
      PHIOUT = PHIOUT + PHIUP(JMAX) * DEL(J) * ENER(J)
C
C
C Cascade production:
C
      DO 990 K = 1, J-1
        LL = J - K
        DO 972 I=1,JMAX
          PRODUA(I) = 0.0
          PRODDA(I) = 0.0
  972   CONTINUE
        DO 980 N = 1, NMAJ
          DO 975 I=1,JMAX
            PRODUA(I) = PRODUA(I)
     >                  + ZMAJ(N,I) * (SIGA(N,K,J)*PIN(N,J)*PHIDWN(I)
     >                  + (1. - PIN(N,J))*SIGA(N,K,J)*PHIUP(I))
            PRODDA(I) = PRODDA(I)
     >                  + ZMAJ(N,I) * (SIGA(N,K,J)*PIN(N,J)*PHIUP(I)
     >                  + (1. - PIN(N,J))*SIGA(N,K,J)*PHIDWN(I))
  975     CONTINUE
  980   CONTINUE
        DO 985 I=1,JMAX
          PRODUP(I,LL) = PRODUP(I,LL) + PRODUA(I) * RMUSIN
          PRODWN(I,LL) = PRODWN(I,LL) + PRODDA(I) * RMUSIN
  985   CONTINUE
  990 CONTINUE
C
      KK = J - 1
      IF (KK .LE. 0) GO TO 1020
      DO 1010 I = 1, JMAX
        PRODUP(I,KK) = PRODUP(I,KK) + TSIGNE(I) * PHIUP(I) * (DEL(J)
     >                 / DEL(KK))
        PRODWN(I,KK) = PRODWN(I,KK) + TSIGNE(I) * PHIDWN(I) * (DEL(J)
     >                 / DEL(KK))
 1010 CONTINUE
 1020 CONTINUE
C
C
C Electron heating rate:
C
      DAG = DEL(J)
      DO I = 1, JMAX
        EHEAT(I) = EHEAT(I) + TSIGNE(I) * (PHIUP(I)+PHIDWN(I)) * DAG**2
      End Do
C
C
C Electron impact excitation rates:
C
      DO 1040 II = 1, JMAX
        DO 1040 I = 1, NMAJ
          DO 1040 IBB = 1, NEI
            AGLW(IBB,I,II) = AGLW(IBB,I,II) + (PHIUP(II) + PHIDWN(II))
     >                       * SIGEX(IBB,I,J) * DEL(J) * ZMAJ(I,II)
 1040 CONTINUE
C
C
C Calculate production of secondaries into K bin for energy J bin and
C add to production:
C
      DO 1090 K = 1, IIMAXX(J) ! iimaxx set near exsect.f:424
        DO 1080 N = 1, NMAJ
          DO 1070 I = 1, JMAX
            SECP(N,I) = SEC(N,K,J) * ZMAJ(N,I) * (PHIUP(I) + PHIDWN(I))
!            if (isnan(sec(n,k,j))) stop 'etrans: NaN in SEC'
!            if (isnan(zmaj(n,i))) stop 'etrans: NaN in ZMAJ'
!            if (isnan(phiup(i))) stop 'etrans: NaN in PHIUP'
            if (debug .and. phidwn(i).gt.1e30) 
     &            error stop 'etrans.f: very large PHIDWN'
            if (debug .and. .not.isfinite(secp(n,i)))
     &            error stop 'etrans: nonfinite SECP'
            SION(N,I) = SION(N,I) + SECP(N,I) * DEL(K)
            
            if (debug .and. .not.isfinite(sion(n,i)))  then
             write(stderr,*)'etrans: nonfinite impact ioniz SION.',
     &                 '  k,n,i=',k,n,i
             write(stderr,*) 'del(k)=',del(k)
             write(stderr,*) 'secp(n,i)=',secp(n,i)
             write(stderr,*) 'sion(n,i)=',sion(n,i)
            error stop
            endif

            SECION(I) = SECION(I) + SECP(N,I) * DEL(K)
            PRODUP(I,K) = PRODUP(I,K) + (SECP(N,I)*.5*RMUSIN)
            PRODWN(I,K) = PRODWN(I,K) + (SECP(N,I)*.5*RMUSIN)
 1070     CONTINUE
 1080   CONTINUE
 1090 CONTINUE
C
 1100 CONTINUE
C
C Bottom of Energy loop
C

      DO 1250 I = 1, JMAX
        EHEAT(I) = EHEAT(I) / RMUSIN
 1250 CONTINUE
C
C
C Calculate energy deposited as a function of altitude
C and total energy deposition:
C
      EDEP = 0.
      DO 1270 IM=1,JMAX
        TEZ(IM) = EHEAT(IM)
        DO 1260 II=1,NMAJ
          TEZ(IM) = TEZ(IM) + SION(II,IM)*POTION(II)
          DO 1260 IQ=1,NEI
            TEZ(IM) = TEZ(IM) + AGLW(IQ,II,IM)*WW(IQ,II)
 1260   CONTINUE
        EDEP = EDEP + TEZ(IM) * DELA(IM)
 1270 CONTINUE
C
C
C Calculate energy input, output, and fractional conservation:
C
      EPE = 0.0
      EPHI = 0.0
      DO 1440 I = 2, JMAX
        APROD = SQRT(EPROD(I)*EPROD(I - 1))
        EPE = EPE + APROD * DELZ(I)
 1440 CONTINUE
      DO JJ = 1, NBINS
        EPHI = EPHI + PHIINF(JJ) * ENER(JJ) * DEL(JJ) / RMUSIN
      End Do
      EIN = EPHI + EPE
      PHIOUT = PHIOUT / RMUSIN
      EOUT = EDEP + PHIOUT
      EFRAC = (EOUT - EIN) / EIN

      END SUBROUTINE ETRANS
C
C
C
C
C Subroutine IMPIT solves parabolic differential equation by implicit
C Crank-Nicholson method
C
      SUBROUTINE IMPIT(FLUXJ)
      use, intrinsic :: iso_fortran_env, only : stdout=>output_unit, 
     &                                          stderr=>error_unit
!      use cglow,only: jmax
      Implicit None
      include 'cglow.h'
!Args:
      Real, Intent(In) :: FLUXJ
!Local:
      logical isfinite
      Real fac,dem
      real,dimension(jmax) :: alpha, beta, gama, psi, delz, del2, dela,
     > delp,delm,dels,den,
     > K, L, A, B, C, D
      Integer i,i1,jk,kk

      COMMON /CIMPIT/ ALPHA, BETA, GAMA, PSI, DELZ, DEL2, DELA, DELP,
     >                DELM, DELS, DEN, FAC
C
      I1 = JMAX - 1

      DO I = 1, I1
        A(I) = PSI(I) / DELP(I) + ALPHA(I) / DEL2(I)
        B(I) = -2. * PSI(I) / DELS(I) + BETA(I)
        C(I) = PSI(I) / DELM(I) - ALPHA(I) / DEL2(I)
        D(I) = GAMA(I)
       if(debug .and. .not.isfinite(c(i)))
     &              error stop 'etrans:impit nonfinite C(I)'
       if(debug .and. .not.isfinite(d(i)))
     &              error stop 'etrans:impit nonfinite D(I)'
      End Do

      K(2) = (D(2) - C(2)*DEN(1)) / B(2)
      L(2) = A(2) / B(2)
      if (debug .and. .not.isfinite(k(2))) then
        write(stderr,*) '***********    **********'
        write(stderr,*) 'K(2) D(2) C(2) DEN(1) B(2)',K(2),D(2),C(2),
     &   DEN(1),B(2)
        error stop 'etrans:impit non-finite K(2)'
      end if
!      if (isnan(k(2))) stop 'etrans:impit NaN in K(2)'

      DO I = 3, I1
        DEM = B(I) - C(I) * L(I-1)
        if (debug .and. .not.isfinite(dem)) 
     &        error stop 'etrans:impit nonfinite DEM'
        K(I) = (D(I) - C(I)*K(I-1)) / DEM
        L(I) = A(I) / DEM

        if (debug .and. .not. isfinite(K(i))) then
         write(stderr,*) k
         error stop 'etrans:impit NaN in K(i)'
        end if
!        if (isnan(L(i))) stop'etrans:impit NaN in L(i)'
      End DO   

      DEN(I1) = (K(I1) - L(I1)*FLUXJ) / (1. + L(I1)*FAC)
!      if (isnan(K(i1))) stop'etrans:impit NaN in K(i1)'
!      if (isnan(L(i1))) stop'etrans:impit NaN in L(i1)'
      if(debug .and. .not.isfinite(den(i1)))
     &          error stop 'impit nonfinite DEN(I1)'
      DEN(JMAX) = DEN(I1)
      
      Do KK = 1, JMAX-3
        JK = I1 - KK
        DEN(JK) = K(JK) - L(JK) * DEN(JK + 1)
        if (debug .and. .not.isfinite(den(jk)))
     &    error stop 'etrans:impit: non-finite DEN'

      End Do

      END Subroutine IMPIT


      logical Function isfinite(x)
      implicit none

      real,intent(in) :: x

      if (abs(x) <= huge(x)) then
        isfinite = .true.
      else
        isfinite = .false.
      end if

      end function isfinite
